-----------------------------------------
-----------------------------------------
spool C:\UOC\PFC\mbernard\logs\ac2-creacio_taules_bdr.log
-----------------------------------------
-----------------------------------------

---------------------------------------------------
---------------------------------------------------
--connectat com a PFC_BDR
ALTER SESSION SET NLS_DATE_FORMAT = 'DD/MM/YYYY HH24:MI:SS';
ALTER SESSION SET NLS_TIMESTAMP_FORMAT = 'DD/MM/YYYY HH24:MI:SS';
ALTER SESSION SET NLS_TIME_FORMAT = 'HH24:MI:SS';
COMMIT;

---------------------------------------------------
--------------  CATEGORIA  ------------------------
---------------------------------------------------
--DROP TABLE categoria CASCADE CONSTRAINTS PURGE;
CREATE TABLE categoria(
      idcategoria INTEGER CONSTRAINT PK_categoria PRIMARY KEY
      , nomCategoria VARCHAR2(50) CONSTRAINT NN_categoria_nomCategoria NOT NULL
                        CONSTRAINT UN_categoria_nomCategoria UNIQUE
      , dataAlta DATE DEFAULT SYSDATE NOT NULL
      , dataBaixa DATE 
)
TABLESPACE TS_BDR;
COMMIT;

--DROP SEQUENCE seq_categoria;
CREATE SEQUENCE seq_categoria INCREMENT BY 1 START WITH 1;
COMMIT;

CREATE OR REPLACE TRIGGER inserir_idcategoria_categoria
      BEFORE INSERT ON categoria
      FOR EACH ROW
BEGIN
      SELECT seq_categoria.NEXTVAL INTO :NEW.idcategoria
      FROM DUAL;
END inserir_idcategoria_categoria;
/
COMMIT;

---------------------------------------------------
--------------  POBLACIO  ------------------------
---------------------------------------------------
--DROP TABLE poblacio CASCADE CONSTRAINTS PURGE;
CREATE TABLE poblacio(
      idpoblacio INTEGER CONSTRAINT PK_poblacio PRIMARY KEY
      , nomPoblacio VARCHAR2(50) CONSTRAINT NN_poblacio_nomPoblacio NOT NULL
                        CONSTRAINT UN_poblacio_nomPoblacio UNIQUE
      , dataAlta DATE DEFAULT SYSDATE NOT NULL
      , dataBaixa DATE 
)
TABLESPACE TS_BDR;
COMMIT;

--DROP SEQUENCE seq_poblacio;
CREATE SEQUENCE seq_poblacio INCREMENT BY 1 START WITH 1;
COMMIT;

CREATE OR REPLACE TRIGGER inserir_idpoblacio_poblacio
      BEFORE INSERT ON poblacio
      FOR EACH ROW
BEGIN
      SELECT seq_poblacio.NEXTVAL INTO :NEW.idpoblacio
      FROM DUAL;
END inserir_idpoblacio_poblacio;
/
COMMIT;

---------------------------------------------------
-----------------  CENTRE  ------------------------
---------------------------------------------------
--DROP TABLE centre CASCADE CONSTRAINTS PURGE;
CREATE TABLE centre(
      idcentre INTEGER CONSTRAINT PK_centre PRIMARY KEY
      , nomCentre VARCHAR2(50) CONSTRAINT NN_centre_nomCentre NOT NULL
                        CONSTRAINT UN_centre_nomCentre UNIQUE
      , adrea VARCHAR2(50) CONSTRAINT NN_centre_adrea NOT NULL
      , idpoblacio INTEGER CONSTRAINT FK_centre REFERENCES poblacio(idpoblacio)
							CONSTRAINT NN_centre_idpoblacio NOT NULL
      , codipostal CHAR(5) CONSTRAINT NN_centre_codipostal NOT NULL
      , telefon VARCHAR2(15) CONSTRAINT NN_centre_telefon NOT NULL
      , mail VARCHAR2(50)
      , dataAlta DATE DEFAULT SYSDATE NOT NULL
      , dataBaixa DATE       
)
TABLESPACE TS_BDR;
COMMIT;

--DROP SEQUENCE seq_centre;
CREATE SEQUENCE seq_centre INCREMENT BY 1 START WITH 1;
COMMIT;

CREATE OR REPLACE TRIGGER inserir_idcentre_centre
      BEFORE INSERT ON centre
      FOR EACH ROW
BEGIN
      SELECT seq_centre.NEXTVAL INTO :NEW.idcentre
      FROM DUAL;
END inserir_idcentre_centre;
/
COMMIT;

---------------------------------------------------
-----------------  EMPRESA  -----------------------
---------------------------------------------------
--DROP TABLE empresa CASCADE CONSTRAINTS PURGE;
CREATE TABLE empresa(
      idempresa INTEGER CONSTRAINT PK_empresa PRIMARY KEY
      , nomEmpresa VARCHAR2(50) CONSTRAINT NN_empresa_nomEmpresa NOT NULL
      , nif VARCHAR2(50) CONSTRAINT NN_empresa_nif NOT NULL
                        CONSTRAINT UN_empresa_nif UNIQUE       
      , adrea VARCHAR2(50) CONSTRAINT NN_empresa_adrea NOT NULL
      , idpoblacio INTEGER CONSTRAINT FK_empresa REFERENCES poblacio(idpoblacio)
      , codipostal CHAR(5) 
      , telefon1 VARCHAR2(15) CONSTRAINT NN_empresa_telefon1 NOT NULL
      , telefon2 VARCHAR2(15) 
      , fax VARCHAR2(15) 
      , mail VARCHAR2(50)
      , personaContacte VARCHAR2(50)
      , telefonContacte VARCHAR2(50) 
      , mailContacte VARCHAR2(50)
      , telefon24hores VARCHAR2(50)
      , dataAlta DATE DEFAULT SYSDATE NOT NULL
      , dataBaixa DATE      
)
TABLESPACE TS_BDR;
COMMIT;

--DROP SEQUENCE seq_empresa;
CREATE SEQUENCE seq_empresa INCREMENT BY 1 START WITH 1;
COMMIT;

CREATE OR REPLACE TRIGGER inserir_idempresa_empresa
      BEFORE INSERT ON empresa
      FOR EACH ROW
BEGIN
      SELECT seq_empresa.NEXTVAL INTO :NEW.idempresa
      FROM DUAL;
END inserir_idempresa_empresa;
/
COMMIT;

---------------------------------------------------
-----------------  OPERARI  -----------------------
---------------------------------------------------
--DROP TABLE operari CASCADE CONSTRAINTS PURGE;
CREATE TABLE operari(
      idoperari INTEGER CONSTRAINT PK_operari PRIMARY KEY
      , idempresa INTEGER CONSTRAINT FK_operari REFERENCES empresa(idempresa)
                      CONSTRAINT NN_operari_idempresa NOT NULL
      , codiOperari VARCHAR2(50) CONSTRAINT NN_operari_codioperari NOT NULL 
      , dataAlta DATE DEFAULT SYSDATE NOT NULL
      , dataBaixa DATE       
      , CONSTRAINT UN_operari UNIQUE (idempresa, codioperari) 
)
TABLESPACE TS_BDR;
COMMIT;

--DROP SEQUENCE seq_operari;
CREATE SEQUENCE seq_operari INCREMENT BY 1 START WITH 1;
COMMIT;

CREATE OR REPLACE TRIGGER inserir_idoperari_operari
      BEFORE INSERT ON operari
      FOR EACH ROW
BEGIN
      SELECT seq_operari.NEXTVAL INTO :NEW.idoperari
      FROM DUAL;
END inserir_idoperari_operari;
/
COMMIT;

---------------------------------------------------
-------------------  MARCA  -----------------------
---------------------------------------------------
--DROP TABLE marca CASCADE CONSTRAINTS PURGE;
CREATE TABLE marca(
      idmarca INTEGER CONSTRAINT PK_marca PRIMARY KEY
      , nomMarca VARCHAR2(50) CONSTRAINT NN_marca_nomMarca NOT NULL
                        CONSTRAINT UN_marca_nomMarca UNIQUE
      , dataAlta DATE DEFAULT SYSDATE NOT NULL
      , dataBaixa DATE  
)
TABLESPACE TS_BDR;
COMMIT;

--DROP SEQUENCE seq_marca;
CREATE SEQUENCE seq_marca INCREMENT BY 1 START WITH 1;
COMMIT;

CREATE OR REPLACE TRIGGER inserir_idmarca_marca
      BEFORE INSERT ON marca
      FOR EACH ROW
BEGIN
      SELECT seq_marca.NEXTVAL INTO :NEW.idmarca
      FROM DUAL;
END inserir_idmarca_marca;
/
COMMIT;

---------------------------------------------------
---------------  MODEL  ---------------------------
---------------------------------------------------
--DROP TABLE model CASCADE CONSTRAINTS PURGE;
CREATE TABLE model(
      idmodel INTEGER CONSTRAINT PK_model PRIMARY KEY
      , idmarca INTEGER CONSTRAINT FK1_model REFERENCES marca(idmarca)
                      CONSTRAINT NN_model_idmarca NOT NULL
      , nomModel VARCHAR2(50) CONSTRAINT NN_model_nomModel NOT NULL 
      , caracteristiques VARCHAR2(100)  
      , dataAlta DATE DEFAULT SYSDATE NOT NULL
      , dataBaixa DATE 
      , idcategoria INTEGER CONSTRAINT FK2_model REFERENCES categoria(idcategoria)
                          CONSTRAINT NN_model_idcategoria NOT NULL     
      , CONSTRAINT UN_model UNIQUE (idmarca, nomModel) 
)
TABLESPACE TS_BDR;
COMMIT;

--DROP SEQUENCE seq_model;
CREATE SEQUENCE seq_model INCREMENT BY 1 START WITH 1;
COMMIT;

CREATE OR REPLACE TRIGGER inserir_idmodel_model
      BEFORE INSERT ON model
      FOR EACH ROW
BEGIN
      SELECT seq_model.NEXTVAL INTO :NEW.idmodel
      FROM DUAL;
END inserir_idmodel_model;
/
COMMIT;

---------------------------------------------------
-------------------  EQUIP  -----------------------
---------------------------------------------------
--DROP TABLE equip CASCADE CONSTRAINTS PURGE;
CREATE TABLE equip(
      idequip INTEGER CONSTRAINT PK_equip PRIMARY KEY
      , numSerie VARCHAR2(50) CONSTRAINT NN_equip_numserie NOT NULL
      , idmodel INTEGER CONSTRAINT FK1_equip REFERENCES model(idmodel)
                          CONSTRAINT NN_equip_idmodel NOT NULL
      , idcategoria INTEGER CONSTRAINT FK2_equip REFERENCES categoria(idcategoria)
                          CONSTRAINT NN_equip_idcategoria NOT NULL
      , idcentre INTEGER CONSTRAINT FK3_equip REFERENCES centre(idcentre)  
                          CONSTRAINT NN_equip_idcentre NOT NULL    
      , descripcio VARCHAR2(50) CONSTRAINT NN_equip_descripcio NOT NULL
      , dataCompra DATE CONSTRAINT NN_equip_dataCompra NOT NULL
      , dataFiGarantia DATE CONSTRAINT NN_equip_dataFiGarantia NOT NULL
							--si no t garantia, posarem la data de compra 
      , dataAlta DATE DEFAULT SYSDATE NOT NULL
      , dataBaixa DATE
      , CONSTRAINT UN_equip UNIQUE (numserie, idmodel) 
)
TABLESPACE TS_BDR;
COMMIT;

--DROP SEQUENCE seq_equip;
CREATE SEQUENCE seq_equip INCREMENT BY 1 START WITH 1;
COMMIT;

CREATE OR REPLACE TRIGGER inserir_idequip_equip
      BEFORE INSERT ON equip
      FOR EACH ROW
BEGIN
      SELECT seq_equip.NEXTVAL INTO :NEW.idequip
      FROM DUAL;
END inserir_idequip_equip;
/
COMMIT;

---------------------------------------------------
-------------------  USUARI  --------------------
---------------------------------------------------
--DROP TABLE usuari CASCADE CONSTRAINTS PURGE;
CREATE TABLE usuari(
      idusuari INTEGER CONSTRAINT PK_usuari PRIMARY KEY
      , login VARCHAR2(50) CONSTRAINT NN_usuari_login NOT NULL
                          CONSTRAINT UN_usuari_login UNIQUE  
      , pwd VARCHAR2(50) CONSTRAINT NN_usuari_pwd NOT NULL
      , dni VARCHAR2(15) CONSTRAINT NN_usuari_dni NOT NULL
      , nom VARCHAR2(100) CONSTRAINT NN_usuari_nom NOT NULL
      , mail VARCHAR2(50) 
      , perfil VARCHAR2(50) CONSTRAINT NN_usuari_perfil NOT NULL
                            CONSTRAINT CH_usuari_perfil CHECK (perfil IN 
('ADMINISTRADOR','REFERENT','LOGISTIC','ANALISTA'))
      , dataAlta DATE DEFAULT SYSDATE NOT NULL
      , dataBaixa DATE       
)
TABLESPACE TS_BDR;
COMMIT;

--DROP SEQUENCE seq_usuari;
CREATE SEQUENCE seq_usuari INCREMENT BY 1 START WITH 1;
COMMIT;

CREATE OR REPLACE TRIGGER inserir_idusuari_usuari
      BEFORE INSERT ON usuari
      FOR EACH ROW
BEGIN
      SELECT seq_usuari.NEXTVAL INTO :NEW.idusuari
      FROM DUAL;
END inserir_idusuari_usuari;
/
COMMIT;

---------------------------------------------------
--------------  PRIORITAT  ------------------------
---------------------------------------------------
--DROP TABLE prioritat CASCADE CONSTRAINTS PURGE;
CREATE TABLE prioritat(
      idprioritat INTEGER CONSTRAINT PK_prioritat PRIMARY KEY
      , gravetat VARCHAR2(50) CONSTRAINT NN_prioritat_gravetat NOT NULL
                        CONSTRAINT UN_prioritat_gravetat UNIQUE
			CONSTRAINT CH_prioritat_gravetat CHECK (gravetat IN ('ORDINARIA','PREFERENT','URGENT'))
      , qDiesResolucio INTEGER CONSTRAINT NN_prioritat_qDiesRes NOT NULL
      , dataAlta DATE DEFAULT SYSDATE NOT NULL
      , dataBaixa DATE 
)
TABLESPACE TS_BDR;
COMMIT;

--DROP SEQUENCE seq_prioritat;
CREATE SEQUENCE seq_prioritat INCREMENT BY 1 START WITH 1;
COMMIT;

CREATE OR REPLACE TRIGGER inserir_idprioritat_prioritat
      BEFORE INSERT ON prioritat
      FOR EACH ROW
BEGIN
      SELECT seq_prioritat.NEXTVAL INTO :NEW.idprioritat
      FROM DUAL;
END inserir_idprioritat_prioritat;
/
COMMIT;

---------------------------------------------------
----------------  MANTENIMENT  --------------------
---------------------------------------------------
--DROP TABLE manteniment CASCADE CONSTRAINTS PURGE;
CREATE TABLE manteniment(
      idequip INTEGER CONSTRAINT FK_manteniment REFERENCES equip(idequip)
      , idmanteniment INTEGER 
      , tipusMant CHAR(9) CONSTRAINT NN_manteniment_tipusmant NOT NULL
                          CONSTRAINT CH_manteniment_tipusmant CHECK (tipusMant IN 
('PREVENTIU','CORRECTIU'))
      , dataAlta DATE DEFAULT SYSDATE NOT NULL
      , dataBaixa DATE 
      , CONSTRAINT PK_manteniment PRIMARY KEY (idequip, idmanteniment) 
)
TABLESPACE TS_BDR;
COMMIT;

--per cada equip es reinicia la numeraci del manteniment
CREATE OR REPLACE TRIGGER inserir_idmant_manteniment 
      BEFORE INSERT ON manteniment
      FOR EACH ROW
BEGIN
      SELECT (count(*) + 1) INTO :NEW.idmanteniment
      FROM manteniment
      where idequip = :NEW.idequip;
END inserir_idmant_manteniment;
/
COMMIT;

---------------------------------------------------
-----------  MANTENIMENT  CORRECTIU  --------------
---------------------------------------------------
--DROP TABLE mantcorrectiu CASCADE CONSTRAINTS PURGE;
CREATE TABLE mantcorrectiu(
      idequip INTEGER 
      , idmanteniment INTEGER 
      , dataIncid DATE CONSTRAINT NN_mantcorrectiu_dataincid NOT NULL
      , motiuIncid VARCHAR2(220) CONSTRAINT NN_mantcorrectiu_motiuincid NOT NULL
      , idusuari INTEGER CONSTRAINT FK1_mantcorrectiu REFERENCES usuari(idusuari)
                       CONSTRAINT NN_mantcorrectiu_idusuari NOT NULL
      , idprioritat INTEGER CONSTRAINT FK2_mantcorrectiu REFERENCES 
prioritat(idprioritat)
      , CONSTRAINT PK_mantcorrectiu PRIMARY KEY (idequip, idmanteniment) 
      , CONSTRAINT FK3_mantcorrectiu FOREIGN KEY (idequip, idmanteniment) REFERENCES 
manteniment(idequip, idmanteniment)
)
TABLESPACE TS_BDR;
COMMIT;

---------------------------------------------------
------  RESOLUCIO MANTENIMENT CORRECTIU -----------
---------------------------------------------------
--DROP TABLE resoluciomant CASCADE CONSTRAINTS PURGE;
CREATE TABLE resoluciomant(
      idequip INTEGER 
      , idmanteniment INTEGER 
      , idempresa INTEGER CONSTRAINT FK1_resoluciomant REFERENCES empresa(idempresa)
                        CONSTRAINT NN_resoluciomant_empresa NOT NULL  
      , idoperari INTEGER CONSTRAINT FK2_resoluciomant REFERENCES operari(idoperari)
                        CONSTRAINT NN_resoluciomant_idoperari NOT NULL						
      , dataInici DATE CONSTRAINT NN_resoluciomant_dataInici NOT NULL
      , dataFi DATE CONSTRAINT NN_resoluciomant_dataFi NOT NULL
      , observacions VARCHAR2(100) 
      , dataAlta DATE DEFAULT SYSDATE NOT NULL
      , dataBaixa DATE 
      , CONSTRAINT PK_resoluciomant PRIMARY KEY (idequip, idmanteniment) 
      , CONSTRAINT FK3_resoluciomant FOREIGN KEY (idequip, idmanteniment) REFERENCES 
mantcorrectiu(idequip, idmanteniment)
)
TABLESPACE TS_BDR;
COMMIT;

---------------------------------------------------
-----------  MANTENIMENT  PREVENTIU  --------------
---------------------------------------------------
--els manteniments preventius sn els manteniments obligatoris u opcionals 
--que ha de rebre un equip amb la periodicitat que marca la llei (obligatoris) segons l antiguitat del mateix
--o amb el que l empresa consideri oport (opcionals)

--DROP TABLE mantpreventiu CASCADE CONSTRAINTS PURGE;
CREATE TABLE mantpreventiu(
      idequip INTEGER 
      , idmanteniment INTEGER
      , dataInici DATE CONSTRAINT NN_mantpreventiu_datainici NOT NULL
      , dataFi DATE CONSTRAINT NN_mantpreventiu_datafi NOT NULL
      , periodicitatMesos INTEGER CONSTRAINT NN_mantpreventiu_periodMesos NOT NULL
      , CONSTRAINT PK_mantpreventiu PRIMARY KEY (idequip, idmanteniment) 
      , CONSTRAINT FK2_mantpreventiu FOREIGN KEY (idequip, idmanteniment) REFERENCES 
manteniment(idequip, idmanteniment)
)
TABLESPACE TS_BDR;
COMMIT;

---------------------------------------------------
----------------  REVISIO  ------------------------
---------------------------------------------------
--DROP TABLE revisio CASCADE CONSTRAINTS PURGE;
CREATE TABLE revisio(
      idequip INTEGER 
      , idmanteniment INTEGER 
      , idrevisio INTEGER
      , dataPrevista DATE CONSTRAINT NN_revisio_dataPrevista NOT NULL
      , dataRealitzacio DATE 
      , idempresa INTEGER   	  
      , idoperari INTEGER 
      , observacions VARCHAR2(100)
      , dataAlta DATE DEFAULT SYSDATE NOT NULL
      , dataBaixa DATE 
      , CONSTRAINT PK_revisio PRIMARY KEY (idequip, idmanteniment, idrevisio) 
      , CONSTRAINT FK1_revisio FOREIGN KEY (idequip, idmanteniment) REFERENCES mantpreventiu(idequip, idmanteniment)
      , CONSTRAINT FK2_revisio FOREIGN KEY (idoperari) REFERENCES operari(idoperari)
)
TABLESPACE TS_BDR;
COMMIT;

CREATE OR REPLACE TRIGGER inserir_idrevisio_revisio 
      BEFORE INSERT ON revisio
      FOR EACH ROW
BEGIN
      SELECT (count(*) + 1) INTO :NEW.idrevisio
      FROM revisio
      where idequip = :NEW.idequip
            AND idmanteniment = :NEW.idmanteniment;
END inserir_idrevisio_revisio;
/
COMMIT;

CREATE OR REPLACE TRIGGER inserir_prim_revisio_pendent
      AFTER INSERT ON MANTPREVENTIU 
      FOR EACH ROW
   /******************************************************************************
    OBJECTIU:   Donar d'alta la primera revisi pendent d'un equip en donar d alta
                un manteniment preventiu peridic per l equip en qesti.
   ******************************************************************************/        
DECLARE
  p_dataPrev REVISIO.dataprevista%TYPE;
BEGIN
    --calculem data propera revisio pendent
    --dataInici + periodicitatMesos => dataPrevista 
    SELECT ADD_MONTHS(:NEW.DATAINICI,:NEW.PERIODICITATMESOS)
    INTO p_dataPrev
    FROM DUAL;
    
    --inserim propera revisio pendent
    --si dataPrevista < dataFi manteniment
    IF (p_dataPrev <= :NEW.DATAFI) THEN
        INSERT INTO REVISIO(idequip,idmanteniment,dataPrevista)
               VALUES(:NEW.IDEQUIP,:NEW.IDMANTENIMENT, p_dataPrev); 
    END IF;
END inserir_prim_revisio_pendent;
/ 
COMMIT;

---------------------------------------------------
------------------  LOGS  -------------------------
---------------------------------------------------
--DROP TABLE pfc_BDR.logs CASCADE CONSTRAINTS PURGE;
CREATE TABLE LOGS(
  	  idlog  INTEGER CONSTRAINT PK_logs PRIMARY KEY
  	  , dataLog      DATE NOT NULL
	  , PROCEDIMENT  VARCHAR2(200)  NOT NULL
	  , PARAMSENTRADA  VARCHAR2(2000) NOT NULL
	  , PARAMSSORTIDA  VARCHAR2(2000) NOT NULL
)
TABLESPACE TS_BDR;
commit;

--DROP SEQUENCE seq_logs;
CREATE SEQUENCE seq_logs INCREMENT BY 1 START WITH 1;
commit;

CREATE OR REPLACE TRIGGER inserir_idlog_logs
      BEFORE INSERT ON logs
      FOR EACH ROW
BEGIN
      SELECT seq_logs.NEXTVAL INTO :NEW.idlog
      FROM DUAL;
END inserir_idlog_logs;
/
COMMIT;

  
spool off
exit

  
  