-----------------------------------------
-----------------------------------------
spool C:\UOC\PFC\mbernard\logs\ap4-package_empreses.log
-----------------------------------------
-----------------------------------------

CREATE OR REPLACE PACKAGE pfc_BDR.PKG_EMPRESES AS
/******************************************************************************
   NOM:   PKG_EMPRESES
   OBJECTIU: GESTIO DE TOTA LA INFORMACI RELACIONADA AMB LES EMPRESES DE SERVEI 
			 I ELS SEUS OPERARIS
******************************************************************************/

   /**************************************
   *  MANTENIMENT EMPRESES
   **************************************/
  PROCEDURE PR_ALTA_EMPRESA (p_nomEmpresa 		IN EMPRESA.nomEmpresa%TYPE,
							p_nif  				IN EMPRESA.nif%TYPE,
							p_adrea  			IN EMPRESA.adrea%TYPE,
							p_idpoblacio		IN EMPRESA.idpoblacio%TYPE,
							p_codipostal		IN EMPRESA.codipostal%TYPE,
							p_telefon1			IN EMPRESA.telefon1%TYPE,
							p_telefon2			IN EMPRESA.telefon2%TYPE,
							p_fax				IN EMPRESA.fax%TYPE,
							p_mail				IN EMPRESA.mail%TYPE,
							p_personaContacte	IN EMPRESA.personaContacte%TYPE,
							p_telefonContacte	IN EMPRESA.telefonContacte%TYPE,
							p_mailContacte		IN EMPRESA.mailContacte%TYPE,
							p_telefon24hores	IN EMPRESA.telefon24hores%TYPE,
							RES 				OUT VARCHAR2);
													
  PROCEDURE PR_BAIXA_EMPRESA (p_idempresa 	IN EMPRESA.idempresa%TYPE,
							RES     		OUT VARCHAR2);
													
  PROCEDURE PR_MODIF_EMPRESA (p_idempresa 		IN EMPRESA.idempresa%TYPE,
							p_nomEmpresa 		IN EMPRESA.nomEmpresa%TYPE,
							p_nif  				IN EMPRESA.nif%TYPE,
							p_adrea  			IN EMPRESA.adrea%TYPE,
							p_idpoblacio		IN EMPRESA.idpoblacio%TYPE,
							p_codipostal		IN EMPRESA.codipostal%TYPE,
							p_telefon1			IN EMPRESA.telefon1%TYPE,
							p_telefon2			IN EMPRESA.telefon2%TYPE,
							p_fax				IN EMPRESA.fax%TYPE,
							p_mail				IN EMPRESA.mail%TYPE,
							p_personaContacte	IN EMPRESA.personaContacte%TYPE,
							p_telefonContacte	IN EMPRESA.telefonContacte%TYPE,
							p_mailContacte		IN EMPRESA.mailContacte%TYPE,
							p_telefon24hores	IN EMPRESA.telefon24hores%TYPE,
							p_dataalta  		IN EMPRESA.dataAlta%TYPE,
							p_databaixa 		IN EMPRESA.dataBaixa%TYPE,
							RES 				OUT VARCHAR2);

  FUNCTION FN_OBTENIR_ID_NIF_EMPRESA(p_nif EMPRESA.nif%TYPE) 
  RETURN EMPRESA.idempresa%TYPE;
     
	 
   /**************************************
   *  MANTENIMENT OPERARIS 
   **************************************/   
  PROCEDURE PR_ALTA_OPERARI (p_idempresa  	IN OPERARI.idempresa%TYPE,
							p_codiOperari  	IN OPERARI.codiOperari%TYPE,
							RES 			OUT VARCHAR2);
							
  PROCEDURE PR_BAIXA_OPERARI (p_idoperari 	IN OPERARI.idoperari%TYPE,
							RES     		OUT VARCHAR2);
							
  PROCEDURE PR_MODIF_OPERARI (p_idoperari	IN OPERARI.idoperari%TYPE,
							p_idempresa  	IN OPERARI.idempresa%TYPE,
							p_codiOperari  	IN OPERARI.codiOperari%TYPE,				
							p_dataalta  	IN OPERARI.dataAlta%TYPE,
							p_databaixa 	IN OPERARI.dataBaixa%TYPE,
							RES     		OUT VARCHAR2);
							
  FUNCTION FN_OBTENIR_ID_CODI_OPERARI(p_idempresa OPERARI.idempresa%TYPE, p_codiOperari OPERARI.codiOperari%TYPE) 
  RETURN OPERARI.idoperari%TYPE;							
							
END;
/


CREATE OR REPLACE 
PACKAGE BODY   pfc_BDR.PKG_EMPRESES AS

  /**************************************
  *  MANTENIMENT EMPRESES
  **************************************/
  FUNCTION FN_OBTENIR_ID_NIF_EMPRESA(p_nif EMPRESA.nif%TYPE) 
  RETURN EMPRESA.idempresa%TYPE
    IS
	idAux EMPRESA.idempresa%TYPE; 
	q INTEGER;
  BEGIN
	  SELECT count(*) as d  
	  INTO q
	  FROM EMPRESA
	  WHERE p_nif = nif;

	  IF (q > 0) THEN
		  SELECT idempresa 
			INTO idAux
		  FROM EMPRESA
		  WHERE p_nif = nif;
		  RETURN idAux;
	  ELSE 
		  RETURN 0;  --si no existeix retorna 0
	  END IF;
  END;
   
  PROCEDURE PR_ALTA_EMPRESA (p_nomEmpresa 		IN EMPRESA.nomEmpresa%TYPE,
							p_nif  				IN EMPRESA.nif%TYPE,
							p_adrea  			IN EMPRESA.adrea%TYPE,
							p_idpoblacio		IN EMPRESA.idpoblacio%TYPE,
							p_codipostal		IN EMPRESA.codipostal%TYPE,
							p_telefon1			IN EMPRESA.telefon1%TYPE,
							p_telefon2			IN EMPRESA.telefon2%TYPE,
							p_fax				IN EMPRESA.fax%TYPE,
							p_mail				IN EMPRESA.mail%TYPE,
							p_personaContacte	IN EMPRESA.personaContacte%TYPE,
							p_telefonContacte	IN EMPRESA.telefonContacte%TYPE,
							p_mailContacte		IN EMPRESA.mailContacte%TYPE,
							p_telefon24hores	IN EMPRESA.telefon24hores%TYPE,
							RES 				OUT VARCHAR2)
  IS						
   E_CAMP_NUL         	EXCEPTION;
   E_EMPRESA_EXISTEIX     EXCEPTION;
   E_poblacio_NOEXISTEIX  EXCEPTION;

   existeix      VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN

     param_entrada := 'P_NOMEMPRESA: '||p_nomEmpresa||', P_NIF: '||p_nif||', P_ADREA: '||p_adrea||', P_IDPOBLACIO: '||p_idpoblacio||', P_CODIPOSTAL: '||p_codipostal||', P_TELEFON1: '||p_telefon1||', P_TELEFON2: '||p_telefon2||', P_FAX: '||p_fax||', P_MAIL: '||p_mail||', P_PERSONACONTACTE: '||p_personaContacte||', P_TELEFONCONTACTE: '||p_telefonContacte||', P_MAILCONTACTE: '||p_mailContacte||', P_TELEFON24HORES: '||p_telefon24hores;

     --Verifica que tots els camps obligatoris tenen valor
     IF (TRIM(p_nomEmpresa) IS NULL) OR (TRIM(p_nif) IS NULL) OR (TRIM(p_adrea) IS NULL)  
				OR (TRIM(p_idpoblacio) IS NULL) OR (TRIM(p_telefon1) IS NULL)
			THEN 
				RAISE E_CAMP_NUL ;
     END IF;

     --Verifica que el registre no s'hagi inserit previament
     BEGIN
        SELECT 'S'
        INTO EXISTEIX
        FROM EMPRESA
        WHERE nif  = p_nif
			  AND ROWNUM  = 1;

        RAISE E_EMPRESA_EXISTEIX;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           NULL;
     END;
	 
	  --Verifica que la poblacio existeix en la base de dades
      BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM POBLACIO
        WHERE idpoblacio  = p_idpoblacio
          AND ROWNUM  = 1;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_poblacio_NOEXISTEIX;
      END;	 

     --Si ha passat les proves de validaci realitza la inserci
     INSERT INTO EMPRESA (nomEmpresa,nif,adrea,idpoblacio,codipostal,telefon1,telefon2,fax,mail,							personaContacte,telefonContacte,mailContacte,telefon24hores)
          VALUES (p_nomEmpresa,p_nif,p_adrea,p_idpoblacio,p_codipostal,p_telefon1,p_telefon2,p_fax,p_mail,					p_personaContacte,p_telefonContacte,p_mailContacte,p_telefon24hores);

     RES := 'OK';
  
     INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
          VALUES(SYSDATE,'PKG_EMPRESES.PR_ALTA_EMPRESA', param_entrada, 'RES: '||RES);
     COMMIT;

  EXCEPTION
    WHEN E_EMPRESA_EXISTEIX THEN
      RES := 'ERROR: l empresa ja ha estat donada d alta';

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_EMPRESES.PR_ALTA_EMPRESA', param_entrada, 'RES: '||RES);
      COMMIT;

    WHEN E_CAMP_NUL  THEN
      RES := 'ERROR: El camp no pot ser nul';

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_EMPRESES.PR_ALTA_EMPRESA', param_entrada, 'RES: '||RES);
      COMMIT;
	  
    WHEN E_poblacio_NOEXISTEIX  THEN
      RES := 'ERROR: La poblacio no existeix en la base de dades';

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_EMPRESES.PR_ALTA_EMPRESA', param_entrada, 'RES: '||RES);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);

      RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_EMPRESES.PR_ALTA_EMPRESA', param_entrada, 'RES: '||RES);
      COMMIT;
  END;

  
  PROCEDURE PR_BAIXA_EMPRESA (p_idempresa 	IN EMPRESA.idempresa%TYPE,
							RES     		OUT VARCHAR2)
  IS			
   E_CAMP_NUL  EXCEPTION;
   E_EMPRESA_NOEXISTEIX EXCEPTION;
   E_EMPRESA_JA_BAIXA EXCEPTION;

   existeix        VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN

      param_entrada := 'P_IDEMPRESA: '||p_idempresa;

     --Verifica que tots els camps obligatoris tenen valor
     IF (TRIM(p_idempresa) IS NULL) 
			THEN
				RAISE E_CAMP_NUL ;
     END IF;

     --Verifica que l empresa existeix en la Base de Dades
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM EMPRESA
        WHERE idempresa = p_idempresa
			AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_EMPRESA_NOEXISTEIX;
     END;

     --Verifica que l empresa no est donada de baixa
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM EMPRESA
        WHERE idempresa = p_idempresa
			AND dataBaixa  IS NULL
			AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_EMPRESA_JA_BAIXA;
     END;

     --Si ha passat les proves de validaci realitza l'esborrat lgic de l empresa
     UPDATE EMPRESA SET dataBaixa = SYSDATE
     WHERE  idempresa = p_idempresa;

     RES := 'OK';

     INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
          VALUES(SYSDATE,'PKG_EMPRESES.PR_BAIXA_EMPRESA', param_entrada, 'RES: '||RES);
     COMMIT;

  EXCEPTION
      WHEN E_EMPRESA_NOEXISTEIX THEN
        RES := 'ERROR: L empresa a donar de baixa no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_EMPRESES.PR_BAIXA_EMPRESA', param_entrada, 'RES: '||RES);
        COMMIT;

      WHEN E_EMPRESA_JA_BAIXA THEN
        RES := 'ERROR: L empresa ja havia estat donada de baixa';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_EMPRESES.PR_BAIXA_EMPRESA', param_entrada, 'RES: '||RES);
        COMMIT;

      WHEN E_CAMP_NUL  THEN
        RES := 'ERROR: El camp no pot ser nul';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_EMPRESES.PR_BAIXA_EMPRESA', param_entrada, 'RES: '||RES);
        COMMIT;

      WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);

        RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_EMPRESES.PR_BAIXA_EMPRESA', param_entrada, 'RES: '||RES);
        COMMIT;
  END;
  
							
  PROCEDURE PR_MODIF_EMPRESA (p_idempresa 		IN EMPRESA.idempresa%TYPE,
							p_nomEmpresa 		IN EMPRESA.nomEmpresa%TYPE,
							p_nif  				IN EMPRESA.nif%TYPE,
							p_adrea  			IN EMPRESA.adrea%TYPE,
							p_idpoblacio		IN EMPRESA.idpoblacio%TYPE,
							p_codipostal		IN EMPRESA.codipostal%TYPE,
							p_telefon1			IN EMPRESA.telefon1%TYPE,
							p_telefon2			IN EMPRESA.telefon2%TYPE,
							p_fax				IN EMPRESA.fax%TYPE,
							p_mail				IN EMPRESA.mail%TYPE,
							p_personaContacte	IN EMPRESA.personaContacte%TYPE,
							p_telefonContacte	IN EMPRESA.telefonContacte%TYPE,
							p_mailContacte		IN EMPRESA.mailContacte%TYPE,
							p_telefon24hores	IN EMPRESA.telefon24hores%TYPE,
							p_dataalta  		IN EMPRESA.dataAlta%TYPE,
							p_databaixa 		IN EMPRESA.dataBaixa%TYPE,
							RES 				OUT VARCHAR2)
  IS
   E_CAMP_NUL             EXCEPTION;
   E_EMPRESA_NOEXISTEIX       EXCEPTION;
   E_DATA_BAIXA_INCORRECTA EXCEPTION;
   E_poblacio_NOEXISTEIX  EXCEPTION;
   E_DATA_IMPOSSIBLE EXCEPTION;

   existeix        VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

   BEGIN

     param_entrada := 'P_IDEMPRESA: '||p_idempresa||'P_NOMEMPRESA: '||p_nomEmpresa||', P_NIF: '||p_nif||', P_ADREA: '||p_adrea||', P_IDPOBLACIO: '||p_idpoblacio||', P_CODIPOSTAL: '||p_codipostal||', P_TELEFON1: '||p_telefon1||', P_TELEFON2: '||p_telefon2||', P_FAX: '||p_fax||', P_MAIL: '||p_mail||', P_PERSONACONTACTE: '||p_personaContacte||', P_TELEFONCONTACTE: '||p_telefonContacte||', P_MAILCONTACTE: '||p_mailContacte||', P_TELEFON24HORES: '||p_telefon24hores||', P_DATAALTA: '||p_dataalta||', P_DATABAIXA: '||p_databaixa;

     --Verifica que tots els camps obligatoris tenen valor
     IF (TRIM(p_idempresa) IS NULL) OR (TRIM(p_nomEmpresa) IS NULL) OR (TRIM(p_nif) IS NULL) 
			OR (TRIM(p_adrea) IS NULL) OR (TRIM(p_idpoblacio) IS NULL) OR (TRIM(p_telefon1) IS NULL)
				THEN 
					RAISE E_CAMP_NUL ;
     END IF;

     --Verifica que l empresa existeix en la Base de Dades
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM EMPRESA
        WHERE idempresa = p_idempresa
			AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_EMPRESA_NOEXISTEIX;
     END;
	 
	  --Verifica que la poblacio existeix en la base de dades
      BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM POBLACIO
        WHERE idpoblacio  = p_idpoblacio
          AND ROWNUM  = 1;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_poblacio_NOEXISTEIX;
      END;	

	 -- si es modifica la data d'alta
	 IF (p_dataalta IS NOT NULL AND p_databaixa IS NOT NULL) THEN
		IF (p_dataalta > p_databaixa) THEN
				RAISE E_DATA_BAIXA_INCORRECTA;
		END IF;
	 END IF;
	 
	   --verifica que les dates sn anteriors a la data actual
       IF (p_dataalta IS NOT NULL OR p_databaixa IS NOT NULL) THEN
         IF (p_dataalta > SYSDATE) OR (p_databaixa > SYSDATE) THEN
             RAISE E_DATA_IMPOSSIBLE;
         END IF;
       END IF;	 
    
     --Si es passen les proves de validaci actualitzem
     UPDATE EMPRESA
        SET nomEmpresa = nvl(p_nomEmpresa, nomEmpresa),
			nif = nvl(p_nif, nif),
			adrea = nvl(p_adrea, adrea),
			idpoblacio = nvl(p_idpoblacio, idpoblacio),
			codipostal = nvl(p_codipostal, codipostal),
			telefon1 = nvl(p_telefon1, telefon1),
            telefon2 = nvl(p_telefon2, telefon2),
            fax  = nvl(p_fax, fax),
			mail = nvl(p_mail, mail),
			personaContacte = nvl(p_personaContacte, personaContacte),
            telefonContacte = nvl(p_telefonContacte, telefonContacte),
            mailContacte = nvl(p_mailContacte, mailContacte),
			telefon24hores = nvl(p_telefon24hores, telefon24hores),
            dataAlta = nvl(p_dataalta, dataAlta),
			dataBaixa = nvl(p_databaixa, dataBaixa)
     WHERE  idempresa = p_idempresa;
     COMMIT;

     RES:= 'OK';

     INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE,'PKG_EMPRESES.PR_MODIF_EMPRESA', param_entrada, 'RES: '||RES);
     COMMIT;

   EXCEPTION
      WHEN E_EMPRESA_NOEXISTEIX THEN
        RES := 'ERROR: L empresa a modificar no existeix';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_EMPRESES.PR_MODIF_EMPRESA', param_entrada, 'RES: '||RES);
        COMMIT;

      WHEN E_CAMP_NUL  THEN
        RES := 'ERROR: El camp no pot ser nul';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_EMPRESES.PR_MODIF_EMPRESA', param_entrada, 'RES: '||RES);
        COMMIT;
		
      WHEN E_poblacio_NOEXISTEIX  THEN
        RES := 'ERROR: La poblacio no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_EMPRESES.PR_MODIF_EMPRESA', param_entrada, 'RES: '||RES);
        COMMIT;		

      WHEN E_DATA_BAIXA_INCORRECTA THEN
        RES := 'ERROR: La data d alta no pot ser posterior a la data de baixa';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_EMPRESES.PR_MODIF_EMPRESA', param_entrada, 'RES: '||RES);
        COMMIT;
		
      WHEN E_DATA_IMPOSSIBLE THEN
        RES := 'ERROR: La data d alta o la data de baixa no poden ser posteriors a la data actual';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_EMPRESES.PR_MODIF_EMPRESA', param_entrada, 'RES: '||RES);
        COMMIT;			

     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);

        RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_EMPRESES.PR_MODIF_EMPRESA', param_entrada, 'RES: '||RES);
        COMMIT;
  END;
    
	 
  /**************************************
  *  MANTENIMENT OPERARIS 
  **************************************/   
  FUNCTION FN_OBTENIR_ID_CODI_OPERARI(p_idempresa OPERARI.idempresa%TYPE, p_codiOperari OPERARI.codiOperari%TYPE) 
  RETURN OPERARI.idoperari%TYPE
  IS
	idAux OPERARI.idoperari%TYPE; 
	q INTEGER;
  BEGIN
	  SELECT count(*) as d  
	  INTO q
	  FROM OPERARI
	  WHERE p_idempresa = idempresa
			AND p_codiOperari = codiOperari;

	  IF (q > 0) THEN
		  SELECT idoperari 
			INTO idAux
		  FROM OPERARI
		  WHERE p_idempresa = idempresa
				AND p_codiOperari = codiOperari;
		  RETURN idAux;
	  ELSE 
		  RETURN 0;  --si no existeix retorna 0
	  END IF;
  END;
  
  
  PROCEDURE PR_ALTA_OPERARI (p_idempresa  	IN OPERARI.idempresa%TYPE,
							p_codiOperari  	IN OPERARI.codiOperari%TYPE,
							RES 			OUT VARCHAR2)						
  IS
   E_CAMP_NUL         	EXCEPTION;
   E_OPERARI_EXISTEIX   EXCEPTION;
   E_EMPRESA_NOEXISTEIX   EXCEPTION;


   existeix      VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN

     param_entrada := 'P_IDEMPRESA: '||p_idempresa||', P_CODIOPERARI: '||p_codiOperari;

     --Verifica que tots els camps obligatoris tenen valor
     IF (TRIM(p_idempresa) IS NULL) OR (TRIM(p_codiOperari) IS NULL) 
		THEN 
         RAISE E_CAMP_NUL ;
     END IF;

     --Verifica que el registre no s'hagi inserit previament
     BEGIN
        SELECT 'S'
        INTO EXISTEIX
        FROM OPERARI
        WHERE idempresa  = p_idempresa
			  AND codiOperari = p_codiOperari
			  AND ROWNUM  = 1;

        RAISE E_OPERARI_EXISTEIX;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           NULL;
     END;
	 
	 --Verifica que l empresa existeixi
     BEGIN
        SELECT 'S'
        INTO EXISTEIX
        FROM EMPRESA
        WHERE idempresa  = p_idempresa
			  AND ROWNUM  = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
			RAISE E_EMPRESA_NOEXISTEIX;
     END;

     --Si ha passat les proves de validaci realitza la inserci
     INSERT INTO OPERARI (idempresa,codiOperari)
          VALUES (p_idempresa,p_codiOperari);

     RES := 'OK';
  
     INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
          VALUES(SYSDATE,'PKG_EMPRESES.PR_ALTA_OPERARI', param_entrada, 'RES: '||RES);
     COMMIT;

  EXCEPTION
    WHEN E_OPERARI_EXISTEIX THEN
      RES := 'ERROR: l operari de l empresa ja ha estat donat d alta';

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_EMPRESES.PR_ALTA_OPERARI', param_entrada, 'RES: '||RES);
      COMMIT;
	  
	WHEN E_EMPRESA_NOEXISTEIX THEN
      RES := 'ERROR: l empresa no existeix en la base de dades';

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_EMPRESES.PR_ALTA_OPERARI', param_entrada, 'RES: '||RES);
      COMMIT;

    WHEN E_CAMP_NUL  THEN
      RES := 'ERROR: El camp no pot ser nul';

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_EMPRESES.PR_ALTA_OPERARI', param_entrada, 'RES: '||RES);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);

      RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_EMPRESES.PR_ALTA_OPERARI', param_entrada, 'RES: '||RES);
      COMMIT;
  END;

  
  PROCEDURE PR_BAIXA_OPERARI (p_idoperari 	IN OPERARI.idoperari%TYPE,
							RES     		OUT VARCHAR2)
  IS
   E_CAMP_NUL  EXCEPTION;
   E_OPERARI_NOEXISTEIX EXCEPTION;
   E_OPERARI_JA_BAIXA EXCEPTION;

   existeix        VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN

     param_entrada := 'P_IDOPERARI: '||p_idoperari;

     --Verifica que tots els camps obligatoris tenen valor
     IF (TRIM(p_idoperari) IS NULL) 
		 THEN
			RAISE E_CAMP_NUL ;
     END IF;

     --Verifica que l operari existeix en la Base de Dades
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM OPERARI
        WHERE idoperari = p_idoperari
			AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_OPERARI_NOEXISTEIX;
     END;

     --Verifica que l operari no est donat de baixa
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM OPERARI
        WHERE idoperari = p_idoperari
			AND dataBaixa  IS NULL
			AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_OPERARI_JA_BAIXA;
     END;

     --Si ha passat les proves de validaci realitza l'esborrat lgic del model
     UPDATE OPERARI SET dataBaixa = SYSDATE
     WHERE  idoperari = p_idoperari;

     RES := 'OK';

     INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
          VALUES(SYSDATE,'PKG_EMPRESES.PR_BAIXA_OPERARI', param_entrada, 'RES: '||RES);
     COMMIT;

  EXCEPTION
      WHEN E_OPERARI_NOEXISTEIX THEN
        RES := 'ERROR: L operari a donar de baixa no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_EMPRESES.PR_BAIXA_OPERARI', param_entrada, 'RES: '||RES);
        COMMIT;

      WHEN E_OPERARI_JA_BAIXA THEN
        RES := 'ERROR: L operari ja havia estat donat de baixa';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_EMPRESES.PR_BAIXA_OPERARI', param_entrada, 'RES: '||RES);
        COMMIT;

      WHEN E_CAMP_NUL  THEN
        RES := 'ERROR: El camp no pot ser nul';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_EMPRESES.PR_BAIXA_OPERARI', param_entrada, 'RES: '||RES);
        COMMIT;

      WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);

        RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_EMPRESES.PR_BAIXA_OPERARI', param_entrada, 'RES: '||RES);
        COMMIT;
  END;
							
							
  PROCEDURE PR_MODIF_OPERARI (p_idoperari	IN OPERARI.idoperari%TYPE,
							p_idempresa  	IN OPERARI.idempresa%TYPE,
							p_codiOperari  	IN OPERARI.codiOperari%TYPE,				
							p_dataalta  	IN OPERARI.dataAlta%TYPE,
							p_databaixa 	IN OPERARI.dataBaixa%TYPE,
							RES     		OUT VARCHAR2)
  IS
    E_CAMP_NUL             	EXCEPTION;
	E_OPERARI_NOEXISTEIX   	EXCEPTION;
	E_DATA_BAIXA_INCORRECTA EXCEPTION;
	E_DATA_IMPOSSIBLE EXCEPTION;
	E_EMPRESA_NOEXISTEIX   EXCEPTION;

	existeix        VARCHAR2(1);
	param_entrada VARCHAR2(500);
	err_num       NUMBER;
	err_msg       VARCHAR2(100);

  BEGIN

     param_entrada := 'P_IDOPERARI: '||p_idoperari||', P_IDEMPRESA: '||p_idempresa||', P_CODIOPERARI: '||p_codiOperari||', P_DATAALTA: '||p_dataalta||', P_DATABAIXA: '||p_databaixa;

     --Verifica que tots els camps obligatoris tenen valor
     IF (TRIM(p_idoperari) IS NULL) OR (TRIM(p_idempresa) IS NULL) OR (TRIM(p_codiOperari) IS NULL)
				THEN
					RAISE E_CAMP_NUL ;
     END IF;
	 
	 --Verifica que l empresa existeixi
     BEGIN
        SELECT 'S'
        INTO EXISTEIX
        FROM EMPRESA
        WHERE idempresa  = p_idempresa
			  AND ROWNUM  = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
			RAISE E_EMPRESA_NOEXISTEIX;
     END;		 

     --Verifica que l operari existeix en la Base de Dades
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM OPERARI
        WHERE idoperari = p_idoperari
			AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_OPERARI_NOEXISTEIX;
     END;

	 -- si es modifica la data d'alta
	 IF (p_dataalta IS NOT NULL AND p_databaixa IS NOT NULL) THEN
		IF (p_dataalta > p_databaixa) THEN
				RAISE E_DATA_BAIXA_INCORRECTA;
		END IF;
	 END IF;
	 
	   --verifica que les dates sn anteriors a la data actual
       IF (p_dataalta IS NOT NULL OR p_databaixa IS NOT NULL) THEN
         IF (p_dataalta > SYSDATE) OR (p_databaixa > SYSDATE) THEN
             RAISE E_DATA_IMPOSSIBLE;
         END IF;
       END IF;	 
    
     --Si es passen les proves de validaci actualizem
     UPDATE OPERARI
        SET idempresa = nvl(p_idempresa, idempresa),
			codiOperari = nvl(p_codiOperari, codiOperari),
            dataAlta    = nvl(p_dataalta, dataAlta),
            dataBaixa   = nvl(p_databaixa, dataBaixa)
     WHERE   idoperari = p_idoperari;
     COMMIT;

     RES:= 'OK';

     INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE,'PKG_EMPRESES.PR_MODIF_OPERARI', param_entrada, 'RES: '||RES);
     COMMIT;

  EXCEPTION
      WHEN E_OPERARI_NOEXISTEIX THEN
        RES := 'ERROR: L operari a modificar no existeix';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_EMPRESES.PR_MODIF_OPERARI', param_entrada, 'RES: '||RES);
        COMMIT;
		
	 WHEN E_EMPRESA_NOEXISTEIX THEN
      RES := 'ERROR: l empresa no existeix en la base de dades';

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_EMPRESES.PR_MODIF_OPERARI', param_entrada, 'RES: '||RES);
      COMMIT;		

      WHEN E_CAMP_NUL  THEN
        RES := 'ERROR: El camp no pot ser nul';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_EMPRESES.PR_MODIF_OPERARI', param_entrada, 'RES: '||RES);
        COMMIT;

      WHEN E_DATA_BAIXA_INCORRECTA THEN
        RES := 'ERROR: La data d alta no pot ser posterior a la data de baixa';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_EMPRESES.PR_MODIF_OPERARI', param_entrada, 'RES: '||RES);
        COMMIT;
		
      WHEN E_DATA_IMPOSSIBLE THEN
        RES := 'ERROR: La data d alta o la data de baixa no poden ser posteriors a la data actual';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_EMPRESES.PR_MODIF_OPERARI', param_entrada, 'RES: '||RES);
        COMMIT;		

     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);

        RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_EMPRESES.PR_MODIF_OPERARI', param_entrada, 'RES: '||RES);
        COMMIT;
  END;

  
END;
/

COMMIT;

spool off
exit