-----------------------------------------
-----------------------------------------
spool C:\UOC\PFC\mbernard\logs\ap5-package_manteniments.log
-----------------------------------------
-----------------------------------------

CREATE OR REPLACE PACKAGE pfc_BDR.PKG_MANTENIMENTS AS
/******************************************************************************
   NOM:   PKG_MANTENIMENTS
   OBJECTIU: GESTIO DE TOTA LA INFORMACI RELACIONADA AMB ELS MANTENIMENTS  
			 DELS EQUIPS
******************************************************************************/

  /**************************************
  *  MANTENIMENT MANTENIMENTS CORRECTIUS
  **************************************/
  PROCEDURE PR_ALTA_MANT_CORRECTIU (p_idequip 		IN MANTENIMENT.idequip%TYPE,
									p_dataIncid		IN MANTCORRECTIU.dataIncid%TYPE,
									p_motiuIncid	IN MANTCORRECTIU.motiuIncid%TYPE,
									p_idusuari 		IN MANTCORRECTIU.idusuari%TYPE,
									p_idprioritat  	IN MANTCORRECTIU.idprioritat%TYPE,
									RES 			OUT VARCHAR2);
								
								
  PROCEDURE PR_BAIXA_MANT_CORRECTIU (p_idequip 		IN MANTENIMENT.idequip%TYPE,
									p_idmanteniment	IN MANTENIMENT.idmanteniment%TYPE,
									RES         	OUT VARCHAR2);


  PROCEDURE PR_MODIF_MANT_CORRECTIU (p_idequip 		IN MANTENIMENT.idequip%TYPE,
									p_idmanteniment	IN MANTENIMENT.idmanteniment%TYPE,
									p_dataalta     	IN MANTENIMENT.dataAlta%TYPE,
									p_databaixa    	IN MANTENIMENT.dataBaixa%TYPE,
									p_dataIncid		IN MANTCORRECTIU.dataIncid%TYPE,
									p_motiuIncid	IN MANTCORRECTIU.motiuIncid%TYPE,
									p_idusuari 		IN MANTCORRECTIU.idusuari%TYPE,
									p_idprioritat  	IN MANTCORRECTIU.idprioritat%TYPE,
									RES             OUT VARCHAR2);
									
  FUNCTION FN_OBTENIR_ULTIM_MANCORR_EQUIP(p_idequip MANTENIMENT.idequip%TYPE)
  RETURN MANTENIMENT.idmanteniment%TYPE;  


  /***************************************************
  *  MANTENIMENT RESOLUCIONS MANTENIMENTS CORRECTIUS
  ****************************************************/ 															
  PROCEDURE PR_ALTA_RESOLUCIO_MANTCORR (p_idequip 		IN RESOLUCIOMANT.idequip%TYPE,
										p_idmanteniment	IN RESOLUCIOMANT.idmanteniment%TYPE,
										p_idempresa		IN RESOLUCIOMANT.idempresa%TYPE,
										p_idoperari 	IN RESOLUCIOMANT.idoperari%TYPE,
										p_dataInici		IN RESOLUCIOMANT.dataInici%TYPE,
										p_dataFi 		IN RESOLUCIOMANT.dataFi%TYPE,
										p_observacions 	IN RESOLUCIOMANT.observacions%TYPE,
										RES 			OUT VARCHAR2);
								
								
  PROCEDURE PR_BAIXA_RESOLUCIO_MANTCORR (p_idequip 		IN RESOLUCIOMANT.idequip%TYPE,
										p_idmanteniment	IN RESOLUCIOMANT.idmanteniment%TYPE,
										RES         	OUT VARCHAR2);


  PROCEDURE PR_MODIF_RESOLUCIO_MANTCORR (p_idequip 		IN RESOLUCIOMANT.idequip%TYPE,
										p_idmanteniment	IN RESOLUCIOMANT.idmanteniment%TYPE,
										p_idempresa		IN RESOLUCIOMANT.idempresa%TYPE,
										p_idoperari 	IN RESOLUCIOMANT.idoperari%TYPE,
										p_dataInici		IN RESOLUCIOMANT.dataInici%TYPE,
										p_dataFi 		IN RESOLUCIOMANT.dataFi%TYPE,
										p_observacions 	IN RESOLUCIOMANT.observacions%TYPE,
										p_dataalta     	IN RESOLUCIOMANT.dataAlta%TYPE,
										p_databaixa    	IN RESOLUCIOMANT.dataBaixa%TYPE,
										RES             OUT VARCHAR2);
									
									
									
  /**************************************
  *  MANTENIMENT MANTENIMENTS PREVENTIUS
  **************************************/   
  PROCEDURE PR_ALTA_MANT_PREVENTIU (p_idequip 			IN MANTENIMENT.idequip%TYPE,
									p_dataInici			IN MANTPREVENTIU.dataInici%TYPE,
									p_dataFi			IN MANTPREVENTIU.dataFi%TYPE,
									p_periodicitatMesos	IN MANTPREVENTIU.periodicitatMesos%TYPE,
									RES 				OUT VARCHAR2);
	  /******************************************************************************
	   NOM:      PR_ALTA_MANT_PREVENTIU
	   OBJECTIU:   Dna d'alta un manteniment preventiu, si supera els segents controls:
					  -Tots els camps obligatoris tenen valor
					  -No existeix un contracte de manteniment per l equip que coincideixi en 
							algun moment del termini 
					  -L equip existeix en la Base de Dades
					  -La data de fi del contracte s anterior a la data d'inici del contracte
					  -La data d inici del contracte s anterior a la data de compra de l equip
	   PARMETRES:
			INPUT:  Obligatoris: 	idequip: ID de l'equip
									dataInici: data d'inici del termini
									dataFi: data fi del termini
									periodicitatMesos: cada quants mesos durant el termini caldr fer una revisio
					Opcionals:  cap 
					No calen: dataAlta s la data d'alta en el sistema 
									 i pren per valor la data del sistema en el moment de la inserci
							  dataBaixa no cal ja que estem donant d'alta un centre
							  idmanteniment s'emplena automticament amb un autonumric en inserir-se
		   OUTPUT:  RES
	   PRECONDICI: No existeix el manteniment de l'equip a crear
	   POSTCONDICI: S'ha donat d'alta el manteniment preventiu 
						i es dna d'alta la primera revisi pendent de l equip en el termini indicat
	   RETORNA: 
			Si ha anat b:   
					'OK' si l'operaci s'ha realitzat amb xit
			Si no ha anat b algun dels missatges segents, depenent de l'error:   
					'ERROR: El camp no pot ser nul'
					'ERROR: L equip no existeix en la base de dades'
					'ERROR: L equip ja t un manteniment preventiu per aquestes dates'
					'ERROR: La data d inici del contracte no pot ser posterior a la data de fi del contracte'
					'ERROR: La data d inici del contracte no pot ser anterior a la data de compra de l equip'
					'ERROR: Tipus d Error' en qualsevol altre cas 
	   ******************************************************************************/								
								
								
  PROCEDURE PR_BAIXA_MANT_PREVENTIU (p_idequip 		IN MANTENIMENT.idequip%TYPE,
									p_idmanteniment	IN MANTENIMENT.idmanteniment%TYPE,
									RES         	OUT VARCHAR2);


  PROCEDURE PR_MODIF_MANT_PREVENTIU (p_idequip 			IN MANTENIMENT.idequip%TYPE,
									p_idmanteniment		IN MANTENIMENT.idmanteniment%TYPE,
									p_dataalta     		IN MANTENIMENT.dataAlta%TYPE,
									p_databaixa    		IN MANTENIMENT.dataBaixa%TYPE,								
									p_dataInici			IN MANTPREVENTIU.dataInici%TYPE,
									p_dataFi			IN MANTPREVENTIU.dataFi%TYPE,
									p_periodicitatMesos	IN MANTPREVENTIU.periodicitatMesos%TYPE,
									RES             	OUT VARCHAR2);
									
  FUNCTION FN_OBTENIR_ULTIM_MANPREV_EQUIP(p_idequip MANTENIMENT.idequip%TYPE)
  RETURN MANTENIMENT.idmanteniment%TYPE; 									


  /***************************************************
  *  MANTENIMENT REVISIONS MANTENIMENTS PREVENTIUS
  ****************************************************/ 															
  PROCEDURE PR_ALTA_REVISIO_MANTPREV (p_idequip 			IN REVISIO.idequip%TYPE,
										p_idmanteniment		IN REVISIO.idmanteniment%TYPE,
										p_dataPrevista 		IN REVISIO.dataPrevista%TYPE,
										p_dataRealitzacio	IN REVISIO.dataRealitzacio%TYPE,
										p_idempresa			IN REVISIO.idempresa%TYPE,
										p_idoperari			IN REVISIO.idoperari%TYPE,
										p_observacions 		IN REVISIO.observacions%TYPE,
										RES 				OUT VARCHAR2);
	  /******************************************************************************
	   NOM:      PR_ALTA_REVISIO_MANTPREV
	   OBJECTIU:   Dna d'alta una revisi del manteniment de l equip , si supera els segents controls:
					  -Tots els camps obligatoris tenen valor
					  -L equip existeix en la base de dades                                  
					  -El manteniment existeix en la base de dades 
					  -La data prevista s dins del perode del manteniment de l equip
					  -L empresa existeix en la base de dades                                
					  -L operari existeix en la base de dades                                
					  -L operari pertany a l empresa
	   PARMETRES:
			INPUT:  Obligatoris: 	idequip: ID de l'equip
									idmanteniment: ID del manteniment
									dataPrevista: data prevista de la segent revisi
									
									Noms en el cas que s'empleni la data de realitzaci, llavors:
									dataRealitzacio: data de realitzaci de la revisi
									idempresa: ID de l empresa
									idoperari: ID de l operari
					Opcionals:  observacions: si es vol afegir algun tipus d observaci sobre la revisi realitzada 
					No calen: dataAlta s la data d'alta en el sistema 
									 i pren per valor la data del sistema en el moment de la inserci
							  dataBaixa no cal ja que estem donant d'alta un centre
		   OUTPUT:  RES
	   PRECONDICI: No existeix una revisio pendent de realitzar del manteniment de l'equip
	   POSTCONDICI: S'ha donat d'alta una revisi pendent 
						o una revisi realitzada
	   RETORNA: 
			Si ha anat b:   
					'OK' si l'operaci s'ha realitzat amb xit
			Si no ha anat b algun dels missatges segents, depenent de l'error:   
					'ERROR: El camp no pot ser nul'
					'ERROR: L equip no existeix en la base de dades'
					'ERROR: El manteniment a modificar no existeix'    
					'ERROR: La data prevista de la revisio no es dins del periode del manteniment de l equip'					
					'ERROR: L empresa no existeix en la base de dades'                                
					'ERROR: L operari no existeix en la base de dades'                                
					'ERROR: l operari no pertany a l empresa' 
					'ERROR: Tipus d Error' en qualsevol altre cas 
	   ******************************************************************************/								
								
								
  PROCEDURE PR_BAIXA_REVISIO_MANTPREV (p_idequip 		IN REVISIO.idequip%TYPE,
										p_idmanteniment	IN REVISIO.idmanteniment%TYPE,
										p_idrevisio		IN REVISIO.idrevisio%TYPE,
										RES         	OUT VARCHAR2);


  PROCEDURE PR_MODIF_REVISIO_MANTPREV (p_idequip 			IN REVISIO.idequip%TYPE,
										p_idmanteniment		IN REVISIO.idmanteniment%TYPE,
										p_idrevisio			IN REVISIO.idrevisio%TYPE,
										p_dataPrevista 		IN REVISIO.dataPrevista%TYPE,
										p_dataRealitzacio	IN REVISIO.dataRealitzacio%TYPE,
										p_idempresa			IN REVISIO.idempresa%TYPE,
										p_idoperari			IN REVISIO.idoperari%TYPE,
										p_observacions 		IN REVISIO.observacions%TYPE,
										p_dataalta     		IN REVISIO.dataAlta%TYPE,
										p_databaixa    		IN REVISIO.dataBaixa%TYPE,
										RES             	OUT VARCHAR2);
										
  PROCEDURE PR_REALITZAR_REVISIO_PENDENT (p_idequip 		IN REVISIO.idequip%TYPE,
										p_idmanteniment		IN REVISIO.idmanteniment%TYPE,
										p_idrevisio			IN REVISIO.idrevisio%TYPE,
										p_dataRealitzacio	IN REVISIO.dataRealitzacio%TYPE,
										p_idempresa			IN REVISIO.idempresa%TYPE,
										p_idoperari			IN REVISIO.idoperari%TYPE,
										p_observacions 		IN REVISIO.observacions%TYPE,
										RES             	OUT VARCHAR2);
	  /******************************************************************************
	   NOM:      PR_REALITZAR_REVISIO_PENDENT
	   OBJECTIU:   Realitza la revisi pendent, si supera els segents controls:
					  -Tots els camps obligatoris tenen valor
					  -L equip existeix en la base de dades                                  
					  -El manteniment existeix en la base de dades                                   
					  -La revisio existeix en la base de dades                                    
					  -L empresa existeix en la base de dades                                
					  -L operari existeix en la base de dades                                
					  -L operari pertany a l empresa
	   PARMETRES:
			INPUT:  Obligatoris: 	idequip: ID de l'equip
									idmanteniment: ID del manteniment
									idrevisio: ID de la revisio
									dataRealitzacio: data de realitzaci de la revisi
									idempresa: ID de l empresa
									idoperari: ID de l operari
					Opcionals:  observacions: si es vol afegir algun tipus d observaci sobre la revisi realitzada 
					No calen: dataAlta s la data d'alta en el sistema 
									 i pren per valor la data del sistema en el moment de la inserci
							  dataBaixa no cal ja que estem donant d'alta un centre
		   OUTPUT:  RES
	   PRECONDICI: Existeix una revisio pendent de realitzar del manteniment de l'equip
	   POSTCONDICI: S'ha realitzat la revisi pendent  
						i s'ha donat d'alta la segent revisi pendent de l equip en el termini indicat (si escau)
	   RETORNA: 
			Si ha anat b:   
					'OK' si l'operaci s'ha realitzat amb xit
			Si no ha anat b algun dels missatges segents, depenent de l'error:   
					'ERROR: El camp no pot ser nul'
					'ERROR: L equip no existeix en la base de dades'
					'ERROR: El manteniment a modificar no existeix'                                   
					'ERROR: La revisio a modificar no existeix'                                       
					'ERROR: L empresa no existeix en la base de dades'                                
					'ERROR: L operari no existeix en la base de dades'                                
					'ERROR: l operari no pertany a l empresa' 
					'ERROR: Tipus d Error' en qualsevol altre cas 
	   ******************************************************************************/
	   
  FUNCTION FN_OBTENIR_ULTREVPENDENT_EQUIP(p_idequip REVISIO.idequip%TYPE,
											p_idmanteniment REVISIO.idmanteniment%TYPE)
  RETURN REVISIO.idrevisio%TYPE; 
	   
END;
/


CREATE OR REPLACE 
PACKAGE BODY   pfc_BDR.PKG_MANTENIMENTS AS

  /**************************************
  *  MANTENIMENT MANTENIMENTS CORRECTIUS
  **************************************/
  FUNCTION FN_OBTENIR_ULTIM_MANCORR_EQUIP(p_idequip MANTENIMENT.idequip%TYPE)
  /* precondicio: l'equip existeix ------i t manteniments correctius 
     retorna 0 si l equip no en t de manteniments correctius
  */
  RETURN MANTENIMENT.idmanteniment%TYPE  
  IS
	idmant MANTENIMENT.idmanteniment%TYPE;
	q integer;
  BEGIN
	  SELECT count(*) as d  
	  INTO q
	  FROM MANTENIMENT
	  WHERE p_idequip = idequip
		    AND tipusMant = 'CORRECTIU';

	  IF (q > 0) THEN
		  SELECT MAX(idmanteniment) 
			INTO idmant
		  FROM MANTENIMENT
		  WHERE p_idequip = idequip
				AND tipusMant = 'CORRECTIU'
				--AND dataBaixa IS NULL
				;
		  RETURN idmant;
	  ELSE 
		  RETURN 0;  --si no t manteniments retorna 0
	  END IF;
  END;

  
  PROCEDURE PR_ALTA_MANT_CORRECTIU (p_idequip 		IN MANTENIMENT.idequip%TYPE,
									p_dataIncid		IN MANTCORRECTIU.dataIncid%TYPE,
									p_motiuIncid	IN MANTCORRECTIU.motiuIncid%TYPE,
									p_idusuari 		IN MANTCORRECTIU.idusuari%TYPE,
									p_idprioritat  	IN MANTCORRECTIU.idprioritat%TYPE,
									RES 			OUT VARCHAR2)
  IS						
   E_CAMP_NUL   EXCEPTION;
   E_EQUIP_NOEXISTEIX	EXCEPTION;
   E_USUARI_NOEXISTEIX	EXCEPTION;
   E_PRIORITAT_NOEXISTEIX	EXCEPTION;
   E_DATA_INCIDENCIA_INCORRECTA	EXCEPTION;
   E_DATAINCID_IMPOSSIBLE EXCEPTION;
   
   p_idmant		MANTENIMENT.idmanteniment%TYPE;
   existeix      VARCHAR2(1);
   dataCompraEquip EQUIP.dataCompra%TYPE;
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN

     param_entrada := 'P_IDEQUIP: '||p_idequip||', P_DATAINCID: '||p_dataIncid||', P_MOTIUINCID: '||p_motiuIncid||', P_IDUSUARI: '||p_idusuari||', P_IDPRIORITAT: '||p_idprioritat;

     --Verifica que tots els camps obligatoris tenen valor
     IF (TRIM(p_idequip) IS NULL) OR (TRIM(p_dataIncid) IS NULL) OR (TRIM(p_motiuIncid) IS NULL)  
				OR (TRIM(p_idusuari) IS NULL) OR (TRIM(p_idprioritat) IS NULL)
			THEN 
				RAISE E_CAMP_NUL ;
     END IF;
	 
	 --Verifica que l equip existeix en la Base de Dades
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM EQUIP
        WHERE idequip = p_idequip
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_EQUIP_NOEXISTEIX;
     END;
	 
	 --Verifica que l usuari existeix en la Base de Dades
	 BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM USUARI
        WHERE idusuari = p_idusuari
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_USUARI_NOEXISTEIX;
     END;
	 
	 --Verifica que la prioritat existeix en la Base de Dades	 
	 BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM PRIORITAT
        WHERE idprioritat = p_idprioritat
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_PRIORITAT_NOEXISTEIX;
     END;
	 
	 --Verifica que la data de la incidncia s posterior a la data de compra de l equip
	 SELECT dataCompra
     INTO dataCompraEquip
     FROM EQUIP
     WHERE idequip = p_idequip;
	 
	 IF (dataCompraEquip IS NOT NULL AND p_dataIncid IS NOT NULL) THEN
		IF (dataCompraEquip > p_dataIncid) THEN
				RAISE E_DATA_INCIDENCIA_INCORRECTA;
		END IF;
	 END IF;
	 
	   --verifica que le data de la incidncia s anterior a la data actual
         IF (p_dataIncid > SYSDATE) THEN
             RAISE E_DATAINCID_IMPOSSIBLE;
         END IF;	 
	 
     --Si ha passat les proves de validaci realitza la inserci
     INSERT INTO MANTENIMENT (idequip,tipusMant)
          VALUES (p_idequip,'CORRECTIU');
	 COMMIT;
	 
	 p_idmant := FN_OBTENIR_ULTIM_MANCORR_EQUIP(p_idequip);
		  
     INSERT INTO MANTCORRECTIU (idequip,idmanteniment,dataIncid,motiuIncid,idusuari,idprioritat)
          VALUES (p_idequip,p_idmant,p_dataIncid,p_motiuIncid,p_idusuari,p_idprioritat);
		  
     RES := 'OK';
  
     INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
          VALUES(SYSDATE,'PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU', param_entrada, 'RES: '||RES);
     COMMIT;

  EXCEPTION
    WHEN E_CAMP_NUL  THEN
      RES := 'ERROR: El camp no pot ser nul';

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU', param_entrada, 'RES: '||RES);
      COMMIT;
	    
	WHEN E_EQUIP_NOEXISTEIX  THEN
      RES := 'ERROR: L equip no existeix en la base de dades';

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU', param_entrada, 'RES: '||RES);
      COMMIT;
	  
	WHEN E_USUARI_NOEXISTEIX  THEN
      RES := 'ERROR: L usuari no existeix en la base de dades';

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU', param_entrada, 'RES: '||RES);
      COMMIT;

	WHEN E_PRIORITAT_NOEXISTEIX  THEN
      RES := 'ERROR: La prioritat no existeix en la base de dades';

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU', param_entrada, 'RES: '||RES);
      COMMIT;	

	WHEN E_DATA_INCIDENCIA_INCORRECTA  THEN
      RES := 'ERROR: La data de la incidncia no pot ser anterior a la data de compra de l equip';

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU', param_entrada, 'RES: '||RES);
      COMMIT;	  
	  
      WHEN E_DATAINCID_IMPOSSIBLE THEN
        RES := 'ERROR: La data de la incidncia no pot ser posterior a la data actual';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU', param_entrada, 'RES: '||RES);
        COMMIT;		  

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);

      RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU', param_entrada, 'RES: '||RES);
      COMMIT;
  END;
							
								
  PROCEDURE PR_BAIXA_MANT_CORRECTIU (p_idequip 		IN MANTENIMENT.idequip%TYPE,
									p_idmanteniment	IN MANTENIMENT.idmanteniment%TYPE,
									RES         	OUT VARCHAR2)
  IS			
   E_CAMP_NUL  EXCEPTION;
   E_MANT_CORRECTIU_NOEXISTEIX EXCEPTION;
   E_MANT_CORRECTIU_JA_BAIXA EXCEPTION;
   E_EQUIP_NOEXISTEIX EXCEPTION;
   E_DATAINCID_IMPOSSIBLE EXCEPTION;

   existeix        VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN

     param_entrada := 'P_IDEQUIP: '||p_idequip||', P_IDMANTENIMENT: '||p_idmanteniment;

     --Verifica que tots els camps obligatoris tenen valor
     IF (TRIM(p_idequip) IS NULL) OR (TRIM(p_idmanteniment) IS NULL)
			THEN
				RAISE E_CAMP_NUL ;
     END IF;

	 --Verifica que l equip existeix en la Base de Dades
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM EQUIP
        WHERE idequip = p_idequip
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_EQUIP_NOEXISTEIX;
     END;
	 
     --Verifica que el manteniment existeix en la Base de Dades
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM MANTENIMENT 
        WHERE idequip = p_idequip
			  AND idmanteniment = p_idmanteniment
			  AND tipusMant = 'CORRECTIU'
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_MANT_CORRECTIU_NOEXISTEIX;
     END;

     --Verifica que el manteniment no est donat de baixa
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM MANTENIMENT
        WHERE idequip = p_idequip
			  AND idmanteniment = p_idmanteniment
			  AND dataBaixa  IS NULL
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_MANT_CORRECTIU_JA_BAIXA;
     END;

     --Si ha passat les proves de validaci realitza l'esborrat lgic del manteniment
     UPDATE MANTENIMENT SET dataBaixa = SYSDATE
     WHERE idequip = p_idequip
			AND idmanteniment = p_idmanteniment;

     RES := 'OK';

     INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
          VALUES(SYSDATE,'PKG_MANTENIMENTS.PR_BAIXA_MANT_CORRECTIU', param_entrada, 'RES: '||RES);
     COMMIT;

  EXCEPTION
      WHEN E_EQUIP_NOEXISTEIX THEN
        RES := 'ERROR: L equip no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_BAIXA_MANT_CORRECTIU', param_entrada, 'RES: '||RES);
        COMMIT;
		
      WHEN E_MANT_CORRECTIU_NOEXISTEIX THEN
        RES := 'ERROR: El manteniment de l equip no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_BAIXA_MANT_CORRECTIU', param_entrada, 'RES: '||RES);
        COMMIT;

      WHEN E_MANT_CORRECTIU_JA_BAIXA THEN
        RES := 'ERROR: El manteniment ja havia estat donat de baixa';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_BAIXA_MANT_CORRECTIU', param_entrada, 'RES: '||RES);
        COMMIT;

      WHEN E_CAMP_NUL  THEN
        RES := 'ERROR: El camp no pot ser nul';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_BAIXA_MANT_CORRECTIU', param_entrada, 'RES: '||RES);
        COMMIT;

      WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);

        RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_BAIXA_MANT_CORRECTIU', param_entrada, 'RES: '||RES);
        COMMIT;
  END;


  PROCEDURE PR_MODIF_MANT_CORRECTIU (p_idequip 		IN MANTENIMENT.idequip%TYPE,
									p_idmanteniment	IN MANTENIMENT.idmanteniment%TYPE,
									p_dataalta     	IN MANTENIMENT.dataAlta%TYPE,
									p_databaixa    	IN MANTENIMENT.dataBaixa%TYPE,
									p_dataIncid		IN MANTCORRECTIU.dataIncid%TYPE,
									p_motiuIncid	IN MANTCORRECTIU.motiuIncid%TYPE,
									p_idusuari 		IN MANTCORRECTIU.idusuari%TYPE,
									p_idprioritat  	IN MANTCORRECTIU.idprioritat%TYPE,
									RES             OUT VARCHAR2)
  IS
   E_CAMP_NUL EXCEPTION;
   E_MANT_CORRECTIU_NOEXISTEIX EXCEPTION;
   E_DATA_BAIXA_INCORRECTA EXCEPTION;
   E_EQUIP_NOEXISTEIX EXCEPTION;
   E_DATA_INCIDENCIA_INCORRECTA EXCEPTION;
   E_USUARI_NOEXISTEIX	EXCEPTION;
   E_PRIORITAT_NOEXISTEIX	EXCEPTION;
   E_DATA_IMPOSSIBLE	EXCEPTION;
   E_DATAINCID_IMPOSSIBLE	EXCEPTION;

   dataCompraEquip EQUIP.dataCompra%TYPE;
   existeix        VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

   BEGIN

     param_entrada := 'P_IDEQUIP: '||p_idequip||', P_IDMANTENIMENT: '||p_idmanteniment||', P_DATAALTA: '||p_dataalta||', P_DATABAIXA: '||p_databaixa||', P_DATAINCID: '||p_dataIncid||', P_MOTIUINCID: '||p_motiuIncid||', P_IDUSUARI: '||p_idusuari||', P_IDPRIORITAT: '||p_idprioritat;

     --Verifica que tots els camps obligatoris tenen valor
     IF (TRIM(p_idequip) IS NULL) OR (TRIM(p_idmanteniment) IS NULL)  
			OR (TRIM(p_dataIncid) IS NULL) OR (TRIM(p_motiuIncid) IS NULL)  
				OR (TRIM(p_idusuari) IS NULL) OR (TRIM(p_idprioritat) IS NULL)
			THEN 
				RAISE E_CAMP_NUL ;
     END IF;
	 
	 --Verifica que l equip existeix en la Base de Dades
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM EQUIP
        WHERE idequip = p_idequip
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_EQUIP_NOEXISTEIX;
     END;
	 
	 --Verifica que l usuari existeix en la Base de Dades
	 IF (p_idusuari IS NOT NULL) THEN
		 BEGIN
			SELECT 'S'
			INTO EXISTEIX
			FROM USUARI
			WHERE idusuari = p_idusuari
				  AND ROWNUM   = 1;
		 EXCEPTION
			WHEN NO_DATA_FOUND THEN
			   RAISE E_USUARI_NOEXISTEIX;
		 END;
	END IF;
	 
	 --Verifica que la prioritat existeix en la Base de Dades
	IF (p_idprioritat IS NOT NULL) THEN	 
			 BEGIN
				SELECT 'S'
				INTO EXISTEIX
				FROM PRIORITAT
				WHERE idprioritat = p_idprioritat
					  AND ROWNUM   = 1;
			 EXCEPTION
				WHEN NO_DATA_FOUND THEN
				   RAISE E_PRIORITAT_NOEXISTEIX;
			 END;	 
	 END IF;

     --Verifica que el manteniment existeix en la Base de Dades
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM MANTENIMENT
        WHERE idequip = p_idequip
			  AND idmanteniment = p_idmanteniment
			  AND tipusMant = 'CORRECTIU'
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_MANT_CORRECTIU_NOEXISTEIX;
     END;
	 
	 --Verifica que la data de la incidncia s posterior a la data de compra de l equip
	 SELECT dataCompra
     INTO dataCompraEquip
     FROM EQUIP
     WHERE idequip = p_idequip;
	 
	 IF (dataCompraEquip IS NOT NULL AND p_dataIncid IS NOT NULL) THEN
		IF (dataCompraEquip > p_dataIncid) THEN
				RAISE E_DATA_INCIDENCIA_INCORRECTA;
		END IF;
	 END IF;
	 
	   --verifica que le data de la incidncia s anterior a la data actual
	   IF (p_dataIncid  IS NOT NULL) THEN
         IF (p_dataIncid > SYSDATE) THEN
             RAISE E_DATAINCID_IMPOSSIBLE;
         END IF;	 
	   END IF;
	   
	 -- si es modifica la data d'alta
	 IF (p_dataalta IS NOT NULL AND p_databaixa IS NOT NULL) THEN
		IF (p_dataalta > p_databaixa) THEN
				RAISE E_DATA_BAIXA_INCORRECTA;
		END IF;
	 END IF;
	 
	   --verifica que les dates sn anteriors a la data actual
       IF (p_dataalta IS NOT NULL OR p_databaixa IS NOT NULL) THEN
         IF (p_dataalta > SYSDATE) OR (p_databaixa > SYSDATE) THEN
             RAISE E_DATA_IMPOSSIBLE;
         END IF;
       END IF;		 
    
     --Si es passen les proves de validaci actualitzem            
     UPDATE MANTENIMENT
        SET dataAlta = nvl(p_dataalta, dataAlta),
			dataBaixa = nvl(p_databaixa, dataBaixa)
     WHERE  idequip = p_idequip
			AND idmanteniment = p_idmanteniment;
     COMMIT;
	 
     UPDATE MANTCORRECTIU
        SET dataIncid = nvl(p_dataIncid, dataIncid),
			motiuIncid = nvl(p_motiuIncid, motiuIncid),
			idusuari = nvl(p_idusuari, idusuari),
			idprioritat = nvl(p_idprioritat, idprioritat)
     WHERE  idequip = p_idequip
			AND idmanteniment = p_idmanteniment;
     COMMIT;

     RES:= 'OK';

     INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE,'PKG_MANTENIMENTS.PR_MODIF_MANT_CORRECTIU', param_entrada, 'RES: '||RES);
     COMMIT;

   EXCEPTION
      WHEN E_MANT_CORRECTIU_NOEXISTEIX THEN
        RES := 'ERROR: El manteniment de l equip no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_MANT_CORRECTIU', param_entrada, 'RES: '||RES);
        COMMIT;
		
      WHEN E_EQUIP_NOEXISTEIX THEN
        RES := 'ERROR: L equip no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_MANT_CORRECTIU', param_entrada, 'RES: '||RES);
        COMMIT;	
		
	WHEN E_USUARI_NOEXISTEIX  THEN
      RES := 'ERROR: L usuari no existeix en la base de dades';

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_MANT_CORRECTIU', param_entrada, 'RES: '||RES);
      COMMIT;

	WHEN E_PRIORITAT_NOEXISTEIX  THEN
      RES := 'ERROR: La prioritat no existeix en la base de dades';

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_MANT_CORRECTIU', param_entrada, 'RES: '||RES);
      COMMIT;		

		WHEN E_DATA_INCIDENCIA_INCORRECTA  THEN
		  RES := 'ERROR: La data de la incidncia no pot ser anterior a la data de compra de l equip';

		  INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
			 VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_MANT_CORRECTIU', param_entrada, 'RES: '||RES);
		  COMMIT;		

      WHEN E_CAMP_NUL  THEN
        RES := 'ERROR: El camp no pot ser nul';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_MANT_CORRECTIU', param_entrada, 'RES: '||RES);
        COMMIT;

      WHEN E_DATA_BAIXA_INCORRECTA THEN
        RES := 'ERROR: La data d alta no pot ser posterior a la data de baixa';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_MANT_CORRECTIU', param_entrada, 'RES: '||RES);
        COMMIT;
		
      WHEN E_DATAINCID_IMPOSSIBLE THEN
        RES := 'ERROR: La data de la incidncia no pot ser posterior a la data actual';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_MANT_CORRECTIU', param_entrada, 'RES: '||RES);
        COMMIT;			
		
      WHEN E_DATA_IMPOSSIBLE THEN
        RES := 'ERROR: La data d alta o la data de baixa no poden ser posteriors a la data actual';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_MANT_CORRECTIU', param_entrada, 'RES: '||RES);
        COMMIT;			

     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);

        RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_MANT_CORRECTIU', param_entrada, 'RES: '||RES);
        COMMIT;
  END;


  /***************************************************
  *  MANTENIMENT RESOLUCIONS MANTENIMENTS CORRECTIUS
  ****************************************************/ 															
  PROCEDURE PR_ALTA_RESOLUCIO_MANTCORR (p_idequip 		IN RESOLUCIOMANT.idequip%TYPE,
										p_idmanteniment	IN RESOLUCIOMANT.idmanteniment%TYPE,
										p_idempresa		IN RESOLUCIOMANT.idempresa%TYPE,
										p_idoperari 	IN RESOLUCIOMANT.idoperari%TYPE,
										p_dataInici		IN RESOLUCIOMANT.dataInici%TYPE,
										p_dataFi 		IN RESOLUCIOMANT.dataFi%TYPE,
										p_observacions 	IN RESOLUCIOMANT.observacions%TYPE,
										RES 			OUT VARCHAR2)
  IS						
   E_CAMP_NUL         	EXCEPTION;
   E_RESOLUCIO_MANTCORR_EXISTEIX     EXCEPTION;
   E_DATA_RESOLUCIO_INCORRECTA  EXCEPTION;
   E_TERMINI_RESOLUCIO_INCORRECTA  EXCEPTION;
   E_EQUIP_NOEXISTEIX EXCEPTION;
   E_MANT_CORRECTIU_NOEXISTEIX EXCEPTION;
   E_EMPRESA_NOEXISTEIX EXCEPTION;
   E_OPERARI_NOEXISTEIX EXCEPTION;
   E_OPERARI_INCORRECTE EXCEPTION;
   E_DATA_IMPOSSIBLE EXCEPTION;

   dataIncidEquip MANTCORRECTIU.dataIncid%TYPE;
   existeix      VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN

     param_entrada := 'P_IDEQUIP: '||p_idequip||', P_IDMANTENIMENT: '||p_idmanteniment||', P_IDEMPRESA: '||p_idempresa||', P_IDOPERARI: '||p_idoperari||', P_DATAINICI: '||p_dataInici||', P_DATAFI: '||p_dataFi||', P_OBSERVACIONS: '||p_observacions;

     --Verifica que tots els camps obligatoris tenen valor
     IF (TRIM(p_idequip) IS NULL) OR (TRIM(p_idmanteniment) IS NULL) OR (TRIM(p_idempresa) IS NULL)  
				OR (TRIM(p_idoperari) IS NULL) OR (TRIM(p_dataInici) IS NULL) OR (TRIM(p_dataFi) IS NULL)
			THEN 
				RAISE E_CAMP_NUL ;
     END IF;
	 
	 --Verifica que l equip existeix en la Base de Dades
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM EQUIP
        WHERE idequip = p_idequip
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_EQUIP_NOEXISTEIX;
     END;
	 
	 --Verifica que el manteniment existeix en la Base de Dades
	 BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM MANTENIMENT
        WHERE idequip = p_idequip
			  AND idmanteniment = p_idmanteniment
			  AND tipusMant = 'CORRECTIU'
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_MANT_CORRECTIU_NOEXISTEIX;
     END;
	 

     --Verifica que el registre no s'hagi inserit previament
     BEGIN
        SELECT 'S'
        INTO EXISTEIX
        FROM RESOLUCIOMANT
        WHERE idequip = p_idequip
			  AND idmanteniment = p_idmanteniment
			  AND ROWNUM  = 1;

        RAISE E_RESOLUCIO_MANTCORR_EXISTEIX;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           NULL;
     END;
	 
			 --Verifica que l empresa existeix en la base de dades
			 BEGIN
				SELECT 'S'
				INTO EXISTEIX
				FROM EMPRESA
				WHERE idempresa = p_idempresa
					  AND ROWNUM   = 1;
			 EXCEPTION
				WHEN NO_DATA_FOUND THEN
				   RAISE E_EMPRESA_NOEXISTEIX;
			 END;	 
			 
			 --Verifica que l operari existeix en la base de dades
			 BEGIN
				SELECT 'S'
				INTO EXISTEIX
				FROM OPERARI
				WHERE idoperari = p_idoperari
					  AND ROWNUM   = 1;
			 EXCEPTION
				WHEN NO_DATA_FOUND THEN
				   RAISE E_OPERARI_NOEXISTEIX;
			 END;	 
			 
			 --Verifica que l operari pertany a l empresa
			 BEGIN
				SELECT 'S'
				INTO EXISTEIX
				FROM OPERARI
				WHERE idoperari = p_idoperari
					  and idempresa = p_idempresa
					  AND ROWNUM   = 1;
			 EXCEPTION
				WHEN NO_DATA_FOUND THEN
				   RAISE E_OPERARI_INCORRECTE;
			 END;	
	 
	 
	 --Verifica que la data de fi de resolucio s posterior a la data d'inici de la resolucio 
	 IF (p_dataInici IS NOT NULL AND p_dataFi IS NOT NULL) THEN
		IF (p_dataInici > p_dataFi) THEN
				RAISE E_TERMINI_RESOLUCIO_INCORRECTA;
		END IF;
	 END IF;
	 
	 --Verifica que la data d inici de resolucio no s anterior a la data de la incidncia
	 SELECT dataIncid
     INTO dataIncidEquip
     FROM MANTCORRECTIU
     WHERE idequip = p_idequip
			AND idmanteniment = p_idmanteniment;
	 
	 IF (dataIncidEquip IS NOT NULL AND p_dataInici IS NOT NULL) THEN
		IF (dataIncidEquip > p_dataInici) THEN
				RAISE E_DATA_RESOLUCIO_INCORRECTA;
		END IF;
	 END IF;
	 
	  --verifica que les dates sn anteriors a la data actual
       IF (p_dataInici IS NOT NULL OR p_dataFi IS NOT NULL) THEN
         IF (p_dataInici > SYSDATE) OR (p_dataFi > SYSDATE) THEN
             RAISE E_DATA_IMPOSSIBLE;
         END IF;
       END IF;

     --Si ha passat les proves de validaci realitza la inserci
     INSERT INTO RESOLUCIOMANT (idequip,idmanteniment,idempresa,idoperari,dataInici,dataFi,observacions)
          VALUES (p_idequip,p_idmanteniment,p_idempresa,p_idoperari,p_dataInici,p_dataFi,p_observacions);

     RES := 'OK';
  
     INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
          VALUES(SYSDATE,'PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR', param_entrada, 'RES: '||RES);
     COMMIT;

  EXCEPTION
    WHEN E_RESOLUCIO_MANTCORR_EXISTEIX THEN
      RES := 'ERROR: la resolucio ja ha estat donada d alta';

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR', param_entrada, 'RES: '||RES);
      COMMIT;

    WHEN E_CAMP_NUL  THEN
      RES := 'ERROR: El camp no pot ser nul';

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR', param_entrada, 'RES: '||RES);
      COMMIT;
	  
	  WHEN E_EQUIP_NOEXISTEIX  THEN
        RES := 'ERROR: L equip no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR', param_entrada, 'RES: '||RES);
        COMMIT;	
		
      WHEN E_MANT_CORRECTIU_NOEXISTEIX THEN
        RES := 'ERROR: El manteniment no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR', param_entrada, 'RES: '||RES);
        COMMIT;			
		
	  WHEN E_EMPRESA_NOEXISTEIX  THEN
        RES := 'ERROR: L empresa no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR', param_entrada, 'RES: '||RES);
        COMMIT;		

	  WHEN E_OPERARI_NOEXISTEIX  THEN
        RES := 'ERROR: L operari no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR', param_entrada, 'RES: '||RES);
        COMMIT;			
		
      WHEN E_OPERARI_INCORRECTE THEN
        RES := 'ERROR: l operari no pertany a l empresa';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR', param_entrada, 'RES: '||RES);
        COMMIT;	  
	  
	WHEN E_TERMINI_RESOLUCIO_INCORRECTA  THEN
	  RES := 'ERROR: La data de fi de resolucio no pot ser anterior a la data d inici de resolucio';

	  INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
		 VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR', param_entrada, 'RES: '||RES);
	  COMMIT;	  
	  
	WHEN E_DATA_RESOLUCIO_INCORRECTA  THEN
	  RES := 'ERROR: La data d inici de resolucio no pot ser anterior a la data de la incidncia';

	  INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
		 VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR', param_entrada, 'RES: '||RES);
	  COMMIT;	  
	  
      WHEN E_DATA_IMPOSSIBLE THEN
        RES := 'ERROR: La data d inici o la data fi no poden ser posteriors a la data actual';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR', param_entrada, 'RES: '||RES);
        COMMIT;		  

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);

      RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR', param_entrada, 'RES: '||RES);
      COMMIT;
  END;
								
								
  PROCEDURE PR_BAIXA_RESOLUCIO_MANTCORR (p_idequip 		IN RESOLUCIOMANT.idequip%TYPE,
										p_idmanteniment	IN RESOLUCIOMANT.idmanteniment%TYPE,
										RES         	OUT VARCHAR2)
  IS			
   E_CAMP_NUL  EXCEPTION;
   E_RESOLUCIO_MANCORR_NOEXISTEIX EXCEPTION;
   E_RESOLUCIO_MANTCORR_JA_BAIXA EXCEPTION;

   existeix      VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN

     param_entrada := 'P_IDEQUIP: '||p_idequip||', P_IDMANTENIMENT: '||p_idmanteniment;

     --Verifica que tots els camps obligatoris tenen valor
     IF (TRIM(p_idequip) IS NULL) OR (TRIM(p_idmanteniment) IS NULL)
			THEN
				RAISE E_CAMP_NUL ;
     END IF;

     --Verifica que la resolucio existeix en la Base de Dades
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM RESOLUCIOMANT 
        WHERE idequip = p_idequip
			  AND idmanteniment = p_idmanteniment
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_RESOLUCIO_MANCORR_NOEXISTEIX;
     END;

     --Verifica que la resolucio del manteniment no est donada de baixa
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM RESOLUCIOMANT
        WHERE idequip = p_idequip
			  AND idmanteniment = p_idmanteniment
			  AND dataBaixa  IS NULL
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_RESOLUCIO_MANTCORR_JA_BAIXA;
     END;

     --Si ha passat les proves de validaci realitza l'esborrat lgic del manteniment
     UPDATE RESOLUCIOMANT SET dataBaixa = SYSDATE
     WHERE idequip = p_idequip
			AND idmanteniment = p_idmanteniment;

     RES := 'OK';

     INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
          VALUES(SYSDATE,'PKG_MANTENIMENTS.PR_BAIXA_RESOLUCIO_MANTCORR', param_entrada, 'RES: '||RES);
     COMMIT;

  EXCEPTION
      WHEN E_RESOLUCIO_MANCORR_NOEXISTEIX THEN
        RES := 'ERROR: La resolucio a donar de baixa no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_BAIXA_RESOLUCIO_MANTCORR', param_entrada, 'RES: '||RES);
        COMMIT;

      WHEN E_RESOLUCIO_MANTCORR_JA_BAIXA THEN
        RES := 'ERROR: La resolucio ja havia estat donada de baixa';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_BAIXA_RESOLUCIO_MANTCORR', param_entrada, 'RES: '||RES);
        COMMIT;

      WHEN E_CAMP_NUL  THEN
        RES := 'ERROR: El camp no pot ser nul';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_BAIXA_RESOLUCIO_MANTCORR', param_entrada, 'RES: '||RES);
        COMMIT;

      WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);

        RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_BAIXA_RESOLUCIO_MANTCORR', param_entrada, 'RES: '||RES);
        COMMIT;
  END;


  PROCEDURE PR_MODIF_RESOLUCIO_MANTCORR (p_idequip 		IN RESOLUCIOMANT.idequip%TYPE,
										p_idmanteniment	IN RESOLUCIOMANT.idmanteniment%TYPE,
										p_idempresa		IN RESOLUCIOMANT.idempresa%TYPE,
										p_idoperari 	IN RESOLUCIOMANT.idoperari%TYPE,
										p_dataInici		IN RESOLUCIOMANT.dataInici%TYPE,
										p_dataFi 		IN RESOLUCIOMANT.dataFi%TYPE,
										p_observacions 	IN RESOLUCIOMANT.observacions%TYPE,
										p_dataalta     	IN RESOLUCIOMANT.dataAlta%TYPE,
										p_databaixa    	IN RESOLUCIOMANT.dataBaixa%TYPE,
										RES             OUT VARCHAR2)
  IS
   E_CAMP_NUL             EXCEPTION;
   E_DATA_BAIXA_INCORRECTA EXCEPTION;
   E_DATA_RESOLUCIO_INCORRECTA  EXCEPTION;
   E_TERMINI_RESOLUCIO_INCORRECTA  EXCEPTION;
   E_EQUIP_NOEXISTEIX EXCEPTION;
   E_MANT_CORRECTIU_NOEXISTEIX EXCEPTION;
   E_RESOLUCIO_MANCORR_NOEXISTEIX EXCEPTION;
   E_EMPRESA_NOEXISTEIX EXCEPTION;
   E_OPERARI_NOEXISTEIX EXCEPTION;
   E_OPERARI_INCORRECTE EXCEPTION;
   E_DATA_IMPOSSIBLE EXCEPTION;
   E_DATA2_IMPOSSIBLE EXCEPTION;

   vidempresa 		RESOLUCIOMANT.idempresa%TYPE;
   vdatainici		RESOLUCIOMANT.dataInici%TYPE;
   vdatafi			RESOLUCIOMANT.dataFi%TYPE;
   dataIncidEquip MANTCORRECTIU.dataIncid%TYPE;
   existeix        	VARCHAR2(1);
   param_entrada 	VARCHAR2(500);
   err_num       	NUMBER;
   err_msg       	VARCHAR2(100);

   BEGIN

     param_entrada := 'P_IDEQUIP: '||p_idequip||', P_IDMANTENIMENT: '||p_idmanteniment||', P_IDEMPRESA: '||p_idempresa||', P_IDOPERARI: '||p_idoperari||', P_DATAINICI: '||p_dataInici||', P_DATAFI: '||p_dataFi||', P_OBSERVACIONS: '||p_observacions||', P_DATAALTA: '||p_dataalta||', P_DATABAIXA: '||p_databaixa;

     --Verifica que tots els camps obligatoris tenen valor
	 --en aquest cas noms els camps que formen part de la clau primaria,
	 --noms es modifiquen els camps que no sn NULL i tenen algun valor, 
	 --els camps NULL es deixen amb el valor antic
     IF (TRIM(p_idequip) IS NULL) OR (TRIM(p_idmanteniment) IS NULL) 
			--OR (TRIM(p_idempresa) IS NULL) OR (TRIM(p_idoperari) IS NULL) 
				--OR (TRIM(p_dataInici) IS NULL) OR (TRIM(p_dataFi) IS NULL)  
			THEN 
				RAISE E_CAMP_NUL ;
     END IF;

	 --Verifica que l equip existeix en la Base de Dades
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM EQUIP
        WHERE idequip = p_idequip
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_EQUIP_NOEXISTEIX;
     END;
	 
	 --Verifica que el manteniment existeix en la Base de Dades
	 BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM MANTENIMENT
        WHERE idequip = p_idequip
			  AND idmanteniment = p_idmanteniment
			  AND tipusMant = 'CORRECTIU'
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_MANT_CORRECTIU_NOEXISTEIX;
     END;
	 
	 BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM MANTCORRECTIU
        WHERE idequip = p_idequip
			  AND idmanteniment = p_idmanteniment
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_MANT_CORRECTIU_NOEXISTEIX;
     END;
	 
	 
     --Verifica que la resolucio existeix en la Base de Dades
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM RESOLUCIOMANT
        WHERE idequip = p_idequip
			  AND idmanteniment = p_idmanteniment
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_RESOLUCIO_MANCORR_NOEXISTEIX;
     END;
	 
	 --Verifica que l empresa existeix en la base de dades
	 IF (p_idempresa IS NOT NULL) THEN
		 BEGIN
			SELECT 'S'
			INTO EXISTEIX
			FROM EMPRESA
			WHERE idempresa = p_idempresa
				  AND ROWNUM   = 1;
		 EXCEPTION
			WHEN NO_DATA_FOUND THEN
			   RAISE E_EMPRESA_NOEXISTEIX;
		 END;	 
	 END IF;
	 
	 --Verifica que l operari existeix en la base de dades
	 IF (p_idoperari IS NOT NULL) THEN
		 BEGIN
			SELECT 'S'
			INTO EXISTEIX
			FROM OPERARI
			WHERE idoperari = p_idoperari
				  AND ROWNUM   = 1;
		 EXCEPTION
			WHEN NO_DATA_FOUND THEN
			   RAISE E_OPERARI_NOEXISTEIX;
		 END;	 
	 END IF;
	 
	 --Verifica que l operari pertany a l empresa
	 IF (p_idoperari IS NOT NULL) THEN
		IF (p_idempresa IS NOT NULL) THEN
			 BEGIN
				SELECT 'S'
				INTO EXISTEIX
				FROM OPERARI
				WHERE idoperari = p_idoperari
					  and idempresa = p_idempresa
					  AND ROWNUM   = 1;
			 EXCEPTION
				WHEN NO_DATA_FOUND THEN
				   RAISE E_OPERARI_INCORRECTE;
			 END;	
		ELSE 
			SELECT idempresa
			INTO vidempresa
			FROM RESOLUCIOMANT
			WHERE  idequip = p_idequip
					AND idmanteniment = p_idmanteniment
					AND ROWNUM   = 1;

			 BEGIN
				SELECT 'S'
				INTO EXISTEIX
				FROM OPERARI
				WHERE idoperari = p_idoperari
					  and idempresa = vidempresa
					  AND ROWNUM   = 1;
			 EXCEPTION
				WHEN NO_DATA_FOUND THEN
				   RAISE E_OPERARI_INCORRECTE;
			 END;	
		END IF;
	 END IF;
	 
	 --Verifica que la data de fi de resolucio s posterior a la data d'inici de la resolucio 
		IF (p_dataInici IS NOT NULL) AND (p_dataFi IS NOT NULL) THEN
				IF (p_dataInici > p_dataFi) THEN
						RAISE E_TERMINI_RESOLUCIO_INCORRECTA;
				END IF;
		END IF;
		IF (p_dataInici IS NOT NULL) AND (p_dataFi IS NULL) THEN
			SELECT dataFi
			INTO vdataFi
			FROM RESOLUCIOMANT
			WHERE  idequip = p_idequip
					AND idmanteniment = p_idmanteniment
					AND ROWNUM   = 1;
					
			IF (p_dataInici > vdataFi) THEN
					RAISE E_TERMINI_RESOLUCIO_INCORRECTA;
			END IF;
		END IF;
		IF (p_dataInici IS NULL) AND (p_dataFi IS NOT NULL) THEN
			SELECT dataInici
			INTO vdataInici
			FROM RESOLUCIOMANT
			WHERE  idequip = p_idequip
					AND idmanteniment = p_idmanteniment
					AND ROWNUM   = 1;
					
			IF (vdataInici > p_dataFi) THEN
					RAISE E_TERMINI_RESOLUCIO_INCORRECTA;
			END IF;
		END IF;		
	 
	 --Verifica que la data d inici de resolucio no s anterior a la data de la incidncia
	 SELECT dataIncid
     INTO dataIncidEquip
     FROM MANTCORRECTIU
     WHERE idequip = p_idequip
			AND idmanteniment = p_idmanteniment;
	 
	 IF (dataIncidEquip IS NOT NULL AND p_dataInici IS NOT NULL) THEN
		IF (dataIncidEquip > p_dataInici) THEN
				RAISE E_DATA_RESOLUCIO_INCORRECTA;
		END IF;
	 END IF;
	  
	 --Verifica que la data de fi de resolucio s posterior a la data d'inici de la resolucio 
	 IF (p_dataInici IS NOT NULL AND p_dataFi IS NOT NULL) THEN
		IF (p_dataInici > p_dataFi) THEN
				RAISE E_TERMINI_RESOLUCIO_INCORRECTA;
		END IF;
	 END IF;
	 
	 -- si es modifica la data d'alta
	 IF (p_dataalta IS NOT NULL AND p_databaixa IS NOT NULL) THEN
		IF (p_dataalta > p_databaixa) THEN
				RAISE E_DATA_BAIXA_INCORRECTA;
		END IF;
	 END IF;
	 
	 --verifica que les dates sn anteriors a la data actual
       IF (p_dataalta IS NOT NULL OR p_databaixa IS NOT NULL) THEN
         IF (p_dataalta > SYSDATE) OR (p_databaixa > SYSDATE) THEN
             RAISE E_DATA_IMPOSSIBLE;
         END IF;
       END IF;
	   
	  --verifica que les dates sn anteriors a la data actual
       IF (p_dataInici IS NOT NULL OR p_dataFi IS NOT NULL) THEN
         IF (p_dataInici > SYSDATE) OR (p_dataFi > SYSDATE) THEN
             RAISE E_DATA2_IMPOSSIBLE;
         END IF;
       END IF;	   
    
     --Si es passen les proves de validaci actualitzem            
     UPDATE RESOLUCIOMANT
        SET idempresa = nvl(p_idempresa, idempresa),
			idoperari = nvl(p_idoperari, idoperari),
			dataInici = nvl(p_dataInici, dataInici),
			dataFi = nvl(p_dataFi, dataFi),
			observacions = nvl(p_observacions, observacions),
			dataAlta = nvl(p_dataalta, dataAlta),
			dataBaixa = nvl(p_databaixa, dataBaixa)
     WHERE  idequip = p_idequip
			AND idmanteniment = p_idmanteniment;
     COMMIT;

     RES:= 'OK';

     INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE,'PKG_MANTENIMENTS.PR_MODIF_RESOLUCIO_MANTCORR', param_entrada, 'RES: '||RES);
     COMMIT;

   EXCEPTION
      WHEN E_CAMP_NUL  THEN
        RES := 'ERROR: El camp no pot ser nul';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_RESOLUCIO_MANTCORR', param_entrada, 'RES: '||RES);
        COMMIT;

	  WHEN E_EQUIP_NOEXISTEIX  THEN
        RES := 'ERROR: L equip no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_RESOLUCIO_MANTCORR', param_entrada, 'RES: '||RES);
        COMMIT;	
		
      WHEN E_MANT_CORRECTIU_NOEXISTEIX THEN
        RES := 'ERROR: El manteniment no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_RESOLUCIO_MANTCORR', param_entrada, 'RES: '||RES);
        COMMIT;			
		
      WHEN E_RESOLUCIO_MANCORR_NOEXISTEIX THEN
        RES := 'ERROR: La resolucio a modificar no existeix';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_RESOLUCIO_MANTCORR', param_entrada, 'RES: '||RES);
        COMMIT;		
		
	  WHEN E_EMPRESA_NOEXISTEIX  THEN
        RES := 'ERROR: L empresa no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_RESOLUCIO_MANTCORR', param_entrada, 'RES: '||RES);
        COMMIT;		

	  WHEN E_OPERARI_NOEXISTEIX  THEN
        RES := 'ERROR: L operari no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_RESOLUCIO_MANTCORR', param_entrada, 'RES: '||RES);
        COMMIT;			
		
      WHEN E_OPERARI_INCORRECTE THEN
        RES := 'ERROR: l operari no pertany a l empresa';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_RESOLUCIO_MANTCORR', param_entrada, 'RES: '||RES);
        COMMIT;	  
	  	
      WHEN E_DATA_BAIXA_INCORRECTA THEN
        RES := 'ERROR: La data d alta no pot ser posterior a la data de baixa';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_RESOLUCIO_MANTCORR', param_entrada, 'RES: '||RES);
        COMMIT;
		
	WHEN E_TERMINI_RESOLUCIO_INCORRECTA  THEN
	  RES := 'ERROR: La data de fi de resolucio no pot ser anterior a la data d inici de resolucio';

	  INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
		 VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_RESOLUCIO_MANTCORR', param_entrada, 'RES: '||RES);
	  COMMIT;	  
	  
	WHEN E_DATA_RESOLUCIO_INCORRECTA  THEN
	  RES := 'ERROR: La data d inici de resolucio no pot ser anterior a la data de la incidncia';

	  INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
		 VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_RESOLUCIO_MANTCORR', param_entrada, 'RES: '||RES);
	  COMMIT;		

      WHEN E_DATA_IMPOSSIBLE THEN
        RES := 'ERROR: La data d alta o la data de baixa no poden ser posteriors a la data actual';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_RESOLUCIO_MANTCORR', param_entrada, 'RES: '||RES);
        COMMIT;		

      WHEN E_DATA2_IMPOSSIBLE THEN
        RES := 'ERROR: La data d inici o la data fi de la resolucio no poden ser posteriors a la data actual';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_RESOLUCIO_MANTCORR', param_entrada, 'RES: '||RES);
        COMMIT;			

     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);

        RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_RESOLUCIO_MANTCORR', param_entrada, 'RES: '||RES);
        COMMIT;
  END;
									
									
  /**************************************
  *  MANTENIMENT MANTENIMENTS PREVENTIUS
  **************************************/   
  FUNCTION FN_OBTENIR_ULTIM_MANPREV_EQUIP(p_idequip MANTENIMENT.idequip%TYPE)
  /* precondicio: l'equip existeix ------i t manteniments preventius 
     retorna 0 si l equip no en t de manteniments preventius
  */
  RETURN MANTENIMENT.idmanteniment%TYPE  
  IS
	idmant MANTENIMENT.idmanteniment%TYPE;
	q integer;
  BEGIN
	  SELECT count(*) as d  
	  INTO q
	  FROM MANTENIMENT
	  WHERE p_idequip = idequip
		    AND tipusMant = 'PREVENTIU';

	  IF (q > 0) THEN
		  SELECT MAX(idmanteniment) 
			INTO idmant
		  FROM MANTENIMENT
		  WHERE p_idequip = idequip
				AND tipusMant = 'PREVENTIU'
				--AND dataBaixa IS NULL
				;
		  RETURN idmant;
	  ELSE 
		  RETURN 0;  --si no t manteniments retorna 0
	  END IF;
  END;

  
  PROCEDURE PR_ALTA_MANT_PREVENTIU (p_idequip 			IN MANTENIMENT.idequip%TYPE,
									p_dataInici			IN MANTPREVENTIU.dataInici%TYPE,
									p_dataFi			IN MANTPREVENTIU.dataFi%TYPE,
									p_periodicitatMesos	IN MANTPREVENTIU.periodicitatMesos%TYPE,
									RES 				OUT VARCHAR2)
  IS
   E_CAMP_NUL   EXCEPTION;
   E_EQUIP_NOEXISTEIX EXCEPTION;
   E_TERMINI_CONTRACTE_INCORRECTE	EXCEPTION;
   E_DATA_INICI_INCORRECTA	EXCEPTION;
   E_MANTPREV_JAEXISTEIX	EXCEPTION;
   
   p_idmant		MANTENIMENT.idmanteniment%TYPE;
   dataCompraEquip EQUIP.dataCompra%TYPE;   
   existeix      VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN

     param_entrada := 'P_IDEQUIP: '||p_idequip||', P_DATAINICI: '||p_dataInici||', P_DATAFI: '||p_dataFi||', P_PERIODICITATMESOS: '||p_periodicitatMesos;

     --Verifica que tots els camps obligatoris tenen valor
     IF (TRIM(p_idequip) IS NULL) OR (TRIM(p_dataInici) IS NULL) OR (TRIM(p_dataFi) IS NULL)  
				OR (TRIM(p_periodicitatMesos) IS NULL) 
			THEN 
				RAISE E_CAMP_NUL ;
     END IF;
	 
	 --Verifica que l equip existeix en la Base de Dades
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM EQUIP
        WHERE idequip = p_idequip
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_EQUIP_NOEXISTEIX;
     END;	 
	 
	 --Verifica que la data de fi del contracte s posterior a la data d'inici del contracte 
	 IF (p_dataInici IS NOT NULL AND p_dataFi IS NOT NULL) THEN
		IF (p_dataInici > p_dataFi) THEN
				RAISE E_TERMINI_CONTRACTE_INCORRECTE;
		END IF;
	 END IF;	 
	 
	 --Verifica que la data d inici del contracte s posterior a la data de compra de l equip
	 SELECT dataCompra
     INTO dataCompraEquip
     FROM EQUIP
     WHERE idequip = p_idequip;
	 
	 IF (dataCompraEquip IS NOT NULL AND p_dataInici IS NOT NULL) THEN
		IF (dataCompraEquip > p_dataInici) THEN
				RAISE E_DATA_INICI_INCORRECTA;
		END IF;
	 END IF;	 
	 
	 --Verifica que no existeix cap altre manteniment que es puguin cavalcar les dates
	 BEGIN
		 SELECT 'S'
		   INTO EXISTEIX
		 FROM DUAL
		 WHERE not exists (select *
							from mantpreventiu
							where idequip = p_idequip
								  AND (p_dataInici between dataInici and dataFi
								  OR p_dataFi between dataInici and dataFi))
		  ;
	 EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_MANTPREV_JAEXISTEIX;
     END;
 
     --Si ha passat les proves de validaci realitza la inserci
	 --recordem que en donar d'alta un manteniment preventiu
	 --automaticament tamb es dna d'alta la primera revisi pendent
	 --mitjanant un trigger
     INSERT INTO MANTENIMENT (idequip,tipusMant)
          VALUES (p_idequip,'PREVENTIU');
	 COMMIT;
	 
	 p_idmant := FN_OBTENIR_ULTIM_MANPREV_EQUIP(p_idequip);
		  
     INSERT INTO MANTPREVENTIU (idequip,idmanteniment,dataInici,dataFi,periodicitatMesos)
          VALUES (p_idequip,p_idmant,p_dataInici,p_dataFi,p_periodicitatMesos);
		  
     RES := 'OK';
  
     INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
          VALUES(SYSDATE,'PKG_MANTENIMENTS.PR_ALTA_MANT_PREVENTIU', param_entrada, 'RES: '||RES);
     COMMIT;

  EXCEPTION
    WHEN E_CAMP_NUL  THEN
      RES := 'ERROR: El camp no pot ser nul';

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_MANT_PREVENTIU', param_entrada, 'RES: '||RES);
      COMMIT;
	  
	WHEN E_EQUIP_NOEXISTEIX  THEN
      RES := 'ERROR: L equip no existeix en la base de dades';

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_MANT_PREVENTIU', param_entrada, 'RES: '||RES);
      COMMIT;	

	WHEN E_DATA_INICI_INCORRECTA  THEN
      RES := 'ERROR: La data d inici del contracte no pot ser anterior a la data de compra de l equip';

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_MANT_PREVENTIU', param_entrada, 'RES: '||RES);
      COMMIT;	

	WHEN E_TERMINI_CONTRACTE_INCORRECTE  THEN
      RES := 'ERROR: La data d inici del contracte no pot ser posterior a la data de fi del contracte';

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_MANT_PREVENTIU', param_entrada, 'RES: '||RES);
      COMMIT;	

	WHEN E_MANTPREV_JAEXISTEIX  THEN
      RES := 'ERROR: L equip ja t un manteniment preventiu per aquestes dates';

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_MANT_PREVENTIU', param_entrada, 'RES: '||RES);
      COMMIT;	  

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);

      RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_MANT_PREVENTIU', param_entrada, 'RES: '||RES);
      COMMIT;
  END;
								
								
  PROCEDURE PR_BAIXA_MANT_PREVENTIU (p_idequip 		IN MANTENIMENT.idequip%TYPE,
									p_idmanteniment	IN MANTENIMENT.idmanteniment%TYPE,
									RES         	OUT VARCHAR2)
  IS			
   E_CAMP_NUL  EXCEPTION;
   E_MANT_PREVENTIU_NOEXISTEIX EXCEPTION;
   E_MANT_PREVENTIU_JA_BAIXA EXCEPTION;
   E_EQUIP_NOEXISTEIX EXCEPTION;

   existeix        VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN

     param_entrada := 'P_IDEQUIP: '||p_idequip||', P_IDMANTENIMENT: '||p_idmanteniment;

     --Verifica que tots els camps obligatoris tenen valor
     IF (TRIM(p_idequip) IS NULL) OR (TRIM(p_idmanteniment) IS NULL)
			THEN
				RAISE E_CAMP_NUL ;
     END IF;
	 
	 --Verifica que l equip existeix en la Base de Dades
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM EQUIP
        WHERE idequip = p_idequip
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_EQUIP_NOEXISTEIX;
     END;		 

     --Verifica que el manteniment existeix en la Base de Dades
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM MANTENIMENT 
        WHERE idequip = p_idequip
			  AND idmanteniment = p_idmanteniment
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_MANT_PREVENTIU_NOEXISTEIX;
     END;

     --Verifica que el manteniment no est donat de baixa
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM MANTENIMENT
        WHERE idequip = p_idequip
			  AND idmanteniment = p_idmanteniment
			  AND dataBaixa  IS NULL
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_MANT_PREVENTIU_JA_BAIXA;
     END;

     --Si ha passat les proves de validaci realitza l'esborrat lgic del manteniment
     UPDATE MANTENIMENT SET dataBaixa = SYSDATE
     WHERE idequip = p_idequip
			AND idmanteniment = p_idmanteniment;

     RES := 'OK';

     INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
          VALUES(SYSDATE,'PKG_MANTENIMENTS.PR_BAIXA_MANT_PREVENTIU', param_entrada, 'RES: '||RES);
     COMMIT;

  EXCEPTION
      WHEN E_MANT_PREVENTIU_NOEXISTEIX THEN
        RES := 'ERROR: El manteniment a donar de baixa no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_BAIXA_MANT_PREVENTIU', param_entrada, 'RES: '||RES);
        COMMIT;

      WHEN E_MANT_PREVENTIU_JA_BAIXA THEN
        RES := 'ERROR: El manteniment ja havia estat donat de baixa';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_BAIXA_MANT_PREVENTIU', param_entrada, 'RES: '||RES);
        COMMIT;

      WHEN E_CAMP_NUL  THEN
        RES := 'ERROR: El camp no pot ser nul';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_BAIXA_MANT_PREVENTIU', param_entrada, 'RES: '||RES);
        COMMIT;
		
	  WHEN E_EQUIP_NOEXISTEIX  THEN
        RES := 'ERROR: L equip no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_BAIXA_MANT_PREVENTIU', param_entrada, 'RES: '||RES);
        COMMIT;		

      WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);

        RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_BAIXA_MANT_PREVENTIU', param_entrada, 'RES: '||RES);
        COMMIT;
  END;


  PROCEDURE PR_MODIF_MANT_PREVENTIU (p_idequip 			IN MANTENIMENT.idequip%TYPE,
									p_idmanteniment		IN MANTENIMENT.idmanteniment%TYPE,
									p_dataalta     		IN MANTENIMENT.dataAlta%TYPE,
									p_databaixa    		IN MANTENIMENT.dataBaixa%TYPE,							
									p_dataInici			IN MANTPREVENTIU.dataInici%TYPE,
									p_dataFi			IN MANTPREVENTIU.dataFi%TYPE,
									p_periodicitatMesos	IN MANTPREVENTIU.periodicitatMesos%TYPE,
									RES             	OUT VARCHAR2)
  IS
   E_CAMP_NUL EXCEPTION;
   E_MANT_PREVENTIU_NOEXISTEIX EXCEPTION;
   E_EQUIP_NOEXISTEIX EXCEPTION;
   E_DATA_BAIXA_INCORRECTA EXCEPTION;
   E_TERMINI_CONTRACTE_INCORRECTE	EXCEPTION;
   E_DATA_INICI_INCORRECTA	EXCEPTION; 
   E_MANTPREV_JAEXISTEIX	EXCEPTION;   
   E_DATA_IMPOSSIBLE EXCEPTION;

   dataCompraEquip EQUIP.dataCompra%TYPE;  
   existeix        VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

   BEGIN

     param_entrada := 'P_IDEQUIP: '||p_idequip||', P_IDMANTENIMENT: '||p_idmanteniment||', P_DATAALTA: '||p_dataalta||', P_DATABAIXA: '||p_databaixa||', P_DATAINICI: '||p_dataInici||', P_DATAFI: '||p_dataFi||', P_PERIODICITATMESOS: '||p_periodicitatMesos;

     --Verifica que tots els camps obligatoris tenen valor
     IF (TRIM(p_idequip) IS NULL) OR (TRIM(p_idmanteniment) IS NULL)
			THEN 
				RAISE E_CAMP_NUL ;
     END IF;
	 
	 --Verifica que l equip existeix en la Base de Dades
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM EQUIP
        WHERE idequip = p_idequip
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_EQUIP_NOEXISTEIX;
     END;

     --Verifica que el manteniment existeix en la Base de Dades
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM MANTENIMENT
        WHERE idequip = p_idequip
			  AND idmanteniment = p_idmanteniment
			  AND tipusMant = 'PREVENTIU'
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_MANT_PREVENTIU_NOEXISTEIX;
     END;
	 
	 --Verifica que la data de fi del contracte s posterior a la data d'inici del contracte 
	 IF (p_dataInici IS NOT NULL AND p_dataFi IS NOT NULL) THEN
		IF (p_dataInici > p_dataFi) THEN
				RAISE E_TERMINI_CONTRACTE_INCORRECTE;
		END IF;
	 END IF;	 
	 
	 --Verifica que la data d inici del contracte s posterior a la data de compra de l equip
	 SELECT dataCompra
     INTO dataCompraEquip
     FROM EQUIP
     WHERE idequip = p_idequip;
	 
	 IF (dataCompraEquip IS NOT NULL AND p_dataInici IS NOT NULL) THEN
		IF (dataCompraEquip > p_dataInici) THEN
				RAISE E_DATA_INICI_INCORRECTA;
		END IF;
	 END IF;	 
	 
	 --Verifica que no existeix cap altre manteniment que es puguin cavalcar les dates
     IF (p_dataInici IS NOT NULL) THEN
	   BEGIN
		 SELECT 'S'
		   INTO EXISTEIX
		 FROM DUAL
		 WHERE not exists (select *
							from mantpreventiu
							where idequip = p_idequip
								  and idmanteniment != p_idmanteniment
								  AND p_dataInici between dataInici and dataFi)
		  ;
	   EXCEPTION
           WHEN NO_DATA_FOUND THEN
              RAISE E_MANTPREV_JAEXISTEIX;
	   END;
	 END IF;
	 IF (p_dataFi IS NOT NULL) THEN
	   BEGIN
		 SELECT 'S'
		   INTO EXISTEIX
		 FROM DUAL
		 WHERE not exists (select *
							from mantpreventiu
							where idequip = p_idequip
								  and idmanteniment != p_idmanteniment
								  AND p_dataFi between dataInici and dataFi)
		  ;
	   EXCEPTION
           WHEN NO_DATA_FOUND THEN
              RAISE E_MANTPREV_JAEXISTEIX;
	   END;
	 END IF;	  
	 
	--verifica que les dates sn anteriors a la data actual
   IF (p_dataalta IS NOT NULL OR p_databaixa IS NOT NULL) THEN
	 IF (p_dataalta > SYSDATE) OR (p_databaixa > SYSDATE) THEN
		 RAISE E_DATA_IMPOSSIBLE;
	 END IF;
   END IF;

	 -- si es modifica la data d'alta
	 IF (p_dataalta IS NOT NULL AND p_databaixa IS NOT NULL) THEN
		IF (p_dataalta > p_databaixa) THEN
				RAISE E_DATA_BAIXA_INCORRECTA;
		END IF;
	 END IF;
    
     --Si es passen les proves de validaci actualitzem            
     UPDATE MANTENIMENT
        SET dataAlta = nvl(p_dataalta, dataAlta),
			dataBaixa = nvl(p_databaixa, dataBaixa)
     WHERE  idequip = p_idequip
			AND idmanteniment = p_idmanteniment;
     COMMIT;
	 
     UPDATE MANTPREVENTIU
        SET dataInici = nvl(p_dataInici, dataInici),
			dataFi = nvl(p_dataFi, dataFi),
			periodicitatMesos = nvl(p_periodicitatMesos, periodicitatMesos)
     WHERE  idequip = p_idequip
			AND idmanteniment = p_idmanteniment;
     COMMIT;

     RES:= 'OK';

     INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE,'PKG_MANTENIMENTS.PR_MODIF_MANT_PREVENTIU', param_entrada, 'RES: '||RES);
     COMMIT;

   EXCEPTION
      WHEN E_MANT_PREVENTIU_NOEXISTEIX THEN
        RES := 'ERROR: El manteniment no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_MANT_PREVENTIU', param_entrada, 'RES: '||RES);
        COMMIT;

      WHEN E_CAMP_NUL  THEN
        RES := 'ERROR: El camp no pot ser nul';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_MANT_PREVENTIU', param_entrada, 'RES: '||RES);
        COMMIT;
		
	  WHEN E_EQUIP_NOEXISTEIX  THEN
        RES := 'ERROR: L equip no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_MANT_PREVENTIU', param_entrada, 'RES: '||RES);
        COMMIT;		

	WHEN E_DATA_INICI_INCORRECTA  THEN
      RES := 'ERROR: La data d inici del contracte no pot ser anterior a la data de compra de l equip';

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_MANT_PREVENTIU', param_entrada, 'RES: '||RES);
      COMMIT;	

	WHEN E_TERMINI_CONTRACTE_INCORRECTE  THEN
      RES := 'ERROR: La data d inici del contracte no pot ser posterior a la data de fi del contracte';

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_MANT_PREVENTIU', param_entrada, 'RES: '||RES);
      COMMIT;		

      WHEN E_DATA_BAIXA_INCORRECTA THEN
        RES := 'ERROR: La data d alta no pot ser posterior a la data de baixa';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_MANT_PREVENTIU', param_entrada, 'RES: '||RES);
        COMMIT;
		
	WHEN E_MANTPREV_JAEXISTEIX  THEN
      RES := 'ERROR: L equip ja t un manteniment preventiu per aquestes dates';

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_MANT_PREVENTIU', param_entrada, 'RES: '||RES);
      COMMIT;		
	  
    WHEN E_DATA_IMPOSSIBLE THEN
        RES := 'ERROR: La data d inici o la data fi no poden ser posteriors a la data actual';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_MANT_PREVENTIU', param_entrada, 'RES: '||RES);
        COMMIT;		  

     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);

        RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_MANT_PREVENTIU', param_entrada, 'RES: '||RES);
        COMMIT;
  END;


  /***************************************************
  *  MANTENIMENT REVISIONS MANTENIMENTS PREVENTIUS
  ****************************************************/

  FUNCTION FN_OBTENIR_ULTREVPENDENT_EQUIP(p_idequip REVISIO.idequip%TYPE,
										p_idmanteniment REVISIO.idmanteniment%TYPE)
  RETURN REVISIO.idrevisio%TYPE
  IS
	idrev REVISIO.idrevisio%TYPE;
	q integer;
  BEGIN
	  SELECT count(*) as d  
	  INTO q
	  FROM REVISIO
	  WHERE p_idequip = idequip
		    AND p_idmanteniment = idmanteniment
			and dataRealitzacio is null;

	  IF (q = 1) THEN
	  --si tenim una revisio pendent, cerquem el seu id
	  --recordem que noms pot haver-hi una revisi pendent per un equip i manteniment preventiu alhora
		  SELECT idrevisio 
			INTO idrev
		  FROM REVISIO
		  WHERE p_idequip = idequip
				AND p_idmanteniment = idmanteniment
				and dataRealitzacio is null
				;
		  RETURN idrev;
	  ELSE 
		  RETURN 0;  --si no t revisions pendents retorna 0 (o si en t ms d una de pendent, per si de cas)
	  END IF;
  END;  
  
  PROCEDURE PR_ALTA_REVISIO_MANTPREV (p_idequip 			IN REVISIO.idequip%TYPE,
										p_idmanteniment		IN REVISIO.idmanteniment%TYPE,
										p_dataPrevista 		IN REVISIO.dataPrevista%TYPE,
										p_dataRealitzacio	IN REVISIO.dataRealitzacio%TYPE,
										p_idempresa			IN REVISIO.idempresa%TYPE,
										p_idoperari			IN REVISIO.idoperari%TYPE,
										p_observacions 		IN REVISIO.observacions%TYPE,
										RES 				OUT VARCHAR2)
  IS										
   E_CAMP_NUL         	EXCEPTION;
   E_REVISIO_PENDENT_EXISTEIX EXCEPTION;
   E_DATAPREVISTA_INCORRECTA EXCEPTION;
   E_REVISIO_MANTPREV_EXISTEIX EXCEPTION;
   
   E_EQUIP_NOEXISTEIX EXCEPTION;
   E_MANT_PREVENTIU_NOEXISTEIX EXCEPTION;
   E_EMPRESA_NOEXISTEIX EXCEPTION;
   E_OPERARI_NOEXISTEIX EXCEPTION;
   E_OPERARI_INCORRECTE EXCEPTION;

   existeix      VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN

     param_entrada := 'P_IDEQUIP: '||p_idequip||', P_IDMANTENIMENT: '||p_idmanteniment||', P_DATAPREVISTA: '||p_dataPrevista||', P_DATAREALITZACIO: '||p_dataRealitzacio||', P_IDEMPRESA: '||p_idempresa||', P_IDOPERARI: '||p_idoperari||', P_OBSERVACIONS: '||p_observacions;

     --Verifica que tots els camps obligatoris tenen valor
     IF (TRIM(p_idequip) IS NULL) OR (TRIM(p_idmanteniment) IS NULL) OR (TRIM(p_dataPrevista) IS NULL) 
			THEN 
				RAISE E_CAMP_NUL ;
     END IF;
	 
	 --Verifica que l empresa i operari s emplenin si la data de realitzacio s emplena
	 IF (TRIM(p_dataRealitzacio) IS NOT NULL) AND ((TRIM(p_idempresa) IS NULL) OR (TRIM(p_idoperari) IS NULL)) 
			THEN 
				RAISE E_CAMP_NUL ;
     END IF;

	 --Verifica que no tingui una revisio pendent per l equip i manteniment
	 BEGIN
        SELECT 'S'
        INTO EXISTEIX
        FROM REVISIO
        WHERE idequip = p_idequip
			  AND idmanteniment = p_idmanteniment
			  and dataRealitzacio is null
			  AND ROWNUM  = 1;
        RAISE E_REVISIO_PENDENT_EXISTEIX;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           NULL;
     END;
	 
     --Verifica que el registre no s'hagi inserit previament
	 /*
     BEGIN
        SELECT 'S'
        INTO EXISTEIX
        FROM REVISIO
        WHERE idequip = p_idequip
			  AND idmanteniment = p_idmanteniment
			  AND dataPrevista = p_dataPrevista
			  AND ROWNUM  = 1;

        RAISE E_REVISIO_MANTPREV_EXISTEIX;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           NULL;
     END;
	 */
	 
	 --Verifica que l equip existeix en la Base de Dades
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM EQUIP
        WHERE idequip = p_idequip
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_EQUIP_NOEXISTEIX;
     END;
	 
	 --Verifica que el manteniment existeix en la Base de Dades
	 BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM MANTENIMENT
        WHERE idequip = p_idequip
			  AND idmanteniment = p_idmanteniment
			  AND tipusMant = 'PREVENTIU'
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_MANT_PREVENTIU_NOEXISTEIX;
     END;
	 
	 --Verifica que la data prevista de la revisi s dins del perode del manteniment de l equip
	 BEGIN
		SELECT 'S'
		INTO EXISTEIX
		FROM MANTPREVENTIU
		WHERE idequip = p_idequip
			  AND idmanteniment = p_idmanteniment
			  AND p_dataPrevista between dataInici and dataFi
			  AND ROWNUM   = 1;
	 EXCEPTION
		WHEN NO_DATA_FOUND THEN
		   RAISE E_DATAPREVISTA_INCORRECTA;
	 END;
	 
	 IF (TRIM(p_dataRealitzacio) IS NOT NULL) THEN		 
			 --Verifica que l empresa existeix en la base de dades
			 BEGIN
				SELECT 'S'
				INTO EXISTEIX
				FROM EMPRESA
				WHERE idempresa = p_idempresa
					  AND ROWNUM   = 1;
			 EXCEPTION
				WHEN NO_DATA_FOUND THEN
				   RAISE E_EMPRESA_NOEXISTEIX;
			 END;	 
			 
			 --Verifica que l operari existeix en la base de dades
			 BEGIN
				SELECT 'S'
				INTO EXISTEIX
				FROM OPERARI
				WHERE idoperari = p_idoperari
					  AND ROWNUM   = 1;
			 EXCEPTION
				WHEN NO_DATA_FOUND THEN
				   RAISE E_OPERARI_NOEXISTEIX;
			 END;	 
			 
			 --Verifica que l operari pertany a l empresa
			 BEGIN
				SELECT 'S'
				INTO EXISTEIX
				FROM OPERARI
				WHERE idoperari = p_idoperari
					  and idempresa = p_idempresa
					  AND ROWNUM   = 1;
			 EXCEPTION
				WHEN NO_DATA_FOUND THEN
				   RAISE E_OPERARI_INCORRECTE;
			 END;	
	 END IF;

     --Si ha passat les proves de validaci realitza la inserci
     INSERT INTO REVISIO (idequip,idmanteniment,dataPrevista,dataRealitzacio,idempresa,idoperari,observacions)
          VALUES (p_idequip,p_idmanteniment,p_dataPrevista,p_dataRealitzacio,p_idempresa,p_idoperari,p_observacions);

     RES := 'OK';
  
     INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
          VALUES(SYSDATE,'PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV', param_entrada, 'RES: '||RES);
     COMMIT;

  EXCEPTION
	  WHEN E_EQUIP_NOEXISTEIX  THEN
        RES := 'ERROR: L equip no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV', param_entrada, 'RES: '||RES);
        COMMIT;	
		
      WHEN E_MANT_PREVENTIU_NOEXISTEIX THEN
        RES := 'ERROR: El manteniment no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV', param_entrada, 'RES: '||RES);
        COMMIT;			
		
	  WHEN E_EMPRESA_NOEXISTEIX  THEN
        RES := 'ERROR: L empresa no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV', param_entrada, 'RES: '||RES);
        COMMIT;		

	  WHEN E_OPERARI_NOEXISTEIX  THEN
        RES := 'ERROR: L operari no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV', param_entrada, 'RES: '||RES);
        COMMIT;			
		
      WHEN E_OPERARI_INCORRECTE THEN
        RES := 'ERROR: l operari no pertany a l empresa';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV', param_entrada, 'RES: '||RES);
        COMMIT;
	/*	
    WHEN E_REVISIO_MANTPREV_EXISTEIX THEN
      RES := 'ERROR: la revisio ja ha estat donada d alta';

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV', param_entrada, 'RES: '||RES);
      COMMIT;
	  */
	  
    WHEN E_REVISIO_PENDENT_EXISTEIX THEN
      RES := 'ERROR: ja existeix una revisio pendent de l equip i manteniment';

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV', param_entrada, 'RES: '||RES);
      COMMIT;	  

    WHEN E_CAMP_NUL  THEN
      RES := 'ERROR: El camp no pot ser nul';

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV', param_entrada, 'RES: '||RES);
      COMMIT;
	  
    WHEN E_DATAPREVISTA_INCORRECTA  THEN
      RES := 'ERROR: La data prevista de la revisio no es dins del periode del manteniment de l equip';

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV', param_entrada, 'RES: '||RES);
      COMMIT;	  

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);

      RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV', param_entrada, 'RES: '||RES);
      COMMIT;
  END;
								
								
  PROCEDURE PR_BAIXA_REVISIO_MANTPREV (p_idequip 		IN REVISIO.idequip%TYPE,
										p_idmanteniment	IN REVISIO.idmanteniment%TYPE,
										p_idrevisio		IN REVISIO.idrevisio%TYPE,
										RES         	OUT VARCHAR2)
  IS			
     E_CAMP_NUL  EXCEPTION;
     E_REVISIO_MANTPREV_JA_BAIXA EXCEPTION;
	 E_EQUIP_NOEXISTEIX EXCEPTION;
	 E_MANT_PREVENTIU_NOEXISTEIX EXCEPTION;
	 E_REVISIO_MANPREV_NOEXISTEIX EXCEPTION;

     existeix      VARCHAR2(1);
     param_entrada VARCHAR2(500);
     err_num       NUMBER;
     err_msg       VARCHAR2(100);

  BEGIN

     param_entrada := 'P_IDEQUIP: '||p_idequip||', P_IDMANTENIMENT: '||p_idmanteniment||', P_IDREVISIO: '||p_idrevisio;

     --Verifica que tots els camps obligatoris tenen valor
     IF (TRIM(p_idequip) IS NULL) OR (TRIM(p_idmanteniment) IS NULL) OR (TRIM(p_idrevisio) IS NULL)
			THEN
				RAISE E_CAMP_NUL ;
     END IF;
	 
	 --Verifica que l equip existeix en la Base de Dades
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM EQUIP
        WHERE idequip = p_idequip
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_EQUIP_NOEXISTEIX;
     END;
	 
	 --Verifica que el manteniment existeix en la Base de Dades
	 BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM MANTENIMENT
        WHERE idequip = p_idequip
			  AND idmanteniment = p_idmanteniment
			  AND tipusMant = 'PREVENTIU'
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_MANT_PREVENTIU_NOEXISTEIX;
     END;	 

     --Verifica que la revisio existeix en la Base de Dades
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM REVISIO 
        WHERE idequip = p_idequip
			  AND idmanteniment = p_idmanteniment
			  AND idrevisio = p_idrevisio
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_REVISIO_MANPREV_NOEXISTEIX;
     END;

     --Verifica que la revisio del manteniment no est donada de baixa
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM REVISIO 
        WHERE idequip = p_idequip
			  AND idmanteniment = p_idmanteniment
			  AND idrevisio = p_idrevisio
			  AND dataBaixa  IS NULL
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_REVISIO_MANTPREV_JA_BAIXA;
     END;

     --Si ha passat les proves de validaci realitza l'esborrat lgic del manteniment
     UPDATE REVISIO SET dataBaixa = SYSDATE
     WHERE idequip = p_idequip
			AND idmanteniment = p_idmanteniment
			AND idrevisio = p_idrevisio;

     RES := 'OK';

     INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
          VALUES(SYSDATE,'PKG_MANTENIMENTS.PR_BAIXA_REVISIO_MANTPREV', param_entrada, 'RES: '||RES);
     COMMIT;

  EXCEPTION
      WHEN E_REVISIO_MANPREV_NOEXISTEIX THEN
        RES := 'ERROR: La revisio a donar de baixa no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_BAIXA_REVISIO_MANTPREV', param_entrada, 'RES: '||RES);
        COMMIT;

      WHEN E_REVISIO_MANTPREV_JA_BAIXA THEN
        RES := 'ERROR: La revisio ja havia estat donada de baixa';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_BAIXA_REVISIO_MANTPREV', param_entrada, 'RES: '||RES);
        COMMIT;

      WHEN E_CAMP_NUL  THEN
        RES := 'ERROR: El camp no pot ser nul';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_BAIXA_REVISIO_MANTPREV', param_entrada, 'RES: '||RES);
        COMMIT;
		
	  WHEN E_EQUIP_NOEXISTEIX  THEN
        RES := 'ERROR: L equip no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_BAIXA_REVISIO_MANTPREV', param_entrada, 'RES: '||RES);
        COMMIT;	
		
      WHEN E_MANT_PREVENTIU_NOEXISTEIX THEN
        RES := 'ERROR: El manteniment no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_BAIXA_REVISIO_MANTPREV', param_entrada, 'RES: '||RES);
        COMMIT;			

      WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);

        RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_BAIXA_REVISIO_MANTPREV', param_entrada, 'RES: '||RES);
        COMMIT;
  END;


  PROCEDURE PR_MODIF_REVISIO_MANTPREV (p_idequip 			IN REVISIO.idequip%TYPE,
										p_idmanteniment		IN REVISIO.idmanteniment%TYPE,
										p_idrevisio			IN REVISIO.idrevisio%TYPE,
										p_dataPrevista 		IN REVISIO.dataPrevista%TYPE,
										p_dataRealitzacio	IN REVISIO.dataRealitzacio%TYPE,
										p_idempresa			IN REVISIO.idempresa%TYPE,
										p_idoperari			IN REVISIO.idoperari%TYPE,
										p_observacions 		IN REVISIO.observacions%TYPE,
										p_dataalta     		IN REVISIO.dataAlta%TYPE,
										p_databaixa    		IN REVISIO.dataBaixa%TYPE,
										RES             	OUT VARCHAR2)
  IS
   E_CAMP_NUL             EXCEPTION;
   E_DATA_BAIXA_INCORRECTA EXCEPTION;
   E_DATAPREVISTA_INCORRECTA EXCEPTION;
   E_EQUIP_NOEXISTEIX EXCEPTION;
   E_MANT_PREVENTIU_NOEXISTEIX EXCEPTION;
   E_REVISIO_MANPREV_NOEXISTEIX EXCEPTION;
   E_EMPRESA_NOEXISTEIX EXCEPTION;
   E_OPERARI_NOEXISTEIX EXCEPTION;
   E_OPERARI_INCORRECTE EXCEPTION;
   E_DATA_IMPOSSIBLE	EXCEPTION;

   existeix        VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

   BEGIN

     param_entrada := 'P_IDEQUIP: '||p_idequip||', P_IDMANTENIMENT: '||p_idmanteniment||', P_IDREVISIO: '||p_idrevisio||', P_DATAPREVISTA: '||p_dataPrevista||', P_DATAREALITZACIO: '||p_dataRealitzacio||', P_IDEMPRESA: '||p_idempresa||', P_IDOPERARI: '||p_idoperari||', P_OBSERVACIONS: '||p_observacions||', P_DATAALTA: '||p_dataalta||', P_DATABAIXA: '||p_databaixa;

     --Verifica que tots els camps obligatoris tenen valor
     IF (TRIM(p_idequip) IS NULL) OR (TRIM(p_idmanteniment) IS NULL) OR (TRIM(p_idrevisio) IS NULL) 
			THEN 
				RAISE E_CAMP_NUL ;
     END IF;

	 --Verifica que l equip existeix en la Base de Dades
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM EQUIP
        WHERE idequip = p_idequip
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_EQUIP_NOEXISTEIX;
     END;
	 
	 --Verifica que el manteniment existeix en la Base de Dades
	 BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM MANTENIMENT
        WHERE idequip = p_idequip
			  AND idmanteniment = p_idmanteniment
			  AND tipusMant = 'PREVENTIU'
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_MANT_PREVENTIU_NOEXISTEIX;
     END;

     --Verifica que la revisio existeix en la Base de Dades
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM REVISIO
        WHERE idequip = p_idequip
			  AND idmanteniment = p_idmanteniment
			  AND idrevisio = p_idrevisio
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_REVISIO_MANPREV_NOEXISTEIX;
     END;	 
	 
	 -- si es modifica la data d'alta
	 IF (p_dataalta IS NOT NULL AND p_databaixa IS NOT NULL) THEN
		IF (p_dataalta > p_databaixa) THEN
				RAISE E_DATA_BAIXA_INCORRECTA;
		END IF;
	 END IF;
	  
	 --Verifica que l empresa existeix en la base de dades
	 IF (TRIM(p_idempresa) IS NOT NULL) THEN	
		 BEGIN
			SELECT 'S'
			INTO EXISTEIX
			FROM EMPRESA
			WHERE idempresa = p_idempresa
				  AND ROWNUM   = 1;
		 EXCEPTION
			WHEN NO_DATA_FOUND THEN
			   RAISE E_EMPRESA_NOEXISTEIX;
		 END;
	 END IF;
	 
	 --Verifica que l operari existeix en la base de dades
	 IF (TRIM(p_idoperari) IS NOT NULL) THEN
		 BEGIN
			SELECT 'S'
			INTO EXISTEIX
			FROM OPERARI
			WHERE idoperari = p_idoperari
				  AND ROWNUM   = 1;
		 EXCEPTION
			WHEN NO_DATA_FOUND THEN
			   RAISE E_OPERARI_NOEXISTEIX;
		 END;	
	 END IF;	 
			 
	 --Verifica que l operari pertany a l empresa
	 IF (TRIM(p_idempresa) IS NOT NULL) AND (TRIM(p_idoperari) IS NOT NULL) THEN
			 BEGIN
				SELECT 'S'
				INTO EXISTEIX
				FROM OPERARI
				WHERE idoperari = p_idoperari
					  and idempresa = p_idempresa
					  AND ROWNUM   = 1;
			 EXCEPTION
				WHEN NO_DATA_FOUND THEN
				   RAISE E_OPERARI_INCORRECTE;
			 END;	
	 END IF;	 
	 
	 --Verifica que la data prevista de la revisi s dins del perode del manteniment de l equip
	 IF (TRIM(p_dataPrevista) IS NOT NULL) THEN
		 BEGIN
			SELECT 'S'
			INTO EXISTEIX
			FROM MANTPREVENTIU
			WHERE idequip = p_idequip
				  AND idmanteniment = p_idmanteniment
				  AND p_dataPrevista between dataInici and dataFi
				  AND ROWNUM   = 1;
		 EXCEPTION
			WHEN NO_DATA_FOUND THEN
			   RAISE E_DATAPREVISTA_INCORRECTA;
		 END;
	 END IF;		 
	 
	 --verifica que les dates sn anteriors a la data actual
	   IF (p_dataalta IS NOT NULL OR p_databaixa IS NOT NULL) THEN
		 IF (p_dataalta > SYSDATE) OR (p_databaixa > SYSDATE) THEN
			 RAISE E_DATA_IMPOSSIBLE;
		 END IF;
	   END IF;	
    
     --Si es passen les proves de validaci actualitzem            
     UPDATE REVISIO
        SET dataPrevista = nvl(p_dataPrevista, dataPrevista),
			dataRealitzacio = nvl(p_dataRealitzacio, dataRealitzacio),
			idempresa = nvl(p_idempresa, idempresa),
			idoperari = nvl(p_idoperari, idoperari),
			observacions = nvl(p_observacions, observacions),
			dataAlta = nvl(p_dataalta, dataAlta),
			dataBaixa = nvl(p_databaixa, dataBaixa)
     WHERE  idequip = p_idequip
			AND idmanteniment = p_idmanteniment
			AND idrevisio = p_idrevisio;
     COMMIT;

     RES:= 'OK';

     INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE,'PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV', param_entrada, 'RES: '||RES);
     COMMIT;

   EXCEPTION
      WHEN E_REVISIO_MANPREV_NOEXISTEIX THEN
        RES := 'ERROR: La revisio a modificar no existeix';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV', param_entrada, 'RES: '||RES);
        COMMIT;

      WHEN E_CAMP_NUL  THEN
        RES := 'ERROR: El camp no pot ser nul';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV', param_entrada, 'RES: '||RES);
        COMMIT;
		
	  WHEN E_EQUIP_NOEXISTEIX  THEN
        RES := 'ERROR: L equip no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV', param_entrada, 'RES: '||RES);
        COMMIT;	
		
      WHEN E_MANT_PREVENTIU_NOEXISTEIX THEN
        RES := 'ERROR: El manteniment no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV', param_entrada, 'RES: '||RES);
        COMMIT;			
		
	  WHEN E_EMPRESA_NOEXISTEIX  THEN
        RES := 'ERROR: L empresa no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV', param_entrada, 'RES: '||RES);
        COMMIT;		

	  WHEN E_OPERARI_NOEXISTEIX  THEN
        RES := 'ERROR: L operari no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV', param_entrada, 'RES: '||RES);
        COMMIT;			
		
      WHEN E_OPERARI_INCORRECTE THEN
        RES := 'ERROR: l operari no pertany a l empresa';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV', param_entrada, 'RES: '||RES);
        COMMIT;


      WHEN E_DATA_BAIXA_INCORRECTA THEN
        RES := 'ERROR: La data d alta no pot ser posterior a la data de baixa';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV', param_entrada, 'RES: '||RES);
        COMMIT;
		
      WHEN E_DATAPREVISTA_INCORRECTA THEN
        RES := 'ERROR: la data prevista de la revisi no s dins del perode del manteniment de l equip';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV', param_entrada, 'RES: '||RES);
        COMMIT;		
		
    WHEN E_DATA_IMPOSSIBLE THEN
        RES := 'ERROR: La data d inici o la data fi no poden ser posteriors a la data actual';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV', param_entrada, 'RES: '||RES);
        COMMIT;	

     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);

        RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV', param_entrada, 'RES: '||RES);
        COMMIT;
  END;
  
  PROCEDURE PR_REALITZAR_REVISIO_PENDENT (p_idequip 			IN REVISIO.idequip%TYPE,
										p_idmanteniment		IN REVISIO.idmanteniment%TYPE,
										p_idrevisio			IN REVISIO.idrevisio%TYPE,
										p_dataRealitzacio	IN REVISIO.dataRealitzacio%TYPE,
										p_idempresa			IN REVISIO.idempresa%TYPE,
										p_idoperari			IN REVISIO.idoperari%TYPE,
										p_observacions 		IN REVISIO.observacions%TYPE,
										RES             	OUT VARCHAR2)
  IS
   E_CAMP_NUL EXCEPTION;
   E_EQUIP_NOEXISTEIX EXCEPTION;
   E_MANT_PREVENTIU_NOEXISTEIX EXCEPTION;
   E_REVISIO_MANPREV_NOEXISTEIX EXCEPTION;
   E_EMPRESA_NOEXISTEIX EXCEPTION;
   E_OPERARI_NOEXISTEIX EXCEPTION;
   E_OPERARI_INCORRECTE EXCEPTION;

   p_dataFiMant MANTPREVENTIU.DATAFI%TYPE;
   p_periodMesos MANTPREVENTIU.PERIODICITATMESOS%TYPE;
   p_dataPrev REVISIO.dataprevista%TYPE;

   existeix        VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN

     param_entrada := 'P_IDEQUIP: '||p_idequip||', P_IDMANTENIMENT: '||p_idmanteniment||', P_IDREVISIO: '||p_idrevisio||', P_DATAREALITZACIO: '||p_dataRealitzacio||', P_IDEMPRESA: '||p_idempresa||', P_IDOPERARI: '||p_idoperari||', P_OBSERVACIONS: '||p_observacions;

     --Verifica que tots els camps obligatoris tenen valor
     IF (TRIM(p_idequip) IS NULL) OR (TRIM(p_idmanteniment) IS NULL) OR (TRIM(p_idrevisio) IS NULL) 
			OR (TRIM(p_dataRealitzacio) IS NULL) OR (TRIM(p_idempresa) IS NULL)
				OR (TRIM(p_idoperari) IS NULL)
				THEN 
					RAISE E_CAMP_NUL ;
     END IF;
	 
	 --Verifica que l equip existeix en la Base de Dades
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM EQUIP
        WHERE idequip = p_idequip
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_EQUIP_NOEXISTEIX;
     END;
	 
	 --Verifica que el manteniment existeix en la Base de Dades
	 BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM MANTENIMENT
        WHERE idequip = p_idequip
			  AND idmanteniment = p_idmanteniment
			  AND tipusMant = 'PREVENTIU'
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_MANT_PREVENTIU_NOEXISTEIX;
     END;
	 
     --Verifica que la revisio existeix en la Base de Dades
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM REVISIO
        WHERE idequip = p_idequip
			  AND idmanteniment = p_idmanteniment
			  AND idrevisio = p_idrevisio
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_REVISIO_MANPREV_NOEXISTEIX;
     END;
	 
	 --Verifica que l empresa existeix en la base de dades
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM EMPRESA
        WHERE idempresa = p_idempresa
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_EMPRESA_NOEXISTEIX;
     END;	 
	 
	 --Verifica que l operari existeix en la base de dades
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM OPERARI
        WHERE idoperari = p_idoperari
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_OPERARI_NOEXISTEIX;
     END;	 
	 
	 --Verifica que l operari pertany a l empresa
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM OPERARI
        WHERE idoperari = p_idoperari
			  and idempresa = p_idempresa
			  AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_OPERARI_INCORRECTE;
     END;	 
   
     --Si es passen les proves de validaci actualitzem            
     UPDATE REVISIO
        SET dataRealitzacio = nvl(p_dataRealitzacio, dataRealitzacio),
			idempresa = nvl(p_idempresa, idempresa),
			idoperari = nvl(p_idoperari, idoperari),
			observacions = nvl(p_observacions, observacions)
     WHERE  idequip = p_idequip
			AND idmanteniment = p_idmanteniment
			AND idrevisio = p_idrevisio;
     COMMIT;

     RES:= 'OK';

     INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE,'PKG_MANTENIMENTS.REALITZAR_REVISIO_PENDENT', param_entrada, 'RES: '||RES);
     COMMIT;
	 
	 --calculem propera revisio pendent
	 
	 --obtenim periodicitat i data fi del manteniment de la revisio actual
     SELECT datafi, periodicitatMesos
     INTO p_dataFiMant, p_periodMesos
     FROM MANTPREVENTIU
     WHERE idequip = p_idequip
           AND idmanteniment = p_idmanteniment
     ;

     --calculem data propera revisio pendent
     --dataRealitzacio + periodicitatMesos => dataPrevista 
     SELECT ADD_MONTHS(p_dataRealitzacio,p_periodMesos)
     INTO p_dataPrev
     FROM DUAL;
    
     --inserim propera revisio pendent
     --si dataPrevista <= dataFi manteniment
     IF (p_dataPrev <= p_dataFiMant) THEN
			INSERT INTO REVISIO(idequip,idmanteniment,dataPrevista)
				VALUES(p_idequip,p_idmanteniment,p_dataPrev); 
			COMMIT;
     END IF;

   EXCEPTION
      WHEN E_CAMP_NUL  THEN
        RES := 'ERROR: El camp no pot ser nul';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_REALITZAR_REVISIO_PENDENT', param_entrada, 'RES: '||RES);
        COMMIT;
		
	  WHEN E_EQUIP_NOEXISTEIX  THEN
        RES := 'ERROR: L equip no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_REALITZAR_REVISIO_PENDENT', param_entrada, 'RES: '||RES);
        COMMIT;	
		
      WHEN E_MANT_PREVENTIU_NOEXISTEIX THEN
        RES := 'ERROR: El manteniment no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_REALITZAR_REVISIO_PENDENT', param_entrada, 'RES: '||RES);
        COMMIT;		
		
      WHEN E_REVISIO_MANPREV_NOEXISTEIX THEN
        RES := 'ERROR: La revisio no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_REALITZAR_REVISIO_PENDENT', param_entrada, 'RES: '||RES);
        COMMIT;		
		
	  WHEN E_EMPRESA_NOEXISTEIX  THEN
        RES := 'ERROR: L empresa no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_REALITZAR_REVISIO_PENDENT', param_entrada, 'RES: '||RES);
        COMMIT;		

	  WHEN E_OPERARI_NOEXISTEIX  THEN
        RES := 'ERROR: L operari no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_REALITZAR_REVISIO_PENDENT', param_entrada, 'RES: '||RES);
        COMMIT;			
		
      WHEN E_OPERARI_INCORRECTE THEN
        RES := 'ERROR: l operari no pertany a l empresa';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_REALITZAR_REVISIO_PENDENT', param_entrada, 'RES: '||RES);
        COMMIT;

     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);

        RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'PKG_MANTENIMENTS.PR_REALITZAR_REVISIO_PENDENT', param_entrada, 'RES: '||RES);
        COMMIT;
  END;
  
   
END;
/   

COMMIT;

spool off
exit