-----------------------------------------
-----------------------------------------
SET SERVEROUTPUT ON;
spool C:\UOC\PFC\mbernard\logs\ar2-jocs_proves.log
-----------------------------------------
-----------------------------------------

---------------------------------------------------
---------------------------------------------------
--connectat com a PFC_BDR
ALTER SESSION SET NLS_DATE_FORMAT = 'DD/MM/YYYY HH24:MI:SS';
ALTER SESSION SET NLS_TIMESTAMP_FORMAT = 'DD/MM/YYYY HH24:MI:SS';
ALTER SESSION SET NLS_TIME_FORMAT = 'HH24:MI:SS';
COMMIT;


---------------------------------------------------
--------------  POBLACIONS  -----------------------
---------------------------------------------------
DECLARE
  res VARCHAR2(20000);
BEGIN
DBMS_OUTPUT.PUT_LINE('--------------  POBLACIONS  -----------------------');
--ALTA
DBMS_OUTPUT.PUT_LINE('--PROVES: ALTA');
  --alta - ok
  pfc_BDR.PKG_AUXILIAR.PR_ALTA_POBLACIO('SabaRdell', res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: ja existeix
  pfc_BDR.PKG_AUXILIAR.PR_ALTA_POBLACIO('SabaRdell', res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: camp nul
  pfc_BDR.PKG_AUXILIAR.PR_ALTA_POBLACIO(NULL, res);
  DBMS_OUTPUT.PUT_LINE(res);
--BAIXA
DBMS_OUTPUT.PUT_LINE('--PROVES: BAIXA');
  --baixa - ok  
  pfc_BDR.PKG_AUXILIAR.PR_BAIXA_POBLACIO(pfc_BDR.PKG_AUXILIAR.FN_OBTENIR_ID_NOMPOBLACIO('SabaRdell'), res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: ja donada de baixa
  pfc_BDR.PKG_AUXILIAR.PR_BAIXA_POBLACIO(pfc_BDR.PKG_AUXILIAR.FN_OBTENIR_ID_NOMPOBLACIO('SabaRdell'), res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: no existeix
  pfc_BDR.PKG_AUXILIAR.PR_BAIXA_POBLACIO(pfc_BDR.PKG_AUXILIAR.FN_OBTENIR_ID_NOMPOBLACIO('Terrassa'), res);
  DBMS_OUTPUT.PUT_LINE(res); 
--MODIFICACIO
DBMS_OUTPUT.PUT_LINE('--PROVES: MODIFICACIO');
  --modificacio - ok  
  pfc_BDR.PKG_AUXILIAR.PR_MODIF_POBLACIO(pfc_BDR.PKG_AUXILIAR.FN_OBTENIR_ID_NOMPOBLACIO('SabaRdell'),'Sabadell',NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: id no existeix
  pfc_BDR.PKG_AUXILIAR.PR_MODIF_POBLACIO(999,'Sabadell',NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: id no pot ser nul
  pfc_BDR.PKG_AUXILIAR.PR_MODIF_POBLACIO(NULL,'Sabadell',NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: la data d alta no pot ser posterior a la data de baixa
  pfc_BDR.PKG_AUXILIAR.PR_MODIF_POBLACIO(pfc_BDR.PKG_AUXILIAR.FN_OBTENIR_ID_NOMPOBLACIO('Sabadell'),'Sabadell',SYSDATE-3,SYSDATE-8,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: La data d alta o la data de baixa no poden ser posteriors a la data actual
  pfc_BDR.PKG_AUXILIAR.PR_MODIF_POBLACIO(pfc_BDR.PKG_AUXILIAR.FN_OBTENIR_ID_NOMPOBLACIO('Sabadell'),'Sabadell',null,SYSDATE+100,res);
  DBMS_OUTPUT.PUT_LINE(res);   
END;
/


---------------------------------------------------
--------------  USUARIS  --------------------------
---------------------------------------------------
DECLARE
  res VARCHAR2(20000);
BEGIN
DBMS_OUTPUT.PUT_LINE('--------------  USUARIS  --------------------------');
--ALTA
DBMS_OUTPUT.PUT_LINE('--PROVES: ALTA');
  --alta - ok
  pfc_BDR.PKG_AUXILIAR.PR_ALTA_USUARI('mnebot','1bx45zz','46588335B','Maite Nebot','mnebot@empresa.com','ANALISTA',res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: ja existeix
  pfc_BDR.PKG_AUXILIAR.PR_ALTA_USUARI('mnebot','1bx45yy','46588335B','Maite Nebot','mnebot@empresa.com','ANALISTA',res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: camp nul
  pfc_BDR.PKG_AUXILIAR.PR_ALTA_USUARI(NULL,'1bx45zz','46588335B','Maite Nebot','mnebot@empresa.com','ANALISTA',res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: camp nul
  pfc_BDR.PKG_AUXILIAR.PR_ALTA_USUARI('rnebot',NULL,'46599335B','Rosa Nebot','rnebot@empresa.com','ANALISTA',res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: camp nul
  pfc_BDR.PKG_AUXILIAR.PR_ALTA_USUARI('rnebot','1bx45zz',NULL,'Rosa Nebot','rnebot@empresa.com','ANALISTA',res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: camp nul
  pfc_BDR.PKG_AUXILIAR.PR_ALTA_USUARI('rnebot','1bx45zz','46599335B',NULL,'rnebot@empresa.com','ANALISTA',res);
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: perfil incorrecte
  pfc_BDR.PKG_AUXILIAR.PR_ALTA_USUARI('rnebot','1bx45zz','46599335B','Rosa Nebot','rnebot@empresa.com','TECNIC',res);
  DBMS_OUTPUT.PUT_LINE(res);  
--BAIXA
DBMS_OUTPUT.PUT_LINE('--PROVES: BAIXA');
  --baixa - ok  
  pfc_BDR.PKG_AUXILIAR.PR_BAIXA_USUARI(pfc_BDR.PKG_AUXILIAR.FN_OBTENIR_ID_LOGIN_USUARI('mnebot'), res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: ja donada de baixa
  pfc_BDR.PKG_AUXILIAR.PR_BAIXA_USUARI(pfc_BDR.PKG_AUXILIAR.FN_OBTENIR_ID_LOGIN_USUARI('mnebot'), res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: no existeix
  pfc_BDR.PKG_AUXILIAR.PR_BAIXA_USUARI(pfc_BDR.PKG_AUXILIAR.FN_OBTENIR_ID_LOGIN_USUARI('ndiaz'), res);
  DBMS_OUTPUT.PUT_LINE(res); 
--MODIFICACIO
DBMS_OUTPUT.PUT_LINE('--PROVES: MODIFICACIO');
  --modificacio - ok  
  pfc_BDR.PKG_AUXILIAR.PR_MODIF_USUARI(pfc_BDR.PKG_AUXILIAR.FN_OBTENIR_ID_LOGIN_USUARI('mnebot'),'mnebot','1bx45yy','46588335E','Maite Nebot',NULL,'ANALISTA',NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: id no existeix
  pfc_BDR.PKG_AUXILIAR.PR_MODIF_USUARI(999,'mnebot','1bx45yy','46588335E','Maite Nebot',NULL,'ANALISTA',NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: id no pot ser nul
  pfc_BDR.PKG_AUXILIAR.PR_MODIF_USUARI(NULL,'mnebot','1bx45yy','46588335E','Maite Nebot',NULL,'ANALISTA',NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: la data d alta no pot ser posterior a la data de baixa
  pfc_BDR.PKG_AUXILIAR.PR_MODIF_USUARI(pfc_BDR.PKG_AUXILIAR.FN_OBTENIR_ID_LOGIN_USUARI('mnebot'),'mnebot','1bx45yy','46588335E','Maite Nebot',NULL,'ANALISTA',SYSDATE-3,SYSDATE-8,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: perfil incorrecte
    pfc_BDR.PKG_AUXILIAR.PR_MODIF_USUARI(pfc_BDR.PKG_AUXILIAR.FN_OBTENIR_ID_LOGIN_USUARI('mnebot'),'mnebot','1bx45yy','46588335E','Maite Nebot',NULL,'XXXXX',NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: La data d alta o la data de baixa no poden ser posteriors a la data actual
  pfc_BDR.PKG_AUXILIAR.PR_MODIF_USUARI(pfc_BDR.PKG_AUXILIAR.FN_OBTENIR_ID_LOGIN_USUARI('mnebot'),'mnebot','1bx45yy','46588335E','Maite Nebot',NULL,'ANALISTA',null,SYSDATE+100,res);
  DBMS_OUTPUT.PUT_LINE(res);     
END;
/


---------------------------------------------------
-----------------  CENTRES  -----------------------
---------------------------------------------------
DECLARE
  res VARCHAR2(20000);
BEGIN
DBMS_OUTPUT.PUT_LINE('-----------------  CENTRES  -----------------------');
--ALTA
DBMS_OUTPUT.PUT_LINE('--PROVES: ALTA');
  --alta - ok
  pfc_BDR.PKG_CENTRES.PR_ALTA_CENTRE('Centre 33','telegraf 44',1,'08033','932211589','centre33@empresa.com', res); 
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: ja existeix
  pfc_BDR.PKG_CENTRES.PR_ALTA_CENTRE('Centre 33','telegraf 44',1,'08033','932211589','centre33@empresa.com', res); 
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: camp nul
  pfc_BDR.PKG_CENTRES.PR_ALTA_CENTRE(NULL,'telegraf 44',1,'08033','932211589','centre33@empresa.com', res); 
  DBMS_OUTPUT.PUT_LINE(res);
  --error: camp nul
  pfc_BDR.PKG_CENTRES.PR_ALTA_CENTRE('Centre 14',NULL,1,'08033','932311589','centre14@empresa.com', res); 
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: camp nul
  pfc_BDR.PKG_CENTRES.PR_ALTA_CENTRE('Centre 14','tajo 23',NULL,'08033','932311589','centre14@empresa.com', res); 
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: camp nul
  pfc_BDR.PKG_CENTRES.PR_ALTA_CENTRE('Centre 14','tajo 23',1,NULL,'932311589','centre14@empresa.com', res); 
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: camp nul
  pfc_BDR.PKG_CENTRES.PR_ALTA_CENTRE('Centre 14','tajo 23',1,'08033',NULL,'centre14@empresa.com', res); 
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: poblacio no existeix en la base de dades
  pfc_BDR.PKG_CENTRES.PR_ALTA_CENTRE('Centre 14','tajo 23',99,'08033','932311589','centre14@empresa.com', res); 
  DBMS_OUTPUT.PUT_LINE(res);   
--BAIXA
DBMS_OUTPUT.PUT_LINE('--PROVES: BAIXA');
  --baixa - ok  
  pfc_BDR.PKG_CENTRES.PR_BAIXA_CENTRE(pfc_BDR.PKG_CENTRES.FN_OBTENIR_ID_NOMCENTRE('Centre 33'),res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: ja donada de baixa
  pfc_BDR.PKG_CENTRES.PR_BAIXA_CENTRE(pfc_BDR.PKG_CENTRES.FN_OBTENIR_ID_NOMCENTRE('Centre 33'),res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: no existeix
  pfc_BDR.PKG_CENTRES.PR_BAIXA_CENTRE(99,res);
  DBMS_OUTPUT.PUT_LINE(res); 
--MODIFICACIO
DBMS_OUTPUT.PUT_LINE('--PROVES: MODIFICACIO');
  --modificacio - ok  
  pfc_BDR.PKG_CENTRES.PR_MODIF_CENTRE(pfc_BDR.PKG_CENTRES.FN_OBTENIR_ID_NOMCENTRE('Centre 33'),'Centre 33','telegraf 46',1,'08033','932211589','centre33@empresa.com',NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: id no existeix
  pfc_BDR.PKG_CENTRES.PR_MODIF_CENTRE(pfc_BDR.PKG_CENTRES.FN_OBTENIR_ID_NOMCENTRE('Centre 99'),'Centre 33','telegraf 46',1,'08033','932211589','centre33@empresa.com',NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: id no pot ser nul
  pfc_BDR.PKG_CENTRES.PR_MODIF_CENTRE(NULL,'Centre 33','telegraf 46',1,'08033','932211589','centre33@empresa.com',NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: la data d alta no pot ser posterior a la data de baixa
  pfc_BDR.PKG_CENTRES.PR_MODIF_CENTRE(pfc_BDR.PKG_CENTRES.FN_OBTENIR_ID_NOMCENTRE('Centre 33'),'Centre 33','telegraf 46',1,'08033','932211589','centre33@empresa.com',SYSDATE-3,SYSDATE-8,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: poblacio no existeix en la base de dades
  pfc_BDR.PKG_CENTRES.PR_MODIF_CENTRE(pfc_BDR.PKG_CENTRES.FN_OBTENIR_ID_NOMCENTRE('Centre 33'),'Centre 33','telegraf 46',88,'08033','932211589','centre33@empresa.com',NULL,NULL,res); 
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: La data d alta o la data de baixa no poden ser posteriors a la data actual
  pfc_BDR.PKG_CENTRES.PR_MODIF_CENTRE(pfc_BDR.PKG_CENTRES.FN_OBTENIR_ID_NOMCENTRE('Centre 33'),'Centre 33','telegraf 46',1,'08033','932211589','centre33@empresa.com',null,SYSDATE+8,res);
  DBMS_OUTPUT.PUT_LINE(res);   
END;
/


---------------------------------------------------
-----------------  EMPRESES  ----------------------
---------------------------------------------------
DECLARE
  res VARCHAR2(20000);
BEGIN
DBMS_OUTPUT.PUT_LINE('-----------------  EMPRESES  ----------------------');
--ALTA
DBMS_OUTPUT.PUT_LINE('--PROVES: ALTA');
  --alta - ok
  pfc_BDR.PKG_EMPRESES.PR_ALTA_EMPRESA('Net Driver','N8834534D','Diputacion 291',1,'08009','902999311','902999217', NULL,'comercial@netdriver.es',NULL,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: ja existeix
  pfc_BDR.PKG_EMPRESES.PR_ALTA_EMPRESA('Net Driver','N8834534D','Diputacion 291',1,'08009','902999311','902999217', NULL,'comercial@netdriver.es',NULL,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: camp nul
  pfc_BDR.PKG_EMPRESES.PR_ALTA_EMPRESA(NULL,'N8834534D','Diputacion 291',1,'08009','902999311','902999217', NULL,'comercial@netdriver.es',NULL,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: camp nul
  pfc_BDR.PKG_EMPRESES.PR_ALTA_EMPRESA('Net Driver 2',NULL,'Diputacion 291',1,'08009','902999311','902999217', NULL,'comercial@netdriver.es',NULL,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: camp nul
  pfc_BDR.PKG_EMPRESES.PR_ALTA_EMPRESA('Net Driver 2','N8834534D',NULL,1,'08009','902999311','902999217', NULL,'comercial@netdriver.es',NULL,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: camp nul
  pfc_BDR.PKG_EMPRESES.PR_ALTA_EMPRESA('Net Driver 2','N8834534A','Diputacion 291',NULL,'08009','902999311','902999217', NULL,'comercial@netdriver.es',NULL,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: camp nul
  pfc_BDR.PKG_EMPRESES.PR_ALTA_EMPRESA('Net Driver 2','N8834534A','Diputacion 291',1,'08009',NULL,'902999217', NULL,'comercial@netdriver.es',NULL,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);    
  --error: poblacio no existeix en la base de dades
  pfc_BDR.PKG_EMPRESES.PR_ALTA_EMPRESA('Net Driver 2','N8834534A','Diputacion 291',111,'08009','902999311','902999217', NULL,'comercial@netdriver.es',NULL,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);  
--BAIXA
DBMS_OUTPUT.PUT_LINE('--PROVES: BAIXA');
  --baixa - ok  
  pfc_BDR.PKG_EMPRESES.PR_BAIXA_EMPRESA(pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_NIF_EMPRESA('N8834534D'),res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: ja donada de baixa
  pfc_BDR.PKG_EMPRESES.PR_BAIXA_EMPRESA(pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_NIF_EMPRESA('N8834534D'),res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: no existeix
  pfc_BDR.PKG_EMPRESES.PR_BAIXA_EMPRESA(99,res);
  DBMS_OUTPUT.PUT_LINE(res); 
--MODIFICACIO
DBMS_OUTPUT.PUT_LINE('--PROVES: MODIFICACIO');
  --modificacio - ok  
  pfc_BDR.PKG_EMPRESES.PR_MODIF_EMPRESA(pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_NIF_EMPRESA('N8834534D'),'Net Driver','N8834534D','Diputacion 299',1,'08009','902999311','902999217', NULL,'soporte@netdriver.es',NULL,NULL,NULL,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: id no existeix
  pfc_BDR.PKG_EMPRESES.PR_MODIF_EMPRESA(pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_NIF_EMPRESA('N883453'),'Net Driver','N8834534D','Diputacion 299',1,'08009','902999311','902999217', NULL,'soporte@netdriver.es',NULL,NULL,NULL,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: id no pot ser nul
  pfc_BDR.PKG_EMPRESES.PR_MODIF_EMPRESA(NULL,'Net Driver','N8834534D','Diputacion 299',1,'08009','902999311','902999217', NULL,'soporte@netdriver.es',NULL,NULL,NULL,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: la data d alta no pot ser posterior a la data de baixa
  pfc_BDR.PKG_EMPRESES.PR_MODIF_EMPRESA(pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_NIF_EMPRESA('N8834534D'),'Net Driver','N8834534D','Diputacion 299',1,'08009','902999311','902999217', NULL,'soporte@netdriver.es',NULL,NULL,NULL,NULL,SYSDATE-3,SYSDATE-8,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: poblacio no existeix en la base de dades
  pfc_BDR.PKG_EMPRESES.PR_MODIF_EMPRESA(pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_NIF_EMPRESA('N8834534D'),'Net Driver','N8834534D','Diputacion 299',122,'08009','902999311','902999217', NULL,'soporte@netdriver.es',NULL,NULL,NULL,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: La data d alta o la data de baixa no poden ser posteriors a la data actual
  pfc_BDR.PKG_EMPRESES.PR_MODIF_EMPRESA(pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_NIF_EMPRESA('N8834534D'),'Net Driver','N8834534D','Diputacion 299',1,'08009','902999311','902999217', NULL,'soporte@netdriver.es',NULL,NULL,NULL,NULL,null,SYSDATE+8,res);    
  DBMS_OUTPUT.PUT_LINE(res); 
END;
/


---------------------------------------------------
-----------------  OPERARIS  ----------------------
---------------------------------------------------
DECLARE
  res VARCHAR2(20000);
BEGIN
DBMS_OUTPUT.PUT_LINE('-----------------  OPERARI  -----------------------');
--ALTA
DBMS_OUTPUT.PUT_LINE('--PROVES: ALTA');
  --alta - ok
  pfc_BDR.PKG_EMPRESES.PR_ALTA_OPERARI(1,'990',res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: ja existeix
  pfc_BDR.PKG_EMPRESES.PR_ALTA_OPERARI(1,'990',res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: camp nul
  pfc_BDR.PKG_EMPRESES.PR_ALTA_OPERARI(NULL,'990',res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: camp nul
  pfc_BDR.PKG_EMPRESES.PR_ALTA_OPERARI(1,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: l empresa no existeix
  pfc_BDR.PKG_EMPRESES.PR_ALTA_OPERARI(111,'1111',res);
  DBMS_OUTPUT.PUT_LINE(res);
--BAIXA
DBMS_OUTPUT.PUT_LINE('--PROVES: BAIXA');
  --baixa - ok  
  pfc_BDR.PKG_EMPRESES.PR_BAIXA_OPERARI(pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'990'),res);
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: ja donat de baixa
  pfc_BDR.PKG_EMPRESES.PR_BAIXA_OPERARI(pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'990'),res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: no existeix
  pfc_BDR.PKG_EMPRESES.PR_BAIXA_OPERARI(pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'000'),res);
  DBMS_OUTPUT.PUT_LINE(res); 
--MODIFICACIO
DBMS_OUTPUT.PUT_LINE('--PROVES: MODIFICACIO');
  --modificacio - ok  
  pfc_BDR.PKG_EMPRESES.PR_MODIF_OPERARI(pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'990'),1,'991',NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: id no existeix
  pfc_BDR.PKG_EMPRESES.PR_MODIF_OPERARI(pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'990'),1,'991',NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: id no pot ser nul
  pfc_BDR.PKG_EMPRESES.PR_MODIF_OPERARI(NULL,1,'991',NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: la data d alta no pot ser posterior a la data de baixa
  pfc_BDR.PKG_EMPRESES.PR_MODIF_OPERARI(pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'991'),1,'991',SYSDATE-3,SYSDATE-8,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: La data d alta o la data de baixa no poden ser posteriors a la data actual
  pfc_BDR.PKG_EMPRESES.PR_MODIF_OPERARI(pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'991'),1,'991',null,SYSDATE+8,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: l empresa no existeix en la base de dades
  pfc_BDR.PKG_EMPRESES.PR_MODIF_OPERARI(pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'991'),1111,'991',null,null,res);
  DBMS_OUTPUT.PUT_LINE(res);   
END;
/


---------------------------------------------------
--------------  CATEGORIES  -----------------------
---------------------------------------------------
DECLARE
  res VARCHAR2(20000);
BEGIN
DBMS_OUTPUT.PUT_LINE('--------------  CATEGORIES  -----------------------');
--ALTA
DBMS_OUTPUT.PUT_LINE('--PROVES: ALTA');
  --alta - ok
  pfc_BDR.PKG_EQUIPS.PR_ALTA_CATEGORIA('sai',res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: ja existeix
  pfc_BDR.PKG_EQUIPS.PR_ALTA_CATEGORIA('sai',res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: camp nul
  pfc_BDR.PKG_EQUIPS.PR_ALTA_CATEGORIA(NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);    
--BAIXA
DBMS_OUTPUT.PUT_LINE('--PROVES: BAIXA');
  --baixa - ok  
  pfc_BDR.PKG_EQUIPS.PR_BAIXA_CATEGORIA(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_CATEGORIA('sai'),res);
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: ja donada de baixa
  pfc_BDR.PKG_EQUIPS.PR_BAIXA_CATEGORIA(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_CATEGORIA('sai'),res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: no existeix
  pfc_BDR.PKG_EQUIPS.PR_BAIXA_CATEGORIA(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_CATEGORIA('servidor'),res);
  DBMS_OUTPUT.PUT_LINE(res);
--MODIFICACIO
DBMS_OUTPUT.PUT_LINE('--PROVES: MODIFICACIO');
  --modificacio - ok  
  pfc_BDR.PKG_EQUIPS.PR_MODIF_CATEGORIA(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_CATEGORIA('sai'),'sais',NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: id no existeix
  pfc_BDR.PKG_EQUIPS.PR_MODIF_CATEGORIA(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_CATEGORIA('sai'),'sais',NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: id no pot ser nul
  pfc_BDR.PKG_EQUIPS.PR_MODIF_CATEGORIA(NULL,'sais',NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: la data d alta no pot ser posterior a la data de baixa
  pfc_BDR.PKG_EQUIPS.PR_MODIF_CATEGORIA(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_CATEGORIA('sais'),'sais',SYSDATE-3,SYSDATE-8,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: La data d alta o la data de baixa no poden ser posteriors a la data actual
  pfc_BDR.PKG_EQUIPS.PR_MODIF_CATEGORIA(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_CATEGORIA('sais'),'sais',null,SYSDATE+8,res);
  DBMS_OUTPUT.PUT_LINE(res);    
END;
/


---------------------------------------------------
------------------  MARQUES  ----------------------
---------------------------------------------------
DECLARE
  res VARCHAR2(20000);
BEGIN
DBMS_OUTPUT.PUT_LINE('-------------------  MARCA  -----------------------'); 
--ALTA
DBMS_OUTPUT.PUT_LINE('--PROVES: ALTA');
  --alta - ok
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MARCA('APC',res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: ja existeix
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MARCA('APC',res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: camp nul
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MARCA(NULL,res);
  DBMS_OUTPUT.PUT_LINE(res); 
--BAIXA
DBMS_OUTPUT.PUT_LINE('--PROVES: BAIXA');
  --baixa - ok  
  pfc_BDR.PKG_EQUIPS.PR_BAIXA_MARCA(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MARCA('APC'),res);
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: ja donada de baixa
  pfc_BDR.PKG_EQUIPS.PR_BAIXA_MARCA(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MARCA('APC'),res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: no existeix
  pfc_BDR.PKG_EQUIPS.PR_BAIXA_MARCA(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MARCA('APCXX'),res);
  DBMS_OUTPUT.PUT_LINE(res);  
--MODIFICACIO
DBMS_OUTPUT.PUT_LINE('--PROVES: MODIFICACIO');
  --modificacio - ok  
  pfc_BDR.PKG_EQUIPS.PR_MODIF_MARCA(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MARCA('APC'),'APC SAIS',NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: id no existeix
  pfc_BDR.PKG_EQUIPS.PR_MODIF_MARCA(99,'APC SAIS',NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: id no pot ser nul
  pfc_BDR.PKG_EQUIPS.PR_MODIF_MARCA(NULL,'APC SAIS',NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: la data d alta no pot ser posterior a la data de baixa
  pfc_BDR.PKG_EQUIPS.PR_MODIF_MARCA(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MARCA('APC SAIS'),'APC SAIS',SYSDATE-3,SYSDATE-8,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: La data d alta o la data de baixa no poden ser posteriors a la data actual
  pfc_BDR.PKG_EQUIPS.PR_MODIF_MARCA(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MARCA('APC SAIS'),'APC SAIS',null,SYSDATE+8,res);
  DBMS_OUTPUT.PUT_LINE(res);    
END;
/


---------------------------------------------------
-------------------  MODELS  ----------------------
---------------------------------------------------
DECLARE
  res VARCHAR2(20000);
BEGIN
DBMS_OUTPUT.PUT_LINE('-------------------  MODELS  ----------------------'); 
--ALTA
DBMS_OUTPUT.PUT_LINE('--PROVES: ALTA');
  --alta - ok
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MODEL(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MARCA('APC SAIS'),'APC Smart-UPS 3000','UPS ( externa ) - CA 220 V - 3000 VA - batera de UPS cido de plomo',pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_CATEGORIA('sais'),res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: ja existeix
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MODEL(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MARCA('APC SAIS'),'APC Smart-UPS 3000','UPS ( externa ) - CA 220 V - 3000 VA - batera de UPS cido de plomo',pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_CATEGORIA('sais'),res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: camp nul
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MODEL(NULL,'APC Smart-UPS 3000','UPS ( externa ) - CA 220 V - 3000 VA - batera de UPS cido de plomo',pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_CATEGORIA('sais'),res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: camp nul
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MODEL(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MARCA('APC SAIS'),NULL,'UPS ( externa ) - CA 220 V - 3000 VA - batera de UPS cido de plomo',pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_CATEGORIA('sais'),res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: camp nul
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MODEL(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MARCA('APC SAIS'),'APC Smart-UPS 3000',NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: la marca del model no existeix
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MODEL(888,'APC Smart-UPS 3500','UPS ( externa ) - CA 220 V - 3000 VA - batera de UPS cido de plomo',pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_CATEGORIA('sais'),res); 
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: la categoria del model no existeix
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MODEL(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MARCA('APC SAIS'),'APC Smart-UPS 3500',NULL,777,res); 
  DBMS_OUTPUT.PUT_LINE(res);   
--BAIXA
DBMS_OUTPUT.PUT_LINE('--PROVES: BAIXA');
  --baixa - ok  
  pfc_BDR.PKG_EQUIPS.PR_BAIXA_MODEL(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MODEL(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MARCA('APC SAIS'),'APC Smart-UPS 3000'),res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: ja donada de baixa
  pfc_BDR.PKG_EQUIPS.PR_BAIXA_MODEL(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MODEL(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MARCA('APC SAIS'),'APC Smart-UPS 3000'),res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: no existeix
  pfc_BDR.PKG_EQUIPS.PR_BAIXA_MODEL(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MODEL(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MARCA('APC SAIS'),'APC Smart-UPS 3000 XXXX'),res);
  DBMS_OUTPUT.PUT_LINE(res); 
--MODIFICACIO
DBMS_OUTPUT.PUT_LINE('--PROVES: MODIFICACIO');
  --modificacio - ok  
  pfc_BDR.PKG_EQUIPS.PR_MODIF_MODEL(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MODEL(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MARCA('APC SAIS'),'APC Smart-UPS 3000'),'APC Smart-UPS 3000','CA 220 V - 3000 VA - batera de UPS cido de plomo',pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MARCA('APC SAIS'),pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_CATEGORIA('sais'),NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: id no existeix
  pfc_BDR.PKG_EQUIPS.PR_MODIF_MODEL(9999,'APC Smart-UPS 3000','CA 220 V - 3000 VA - batera de UPS cido de plomo',pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MARCA('APC SAIS'),pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_CATEGORIA('sais'),NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: id no pot ser nul
  pfc_BDR.PKG_EQUIPS.PR_MODIF_MODEL(NULL,'APC Smart-UPS 3000','CA 220 V - 3000 VA - batera de UPS cido de plomo',pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MARCA('APC SAIS'),pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_CATEGORIA('sais'),NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: la data d alta no pot ser posterior a la data de baixa
  pfc_BDR.PKG_EQUIPS.PR_MODIF_MODEL(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MODEL(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MARCA('APC SAIS'),'APC Smart-UPS 3000'),'APC Smart-UPS 3000','UPS ( externa ) - CA 220 V - 3000 VA - batera de UPS cido de plomo',pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MARCA('APC SAIS'),pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_CATEGORIA('sais'),SYSDATE-3,SYSDATE-8,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: la marca del model no existeix
  pfc_BDR.PKG_EQUIPS.PR_MODIF_MODEL(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MODEL(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MARCA('APC SAIS'),'APC Smart-UPS 3000'),'APC Smart-UPS 3000','UPS ( externa ) - CA 220 V - 3000 VA - batera de UPS cido de plomo',999,pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_CATEGORIA('sais'),NULL,NULL,res); 
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: la categoria del model no existeix
  pfc_BDR.PKG_EQUIPS.PR_MODIF_MODEL(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MODEL(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MARCA('APC SAIS'),'APC Smart-UPS 3000'),'APC Smart-UPS 3000','UPS ( externa ) - CA 220 V - 3000 VA - batera de UPS cido de plomo',pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MARCA('APC SAIS'),999,NULL,NULL,res); 
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: La data d alta o la data de baixa no poden ser posteriors a la data actual
  pfc_BDR.PKG_EQUIPS.PR_MODIF_MODEL(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MODEL(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MARCA('APC SAIS'),'APC Smart-UPS 3000'),'APC Smart-UPS 3000','UPS ( externa ) - CA 220 V - 3000 VA - batera de UPS cido de plomo',pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_MARCA('APC SAIS'),pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_NOM_CATEGORIA('sais'),null,SYSDATE+8,res);
  DBMS_OUTPUT.PUT_LINE(res);     
END;
/


---------------------------------------------------
-------------------  EQUIPS  ----------------------
---------------------------------------------------
DECLARE
  res VARCHAR2(20000);
BEGIN
DBMS_OUTPUT.PUT_LINE('-------------------  EQUIPS  ----------------------'); 
--ALTA
DBMS_OUTPUT.PUT_LINE('--PROVES: ALTA');
  --alta - ok
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N3456111111',7,4,11,'PC PLANTA 2 - AULA 1','01/05/2010','01/05/2012',res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: ja existeix
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N3456111111',7,4,12,'PC PLANTA 2 - AULA 1','01/05/2010','01/05/2012',res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: camp nul
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP(NULL,7,4,12,'PC PLANTA 2 - AULA 1','01/05/2010','01/05/2012',res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: camp nul
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N3456111112',NULL,4,12,'PC PLANTA 2 - AULA 1','01/05/2010','01/05/2012',res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: camp nul
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N3456111112',7,NULL,12,'PC PLANTA 2 - AULA 1','01/05/2010','01/05/2012',res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: camp nul
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N3456111112',7,4,NULL,'PC PLANTA 2 - AULA 1','01/05/2010','01/05/2012',res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: camp nul
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N3456111112',7,4,12,NULL,'01/05/2010','01/05/2012',res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: camp nul
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N3456111112',7,4,12,'PC PLANTA 2 - AULA 1',NULL,'01/05/2012',res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: camp nul
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N3456111112',7,4,12,'PC PLANTA 2 - AULA 1','01/05/2010',NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: model no existeix en la base de dades
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N3456111112',77,4,12,'PC PLANTA 2 - AULA 1','01/05/2010','01/05/2012',res);
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: categoria no existeix en la base de dades
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N3456111112',7,44,12,'PC PLANTA 2 - AULA 1','01/05/2010','01/05/2012',res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: centre no existeix en la base de dades
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N3456111112',7,4,54,'PC PLANTA 2 - AULA 1','01/05/2010','01/05/2012',res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: la categoria de l'equip ha de ser la mateixa que la categoria del model de l'equip
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N3456111112',7,5,12,'PC PLANTA 2 - AULA 1','01/05/2010','01/05/2012',res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: La data de compra no pot ser posterior a la data actual
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N3456111112',7,4,12,'PC PLANTA 2 - AULA 1','01/05/2015','01/05/2018',res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: la data de compra ha de ser inferior o igual a la data de fi de garantia
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N3456111112',7,4,12,'PC PLANTA 2 - AULA 1','01/05/2011','01/05/2010',res);
  DBMS_OUTPUT.PUT_LINE(res);   
--BAIXA  
DBMS_OUTPUT.PUT_LINE('--PROVES: BAIXA');
  --baixa - ok  
  pfc_BDR.PKG_EQUIPS.PR_BAIXA_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N3456111111',7),res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: ja donada de baixa
  pfc_BDR.PKG_EQUIPS.PR_BAIXA_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N3456111111',7),res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: no existeix
  pfc_BDR.PKG_EQUIPS.PR_BAIXA_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N3456111XX112',7),res);
  DBMS_OUTPUT.PUT_LINE(res); 
--MODIFICACIO  
DBMS_OUTPUT.PUT_LINE('--PROVES: MODIFICACIO');
  --modificacio - ok  
  pfc_BDR.PKG_EQUIPS.PR_MODIF_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N3456111111',7),'N3456111111',7,4,12,'PC PLANTA 2 - AULA 001','01/05/2010','01/05/2012',null,null,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: equip no existeix
  pfc_BDR.PKG_EQUIPS.PR_MODIF_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34561XXXX11112',7),'N3456111112',7,4,12,'PC PLANTA 2 - AULA 001','01/05/2010','01/05/2012',null,null,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: id no pot ser nul
  pfc_BDR.PKG_EQUIPS.PR_MODIF_EQUIP(null,'N3456111112',7,4,12,'PC PLANTA 2 - AULA 001','01/05/2010','01/05/2012',null,null,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: model no existeix en la base de dades
  pfc_BDR.PKG_EQUIPS.PR_MODIF_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N3456111111',7),'N3456111111',77,4,12,'PC PLANTA 2 - AULA 001','01/05/2010','01/05/2012',null,null,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: categoria no existeix en la base de dades
  pfc_BDR.PKG_EQUIPS.PR_MODIF_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N3456111111',7),'N3456111111',7,44,12,'PC PLANTA 2 - AULA 001','01/05/2010','01/05/2012',null,null,res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: centre no existeix en la base de dades
  pfc_BDR.PKG_EQUIPS.PR_MODIF_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N3456111111',7),'N3456111111',7,4,122,'PC PLANTA 2 - AULA 001','01/05/2010','01/05/2012',null,null,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: la data d alta no pot ser posterior a la data de baixa
  pfc_BDR.PKG_EQUIPS.PR_MODIF_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N3456111111',7),'N3456111111',7,4,12,'PC PLANTA 2 - AULA 001','01/05/2010','01/05/2012',sysdate-3,sysdate-8,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: La data de compra no pot ser posterior a la data actual
  pfc_BDR.PKG_EQUIPS.PR_MODIF_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N3456111111',7),'N3456111111',7,4,12,'PC PLANTA 2 - AULA 001','01/05/2012','01/05/2012',null,null,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: la data de compra ha de ser inferior o igual a la data de fi de garantia
  pfc_BDR.PKG_EQUIPS.PR_MODIF_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N3456111111',7),'N3456111111',7,4,12,'PC PLANTA 2 - AULA 001','01/05/2010','01/05/2008',null,null,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: La data d alta o la data de baixa no poden ser posteriors a la data actual
  pfc_BDR.PKG_EQUIPS.PR_MODIF_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N3456111111',7),'N3456111111',7,4,12,'PC PLANTA 2 - AULA 001','01/05/2010','01/05/2012',null,sysdate+8,res);
  DBMS_OUTPUT.PUT_LINE(res);    
--REUBICAR EQUIP
DBMS_OUTPUT.PUT_LINE('--PROVES: REUBICACIO');
  --reubicacio - ok
  pfc_BDR.PKG_EQUIPS.PR_REUBICAR_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N3456111111',7),10,res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: equip no existeix
  pfc_BDR.PKG_EQUIPS.PR_REUBICAR_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N3456NNNN111111',7),10,res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: centre no existeix
  pfc_BDR.PKG_EQUIPS.PR_REUBICAR_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N3456111111',7),9988,res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: camp nul
  pfc_BDR.PKG_EQUIPS.PR_REUBICAR_EQUIP(null,10,res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: camp nul
  pfc_BDR.PKG_EQUIPS.PR_REUBICAR_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N3456111111',7),null,res);
  DBMS_OUTPUT.PUT_LINE(res);  
END;
/


---------------------------------------------------
------------  MANTENIMENTS CORRECTIUS  ------------
---------------------------------------------------
DECLARE
  res VARCHAR2(20000);
BEGIN
DBMS_OUTPUT.PUT_LINE('------------  MANTENIMENTS CORRECTIUS  ------------'); 
--ALTA
DBMS_OUTPUT.PUT_LINE('--PROVES: ALTA');
  --alta - ok
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),'08/09/2011 10:00','pita quan s encn i el SO no es carrega',pfc_BDR.PKG_AUXILIAR.FN_OBTENIR_ID_LOGIN_USUARI('dflores'),3,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: ja existeix
  --aquest error no existeix, es poden donar d'alta les incidncies que es vulguin, ja que es guarda l'hora si es vol. el programa s'encarregar de consultar les incidncies de l'equip i mostrar-les per saber si ja s'ha introduit.
  --s responsabilitat de la persona encarregada d introduir les incidencies de no duplicar-les
  --error: camp nul
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU(NULL,'08/09/2011','pita quan s encn i el SO no es carrega',pfc_BDR.PKG_AUXILIAR.FN_OBTENIR_ID_LOGIN_USUARI('dflores'),3,res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: camp nul
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),NULL,'pita quan s encn i el SO no es carrega',pfc_BDR.PKG_AUXILIAR.FN_OBTENIR_ID_LOGIN_USUARI('dflores'),3,res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: camp nul
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),'08/09/2011',NULL,pfc_BDR.PKG_AUXILIAR.FN_OBTENIR_ID_LOGIN_USUARI('dflores'),3,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: camp nul
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),'08/09/2011','pita quan s encn i el SO no es carrega',NULL,3,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: camp nul
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),'08/09/2011','pita quan s encn i el SO no es carrega',pfc_BDR.PKG_AUXILIAR.FN_OBTENIR_ID_LOGIN_USUARI('dflores'),NULL,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: l equip no existeix en la Base de Dades
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU(88,'08/09/2011','pita quan s encn i el SO no es carrega',pfc_BDR.PKG_AUXILIAR.FN_OBTENIR_ID_LOGIN_USUARI('dflores'),3,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: l usuari no existeix en la Base de Dades
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),'08/09/2011','pita quan s encn i el SO no es carrega',888,3,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: la prioritat no existeix en la Base de Dades
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),'08/09/2011','pita quan s encn i el SO no es carrega',pfc_BDR.PKG_AUXILIAR.FN_OBTENIR_ID_LOGIN_USUARI('dflores'),55,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: la data d incidencia no pot ser anterior a la data de compra d un equip
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU(1,'08/09/2005','pita quan s encn i el SO no es carrega',pfc_BDR.PKG_AUXILIAR.FN_OBTENIR_ID_LOGIN_USUARI('dflores'),3,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: la data d incidencia no pot ser posterior a la data actual
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),'08/09/2021','pita quan s encn i el SO no es carrega',pfc_BDR.PKG_AUXILIAR.FN_OBTENIR_ID_LOGIN_USUARI('dflores'),2,res);
  DBMS_OUTPUT.PUT_LINE(res);   
--BAIXA
DBMS_OUTPUT.PUT_LINE('--PROVES: BAIXA');
  --baixa - ok  
  --el programa mostrar les incidncies d'un equip i l usuari ser l'encarregat d indicar quina s la que vol donar de baixa. Per aquest exemple donem de baixa l ultim manteniment correctiu de l equip introduit
  pfc_BDR.PKG_MANTENIMENTS.PR_BAIXA_MANT_CORRECTIU(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7)),res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: ja donat de baixa
  pfc_BDR.PKG_MANTENIMENTS.PR_BAIXA_MANT_CORRECTIU(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7)),res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: equip no existeix
  pfc_BDR.PKG_MANTENIMENTS.PR_BAIXA_MANT_CORRECTIU(88,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7)),res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: manteniment no existeix
  pfc_BDR.PKG_MANTENIMENTS.PR_BAIXA_MANT_CORRECTIU(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),99,res);
  DBMS_OUTPUT.PUT_LINE(res); 
--MODIFICACIO  
DBMS_OUTPUT.PUT_LINE('--PROVES: MODIFICACIO');    
  --modificacio - ok  
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_MANT_CORRECTIU (2,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(2),NULL,NULL,'08/01/2011','el ventilador fa molt de soroll',pfc_BDR.PKG_AUXILIAR.FN_OBTENIR_ID_LOGIN_USUARI('lgarcia'),3,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: equip no existeix
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_MANT_CORRECTIU (88,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(2),NULL,NULL,'03/09/2011','pita quan s encn i el SO no es carrega',pfc_BDR.PKG_AUXILIAR.FN_OBTENIR_ID_LOGIN_USUARI('dflores'),3,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: manteniment equip no existeix
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_MANT_CORRECTIU (pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),77,NULL,NULL,'03/09/2011','pita quan s encn i el SO no es carrega',pfc_BDR.PKG_AUXILIAR.FN_OBTENIR_ID_LOGIN_USUARI('dflores'),3,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: id no pot ser nul
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_MANT_CORRECTIU (NULL,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7)),NULL,NULL,'03/09/2011','pita quan s encn i el SO no es carrega',pfc_BDR.PKG_AUXILIAR.FN_OBTENIR_ID_LOGIN_USUARI('dflores'),3,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: id no pot ser nul
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_MANT_CORRECTIU (pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),NULL,NULL,NULL,'03/09/2011 10:00','pita quan s encn i el SO no es carrega',pfc_BDR.PKG_AUXILIAR.FN_OBTENIR_ID_LOGIN_USUARI('dflores'),3,res);
  DBMS_OUTPUT.PUT_LINE(res);    
  --error: la data d alta no pot ser posterior a la data de baixa
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_MANT_CORRECTIU (pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7)),SYSDATE-100,SYSDATE-150,'03/09/2011','pita quan s encn i el SO no es carrega',pfc_BDR.PKG_AUXILIAR.FN_OBTENIR_ID_LOGIN_USUARI('dflores'),3,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: la data d incidencia no pot ser anterior a la data de compra d un equip
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_MANT_CORRECTIU (2,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(2),null,null,'03/09/2004','pita quan s encn i el SO no es carrega',pfc_BDR.PKG_AUXILIAR.FN_OBTENIR_ID_LOGIN_USUARI('dflores'),3,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: usuari no existeix
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_MANT_CORRECTIU (2,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(2),NULL,NULL,'03/09/2011','pita quan s encn i el SO no es carrega',99,3,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: prioritat no existeix
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_MANT_CORRECTIU (2,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(2),NULL,NULL,'03/09/2011','pita quan s encn i el SO no es carrega',pfc_BDR.PKG_AUXILIAR.FN_OBTENIR_ID_LOGIN_USUARI('dflores'),33,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: la data d incidencia no pot ser posterior a la data actual
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_MANT_CORRECTIU (pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7)),SYSDATE-100,SYSDATE,'03/09/2021','pita quan s encn i el SO no es carrega',pfc_BDR.PKG_AUXILIAR.FN_OBTENIR_ID_LOGIN_USUARI('dflores'),3,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: La data d alta o la data de baixa no poden ser posteriors a la data actual
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_MANT_CORRECTIU (pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7)),SYSDATE,SYSDATE+100,'03/09/2011','pita quan s encn i el SO no es carrega',pfc_BDR.PKG_AUXILIAR.FN_OBTENIR_ID_LOGIN_USUARI('dflores'),3,res);
  DBMS_OUTPUT.PUT_LINE(res);   
END;
/

  
---------------------------------------------------
-------------  RESOLUCIO MANTENIMENT  -------------
---------------------------------------------------
DECLARE
  res VARCHAR2(20000);
BEGIN
DBMS_OUTPUT.PUT_LINE('-------------  RESOLUCIO MANTENIMENT  -------------'); 
--ALTA
DBMS_OUTPUT.PUT_LINE('--PROVES: ALTA');
  --alta - ok
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7)),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_NIF_EMPRESA('H45634534D'),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'991'),'08/09/2011 15:30','08/09/2011 16:30','canvi de ram',res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: ja existeix
  --un manteniment correctiu d un equip noms pot tenir una resoluci associada a aquest manteniment
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7)),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_NIF_EMPRESA('H45634534D'),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'991'),'08/09/2011 15:30','08/09/2011 16:30','canvi de ram',res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: camp nul
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR(NULL,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7)),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_NIF_EMPRESA('H45634534D'),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'991'),'08/09/2011 15:30','08/09/2011 16:30','canvi de ram',res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: camp nul
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),null,pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_NIF_EMPRESA('H45634534D'),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'991'),'08/09/2011 15:30','08/09/2011 16:30','canvi de ram',res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: camp nul
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7)),null,pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'991'),'08/09/2011 15:30','08/09/2011 16:30','canvi de ram',res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: camp nul
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7)),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_NIF_EMPRESA('H45634534D'),null,'03/09/2011 15:30','03/09/2011 16:30','canvi de ram',res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: camp nul
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7)),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_NIF_EMPRESA('H45634534D'),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'991'),null,'08/09/2011 16:30','canvi de ram',res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: camp nul
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7)),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_NIF_EMPRESA('H45634534D'),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'991'),'08/09/2011 15:30',null,'canvi de ram',res);
  DBMS_OUTPUT.PUT_LINE(res);    
  --error: l equip no existeix en la Base de Dades
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR(333,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7)),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_NIF_EMPRESA('H45634534D'),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'991'),'08/09/2011 15:30','08/09/2011 16:30','canvi de ram',res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: el manteniment no existeix en la Base de Dades
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),333,pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_NIF_EMPRESA('H45634534D'),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'991'),'08/09/2011 15:30','08/09/2011 16:30','canvi de ram',res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: l empresa no existeix en la Base de Dades
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR(22,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(22),999,pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'991'),'08/10/2011 15:30','08/10/2011 18:30','la porta s ha sortit',res);
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: l operari no existeix en la Base de Dades
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR(22,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(22),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_NIF_EMPRESA('H45634534D'),999,'08/10/2011 15:30','08/10/2011 18:30','la porta s ha sortit',res);
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: l operari no pertany a l empresa
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR(22,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(22),2,pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'991'),'08/10/2011 15:30','08/10/2011 18:30','la porta s ha sortit',res);
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: la data de fi de resolucio no pot ser anterior a la data d'inici de resolucio
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR(22,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(22),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_NIF_EMPRESA('H45634534D'),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'991'),'08/10/2011 15:30','08/10/2011 12:30','la porta s ha sortit',res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: la data d inici de resolucio no pot ser anterior a la data de la incidncia
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR(22,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(22),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_NIF_EMPRESA('H45634534D'),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'991'),'08/10/2011 09:30','08/10/2011 19:30','la porta s ha sortit',res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: La data d inici de resolucio o la data fi no poden ser posteriors a la data actual
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR(22,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(22),1,pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'991'),'08/12/2021 15:30','08/10/2022 18:30','la porta s ha sortit',res);
  DBMS_OUTPUT.PUT_LINE(res);     
--BAIXA
DBMS_OUTPUT.PUT_LINE('--PROVES: BAIXA');
  --baixa - ok   
  pfc_BDR.PKG_MANTENIMENTS.PR_BAIXA_RESOLUCIO_MANTCORR(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7)),res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: ja donada de baixa
  pfc_BDR.PKG_MANTENIMENTS.PR_BAIXA_RESOLUCIO_MANTCORR(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7)),res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: no existeix
  pfc_BDR.PKG_MANTENIMENTS.PR_BAIXA_RESOLUCIO_MANTCORR(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),999,res);
  DBMS_OUTPUT.PUT_LINE(res);  
--MODIFICACIO  
DBMS_OUTPUT.PUT_LINE('--PROVES: MODIFICACIO');    
  --modificacio - ok    
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_RESOLUCIO_MANTCORR(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7)),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_NIF_EMPRESA('H45634534D'),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'991'),'08/09/2011 15:30','08/09/2011 18:30','canvi de ram',null,null,res);  
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: id no existeix
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_RESOLUCIO_MANTCORR(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),888,pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_NIF_EMPRESA('H45634534D'),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'991'),'08/09/2011 15:30','08/09/2011 18:30','canvi de ram',null,null,res); 
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: id no pot ser nul
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_RESOLUCIO_MANTCORR(null,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7)),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_NIF_EMPRESA('H45634534D'),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'991'),'08/09/2011 15:30','08/09/2011 18:30','canvi de ram',null,null,res);  
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: id no pot ser nul
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_RESOLUCIO_MANTCORR(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),null,pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_NIF_EMPRESA('H45634534D'),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'991'),'08/09/2011 15:30','08/09/2011 18:30','canvi de ram',null,null,res); 
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: la data d alta no pot ser posterior a la data de baixa
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_RESOLUCIO_MANTCORR(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7)),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_NIF_EMPRESA('H45634534D'),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'991'),'08/09/2011 15:30','08/09/2011 18:30','canvi de ram',sysdate-10,sysdate-12,res); 
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: la data de fi de resolucio no pot ser anterior a la data d'inici de resolucio
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_RESOLUCIO_MANTCORR(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7)),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_NIF_EMPRESA('H45634534D'),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'991'),'08/09/2011 15:30','08/09/2011 11:30','canvi de ram',null,null,res); 
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: la data d inici de resolucio no pot ser anterior a la data de la incidncia
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_RESOLUCIO_MANTCORR(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7)),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_NIF_EMPRESA('H45634534D'),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'991'),'01/09/2011 15:30','08/09/2011 19:30','canvi de ram',null,null,res); 
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: l equip no existeix en la Base de Dades
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_RESOLUCIO_MANTCORR(999,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7)),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_NIF_EMPRESA('H45634534D'),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'991'),null,'08/09/2021 18:30',null,null,null,res); 
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: el manteniment no existeix en la Base de Dades
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_RESOLUCIO_MANTCORR(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),99,pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_NIF_EMPRESA('H45634534D'),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'991'),null,'08/09/2021 18:30',null,null,null,res); 
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: l empresa no existeix en la Base de Dades
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_RESOLUCIO_MANTCORR(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7)),99,pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'991'),null,'08/09/2021 18:30',null,null,null,res); 
  DBMS_OUTPUT.PUT_LINE(res);    
  --error: l operari no existeix en la Base de Dades
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_RESOLUCIO_MANTCORR(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7)),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_NIF_EMPRESA('H45634534D'),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'99991'),null,'08/09/2021 18:30',null,null,null,res); 
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: l operari no pertany a l empresa
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_RESOLUCIO_MANTCORR(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7)),4,pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'991'),null,'08/09/2021 18:30',null,null,null,res); 
  DBMS_OUTPUT.PUT_LINE(res);    
  --error: la data d inici o data fi de la resolucio no poden ser posteriors a la data actual
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_RESOLUCIO_MANTCORR(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7)),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_NIF_EMPRESA('H45634534D'),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'991'),null,'08/09/2021 18:30',null,null,null,res); 
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: La data d alta o la data de baixa no poden ser posteriors a la data actual
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_RESOLUCIO_MANTCORR(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7),pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANCORR_EQUIP(pfc_BDR.PKG_EQUIPS.FN_OBTENIR_ID_EQUIP('N34567RTG572',7)),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_NIF_EMPRESA('H45634534D'),pfc_BDR.PKG_EMPRESES.FN_OBTENIR_ID_CODI_OPERARI(1,'991'),'08/09/2011 15:30','08/09/2011 18:30','canvi de ram',sysdate-10,sysdate+112,res); 
  DBMS_OUTPUT.PUT_LINE(res);   
END;
/  


---------------------------------------------------
---------  MANTENIMENTS  PREVENTIUS  --------------
---------------------------------------------------
DECLARE
  res VARCHAR2(20000);
BEGIN
DBMS_OUTPUT.PUT_LINE('----------  MANTENIMENTS  PREVENTIUS  --------------'); 
--ALTA
DBMS_OUTPUT.PUT_LINE('--PROVES: ALTA');
  --alta - ok
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_PREVENTIU(50,'23/03/2004','23/03/2007',12,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: ja existeix
  --si ja existeix un contracte de manteniment per l equip en algun moment del termini 
  --recordem que els manteniments preventius sn els manteniments obligatoris u opcionals 
  --que ha de rebre un equip amb la periodicitat que marca la llei segons l antiguitat del mateix
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_PREVENTIU(50,'23/03/2005','23/03/2008',12,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: camp nul
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_PREVENTIU(null,'24/03/2006','23/03/2008',12,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: camp nul
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_PREVENTIU(50,null,'23/03/2008',12,res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: camp nul
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_PREVENTIU(50,'24/03/2006',null,12,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: camp nul
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_PREVENTIU(50,'24/03/2006','23/03/2008',null,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: l equip no existeix en la Base de Dades
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_PREVENTIU(987,'24/03/2006','23/03/2008',12,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: la data de fi del contracte s anterior a la data d'inici del contracte 
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_PREVENTIU(50,'24/03/2008','23/03/2006',12,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: la data d inici del contracte s anterior a la data de compra de l equip
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_PREVENTIU(50,'24/03/2002','23/03/2003',12,res);
  DBMS_OUTPUT.PUT_LINE(res); 
--BAIXA
DBMS_OUTPUT.PUT_LINE('--PROVES: BAIXA');
  --baixa - ok  
  pfc_BDR.PKG_MANTENIMENTS.PR_BAIXA_MANT_PREVENTIU(50,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANPREV_EQUIP(50),res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: ja donat de baixa
  pfc_BDR.PKG_MANTENIMENTS.PR_BAIXA_MANT_PREVENTIU(50,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANPREV_EQUIP(50),res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: l equip no existeix en la Base de Dades
  pfc_BDR.PKG_MANTENIMENTS.PR_BAIXA_MANT_PREVENTIU(987,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANPREV_EQUIP(50),res);
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: el manteniment de l equip no existeix en la Base de Dades
  pfc_BDR.PKG_MANTENIMENTS.PR_BAIXA_MANT_PREVENTIU(50,88,res);
  DBMS_OUTPUT.PUT_LINE(res); 
--MODIFICACIO  
DBMS_OUTPUT.PUT_LINE('--PROVES: MODIFICACIO');    
  --modificacio - ok   
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_MANT_PREVENTIU(50,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANPREV_EQUIP(50),null,null,'23/03/2004','23/03/2006',12,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: id no pot ser nul
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_MANT_PREVENTIU(null,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANPREV_EQUIP(50),null,null,'23/03/2004','23/03/2007',12,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: id no pot ser nul
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_MANT_PREVENTIU(50,null,null,null,'23/03/2004','23/03/2007',12,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: l equip no existeix en la Base de Dades
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_MANT_PREVENTIU(500,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANPREV_EQUIP(50),null,null,'23/03/2004','23/03/2007',12,res); 
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: el manteniment de l equip no existeix en la Base de Dades
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_MANT_PREVENTIU(50,990,null,null,'23/03/2004','23/03/2007',12,res); 
  DBMS_OUTPUT.PUT_LINE(res);    
  --error: la data de fi del contracte s anterior a la data d'inici del contracte 
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_MANT_PREVENTIU(50,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANPREV_EQUIP(50),null,null,'23/03/2006','23/03/2004',12,res); 
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: la data d inici del contracte s anterior a la data de compra de l equip
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_MANT_PREVENTIU(50,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANPREV_EQUIP(50),null,null,'23/03/2002','23/03/2007',12,res); 
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: la data d alta no pot ser posterior a la data de baixa
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_MANT_PREVENTIU(50,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANPREV_EQUIP(50),sysdate-100,sysdate-150,'23/03/2004','23/03/2007',12,res); 
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: ja existeix un contracte de manteniment per l equip en algun moment del termini 
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_MANT_PREVENTIU(50,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANPREV_EQUIP(50),null,null,'23/11/2003',null,12,res); 
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: La data d alta o la data de baixa no poden ser posteriors a la data actual
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_MANT_PREVENTIU(50,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANPREV_EQUIP(50),sysdate-100,sysdate+150,'23/03/2004','23/03/2007',12,res); 
  DBMS_OUTPUT.PUT_LINE(res);  
END;
/   

									
---------------------------------------------------
----------------  REVISIO  ------------------------
---------------------------------------------------
DECLARE
  res VARCHAR2(20000);
BEGIN
DBMS_OUTPUT.PUT_LINE('----------------  REVISIO  ------------------------');
--REALITZAR REVISIO PENDENT
DBMS_OUTPUT.PUT_LINE('--PROVES: REALITZAR REVISIO PENDENT');
  --realitzaci - ok
  pfc_BDR.PKG_MANTENIMENTS.PR_REALITZAR_REVISIO_PENDENT(50,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANPREV_EQUIP(50),pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTREVPENDENT_EQUIP(50,4),'22/03/2005',8,11,null,res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: camp nul
  pfc_BDR.PKG_MANTENIMENTS.PR_REALITZAR_REVISIO_PENDENT(null,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANPREV_EQUIP(50),pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTREVPENDENT_EQUIP(50,4),'22/03/2005',8,11,null,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: camp nul
  pfc_BDR.PKG_MANTENIMENTS.PR_REALITZAR_REVISIO_PENDENT(50,null,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTREVPENDENT_EQUIP(50,4),'22/03/2005',8,11,null,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: camp nul
  pfc_BDR.PKG_MANTENIMENTS.PR_REALITZAR_REVISIO_PENDENT(50,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANPREV_EQUIP(50),null,'22/03/2005',8,11,null,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: camp nul
  pfc_BDR.PKG_MANTENIMENTS.PR_REALITZAR_REVISIO_PENDENT(50,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANPREV_EQUIP(50),pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTREVPENDENT_EQUIP(50,4),null,8,11,null,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: camp nul
  pfc_BDR.PKG_MANTENIMENTS.PR_REALITZAR_REVISIO_PENDENT(50,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANPREV_EQUIP(50),pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTREVPENDENT_EQUIP(50,4),'22/03/2005',null,11,null,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: camp nul
  pfc_BDR.PKG_MANTENIMENTS.PR_REALITZAR_REVISIO_PENDENT(50,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANPREV_EQUIP(50),pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTREVPENDENT_EQUIP(50,4),'22/03/2005',8,null,null,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: l equip no existeix en la Base de Dades
  pfc_BDR.PKG_MANTENIMENTS.PR_REALITZAR_REVISIO_PENDENT(500,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANPREV_EQUIP(50),pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTREVPENDENT_EQUIP(50,4),'22/03/2005',8,11,null,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: el manteniment no existeix en la Base de Dades
  pfc_BDR.PKG_MANTENIMENTS.PR_REALITZAR_REVISIO_PENDENT(50,990,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTREVPENDENT_EQUIP(50,4),'22/03/2005',8,11,null,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: la revisio no existeix en la Base de Dades
  pfc_BDR.PKG_MANTENIMENTS.PR_REALITZAR_REVISIO_PENDENT(50,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANPREV_EQUIP(50),4444,'22/03/2005',8,11,null,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: l empresa no existeix en la Base de Dades
  pfc_BDR.PKG_MANTENIMENTS.PR_REALITZAR_REVISIO_PENDENT(50,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANPREV_EQUIP(50),pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTREVPENDENT_EQUIP(50,4),'22/03/2005',888,11,null,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: l operari no existeix en la Base de Dades
  pfc_BDR.PKG_MANTENIMENTS.PR_REALITZAR_REVISIO_PENDENT(50,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANPREV_EQUIP(50),pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTREVPENDENT_EQUIP(50,4),'22/03/2005',8,1111,null,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: l operari no pertany a l empresa
  pfc_BDR.PKG_MANTENIMENTS.PR_REALITZAR_REVISIO_PENDENT(50,pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTIM_MANPREV_EQUIP(50),pfc_BDR.PKG_MANTENIMENTS.FN_OBTENIR_ULTREVPENDENT_EQUIP(50,4),'22/03/2005',4,11,null,res);
  DBMS_OUTPUT.PUT_LINE(res); 
--ALTA
DBMS_OUTPUT.PUT_LINE('--PROVES: ALTA');
  --alta - ok
  --pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(23,1,'28/03/2009','30/03/2009',7,10,NULL,res);
  --DBMS_OUTPUT.PUT_LINE(res); 
  --error: ja existeix una revisio pendent per l equip i manteniment
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(50,4,'22/03/2006',null,null,null,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: camp nul
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(null,4,'22/03/2006',null,null,null,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: camp nul
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(50,null,'22/03/2006',null,null,null,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);
  --error: camp nul
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(50,4,null,null,null,null,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: camp nul
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(50,4,'22/03/2006','20/03/2006',8,null,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: camp nul
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(50,4,'22/03/2006','20/03/2006',null,11,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: l equip no existeix en la Base de Dades
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(500,4,'22/03/2006',null,null,null,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: el manteniment no existeix en la Base de Dades
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(50,444,'22/03/2006',null,null,null,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: la data prevista de la revisi no s dins del perode del manteniment de l equip
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_PREVENTIU(52,'23/03/2003','22/03/2005',12,res);
  DBMS_OUTPUT.PUT_LINE(res);    
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV(52,1,1,'22/03/2004','20/03/2004',8,11,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(52,1,'21/03/2025',null,null,null,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: l empresa no existeix en la Base de Dades 
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(52,1,'21/03/2005','20/03/2005',88,11,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: l operari no existeix en la Base de Dades
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(52,1,'21/03/2005','20/03/2005',8,1111,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: l operari no pertany a l empresa  
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(52,1,'21/03/2005','20/03/2005',4,11,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);   
--BAIXA
DBMS_OUTPUT.PUT_LINE('--PROVES: BAIXA'); 
  --baixa - ok  
  pfc_BDR.PKG_MANTENIMENTS.PR_BAIXA_REVISIO_MANTPREV(52,1,1,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: ja donada de baixa
  pfc_BDR.PKG_MANTENIMENTS.PR_BAIXA_REVISIO_MANTPREV(52,1,1,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: l equip no existeix en la Base de Dades
  pfc_BDR.PKG_MANTENIMENTS.PR_BAIXA_REVISIO_MANTPREV(522,1,1,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: el manteniment no existeix en la Base de Dades
  pfc_BDR.PKG_MANTENIMENTS.PR_BAIXA_REVISIO_MANTPREV(52,1111,1,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: la revisio del manteniment de l equip no existeix en la Base de Dades
  pfc_BDR.PKG_MANTENIMENTS.PR_BAIXA_REVISIO_MANTPREV(52,1,111,res);
  DBMS_OUTPUT.PUT_LINE(res);  
--MODIFICACIO
DBMS_OUTPUT.PUT_LINE('--PROVES: MODIFICACIO'); 
  --modificacio - ok  
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV(52,1,1,'22/03/2004','21/03/2004',8,11,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: id no pot ser nul
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV(null,1,1,'22/03/2004','21/03/2004',8,11,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: id no pot ser nul
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV(52,null,1,'22/03/2004','21/03/2004',8,11,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: id no pot ser nul
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV(52,1,null,'22/03/2004','21/03/2004',8,11,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: l equip no existeix en la Base de Dades
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV(999,1,1,null,null,null,null,NULL,NULL,NULL,res);  
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: el manteniment no existeix en la Base de Dades
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV(52,111,1,'22/03/2004','21/03/2004',8,11,NULL,NULL,NULL,res);  
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: la revisio del manteniment de l equip no existeix en la Base de Dades
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV(52,1,111,'22/03/2004','21/03/2004',8,11,NULL,NULL,NULL,res);  
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: la data prevista de la revisi no s dins del perode del manteniment de l equip  
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV(52,1,1,'22/03/2024',null,null,null,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: la data d alta no pot ser posterior a la data de baixa
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV(52,1,1,null,null,null,null,NULL,sysdate-100,sysdate-200,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  --error: l empresa no existeix en la Base de Dades 
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV(52,1,1,null,null,88,null,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  --error: l operari no existeix en la Base de Dades
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV(52,1,1,null,null,null,111,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: l operari no pertany a l empresa  
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV(52,1,1,null,null,4,11,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --error: La data d alta o la data de baixa no poden ser posteriors a la data actual
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV(52,1,1,null,null,null,null,NULL,sysdate-100,sysdate+200,res);
  DBMS_OUTPUT.PUT_LINE(res);    
END;
/ 								

spool off
SET SERVEROUTPUT OFF
exit