-----------------------------------------
-----------------------------------------
SET SERVEROUTPUT ON;
spool C:\UOC\PFC\mbernard\logs\ar3-extraccio_llistats.log
--SET echo ON
-----------------------------------------
-----------------------------------------

---------------------------------------------------
---------------------------------------------------
--connectat com a PFC_BDR
ALTER SESSION SET NLS_DATE_FORMAT = 'DD/MM/YYYY HH24:MI:SS';
ALTER SESSION SET NLS_TIMESTAMP_FORMAT = 'DD/MM/YYYY HH24:MI:SS';
ALTER SESSION SET NLS_TIME_FORMAT = 'HH24:MI:SS';
COMMIT;

SET SERVEROUTPUT OFF
SET feedback OFF
SET linesize 800
SET trimout ON
SET trimspool ON
SET heads ON
SET heading ON
SET echo OFF


  -----------------------------------------
  --  LLISTATS CATEGORIES
  -----------------------------------------
  spool C:\UOC\PFC\mbernard\logs\ar31-llistat_categories.log

  SET LINESIZE 250
  SET PAGESIZE 30
  COLUMN idcategoria HEADING 'ID|CATEGORIA' FORMAT 999
  COLUMN nomCategoria FORMAT A30  

  --retorna un llistat de totes les categories
  SELECT *
  FROM TABLE(pfc_bdr.pkg_llistats.FN_LLISTA_CATEGORIES)
  ; 

  
  -----------------------------------------
  --  LLISTATS CENTRES
  -----------------------------------------  
  spool C:\UOC\PFC\mbernard\logs\ar32-llistat_centres.log
  
  SET LINESIZE 150
  SET PAGESIZE 35
  COLUMN idcentre HEADING 'ID|CENTRE' FORMAT 999
  COLUMN nomCentre FORMAT A15  
  COLUMN adrea FORMAT A20 
  COLUMN nomPoblacio HEADING 'poblacio' FORMAT A10  
  COLUMN codipostal HEADING 'CODI|POSTAL' FORMAT A6  
  COLUMN telefon FORMAT A15  
  COLUMN mail FORMAT A20 

  --retorna un llistat de tots els centres  
  SELECT *
  FROM TABLE(pfc_bdr.pkg_llistats.FN_LLISTA_CENTRES)
  ORDER BY idcentre
  ;    

   
  -----------------------------------------
  --  LLISTATS EQUIPS
  -----------------------------------------  
  
  --retorna un llistat de tots els equips de tots els centres
  --si el centre no existeix o s 0, retorna tots els equips de tots els centres
  --ordenat per centre i per categoria   
  spool C:\UOC\PFC\mbernard\logs\ar33-llistat_equips_centres.log
  
  SET LINESIZE 800
  SET PAGESIZE 300
  COLUMN idcentre HEADING 'ID|CENTRE' FORMAT 999
  COLUMN nomCentre HEADING 'CENTRE' FORMAT A15  
  COLUMN nomcategoria HEADING 'CATEGORIA' FORMAT A15   
  COLUMN nommarca HEADING 'MARCA' FORMAT A10 
  COLUMN nommodel HEADING 'MODEL' FORMAT A30  
  COLUMN idequip HEADING 'ID|EQUIP' FORMAT 999  
  COLUMN numserie FORMAT A15  
  COLUMN descripcio FORMAT A40 
  COLUMN datacompra HEADING 'DATA|COMPRA' FORMAT A20
  COLUMN datafigarantia HEADING 'DATA|FI|GARANTIA' FORMAT A20
  BREAK ON REPORT ON idcentre ON nomcentre NODUP SKIP PAGE ON nomcategoria ON nommarca ON nommodel SKIP 1

  SELECT *
  FROM TABLE(pfc_bdr.pkg_llistats.FN_LLISTA_EQUIPS_CENTRE(0))
  ;  

  
  --retorna un llistat de tots els equips del centre indicat
  --si el centre no existeix o s 0, retorna tots els equips de tots els centres
  --ordenat per centre i per categoria   
  spool C:\UOC\PFC\mbernard\logs\ar34-llistat_equips_1centre.log
  
  SET LINESIZE 800
  SET PAGESIZE 300
  COLUMN idcentre HEADING 'ID|CENTRE' FORMAT 999
  COLUMN nomCentre HEADING 'CENTRE' FORMAT A15  
  COLUMN nomcategoria HEADING 'CATEGORIA' FORMAT A15   
  COLUMN nommarca HEADING 'MARCA' FORMAT A10 
  COLUMN nommodel HEADING 'MODEL' FORMAT A30  
  COLUMN idequip HEADING 'ID|EQUIP' FORMAT 999  
  COLUMN numserie FORMAT A15  
  COLUMN descripcio FORMAT A40 
  COLUMN datacompra HEADING 'DATA|COMPRA' FORMAT A20
  COLUMN datafigarantia HEADING 'DATA|FI|GARANTIA' FORMAT A20
  BREAK ON REPORT ON idcentre ON nomcentre NODUP SKIP PAGE ON nomcategoria ON nommarca ON nommodel SKIP 1

  SELECT *
  FROM TABLE(pfc_bdr.pkg_llistats.FN_LLISTA_EQUIPS_CENTRE(2))
  ;  
  
  
  --retorna un llistat de tots els manteniments dels equips 
  --ordenat per categoria, equip i data del manteniment  
  spool C:\UOC\PFC\mbernard\logs\ar35-llistat_manteniments_equips.log
  
  SET LINESIZE 800
  SET PAGESIZE 300
  COLUMN nomcategoria HEADING 'CATEGORIA' FORMAT A15 
  COLUMN idequip HEADING 'ID|EQUIP' FORMAT 999  
  COLUMN numserie FORMAT A15  
  COLUMN nommarca HEADING 'MARCA' FORMAT A10 
  COLUMN nommodel HEADING 'MODEL' FORMAT A30  
  COLUMN descripcio FORMAT A40 
  COLUMN datacompra HEADING 'DATA|COMPRA' FORMAT A20  
  COLUMN nomCentre HEADING 'CENTRE' FORMAT A15  
  COLUMN tipusManteniment HEADING 'TIPUS|MANTENIMENT' FORMAT A15 
  COLUMN datainici HEADING 'DATA|INICI' FORMAT A20 
  COLUMN datafi HEADING 'DATA|FI' FORMAT A20   
  COLUMN nomempresa HEADING 'EMPRESA' FORMAT A25 
  COLUMN observacions FORMAT A50 
  BREAK ON REPORT ON nomcategoria SKIP PAGE ON idequip ON numserie ON nommarca ON nommodel ON descripcio ON datacompra ON nomCentre ON tipusManteniment SKIP 1
				  
  SELECT *
  FROM TABLE(pfc_bdr.pkg_llistats.FN_LLISTA_MANTENIMENTS_EQUIPS)
  ;       


  --retorna un llistat de les revisions pendents dels equips 
  --ordenat per data prevista de la revisi
  spool C:\UOC\PFC\mbernard\logs\ar36-llistat_revisions_pendents.log
  
  SET LINESIZE 800
  SET PAGESIZE 300
  COLUMN dataPrevista HEADING 'DATA|PREVISTA' FORMAT A20 
  COLUMN observacio FORMAT A75 
  COLUMN nomcategoria HEADING 'CATEGORIA' FORMAT A15 
  COLUMN idequip HEADING 'ID|EQUIP' FORMAT 999  
  COLUMN numserie FORMAT A15  
  COLUMN nommarca HEADING 'MARCA' FORMAT A10 
  COLUMN nommodel HEADING 'MODEL' FORMAT A30  
  COLUMN descripcio FORMAT A40 
  COLUMN datacompra HEADING 'DATA|COMPRA' FORMAT A20  
  COLUMN nomCentre HEADING 'CENTRE' FORMAT A15  
  BREAK ON REPORT ON SKIP PAGE 
				   
  SELECT *
  FROM TABLE(pfc_bdr.pkg_llistats.FN_LLISTA_REVISIONS_PENDENTS)
  ;    


  --retorna un llistat dels manteniments realitzats per les empreses de servei 
  --ordenat per empresa i data del manteniment 
  spool C:\UOC\PFC\mbernard\logs\ar37-llistat_manteniments_empreses.log
  
  SET LINESIZE 800
  SET PAGESIZE 300
  COLUMN idempresa HEADING 'ID|EMPRESA' FORMAT 999  
  COLUMN nomempresa HEADING 'EMPRESA' FORMAT A25 
  COLUMN nif FORMAT A15 
  COLUMN adrea FORMAT A25 
  COLUMN nomPoblacio HEADING 'poblacio' FORMAT A15 
  COLUMN telefon1 FORMAT A15 
  COLUMN fax FORMAT A15 
  COLUMN mail FORMAT A30 
  COLUMN personaContacte FORMAT A15 
  COLUMN telefonContacte FORMAT A15 
  COLUMN telefon24hores FORMAT A15 
  COLUMN mail FORMAT A30  
  COLUMN datainici HEADING 'DATA|INICI' FORMAT A20 
  COLUMN datafi HEADING 'DATA|FI' FORMAT A20   
  COLUMN tipusManteniment HEADING 'TIPUS|MANTENIMENT' FORMAT A15   
  COLUMN observacions FORMAT A25   
  COLUMN nomcategoria HEADING 'CATEGORIA' FORMAT A15 
  COLUMN idequip HEADING 'ID|EQUIP' FORMAT 999  
  COLUMN numserie FORMAT A15  
  COLUMN nommarca HEADING 'MARCA' FORMAT A10 
  COLUMN nommodel HEADING 'MODEL' FORMAT A30  
  COLUMN descripcio FORMAT A40 
  COLUMN datacompra HEADING 'DATA|COMPRA' FORMAT A20  
  COLUMN nomCentre HEADING 'CENTRE' FORMAT A15  
  BREAK ON REPORT ON idempresa ON nomempresa ON nif ON adrea ON nomPoblacio ON telefon1 ON fax ON mail ON personaContacte ON telefonContacte ON telefon24hores SKIP 1 ON mail SKIP PAGE 
  
  SELECT *
  FROM TABLE(pfc_bdr.pkg_llistats.FN_LLISTA_MANTENIMENTS_EMPRESA)
  ;      
 					

spool off
exit