-----------------------------------------
-----------------------------------------
spool C:\UOC\PFC\mbernard\logs\zc20-creacio_imatgeBDop.log
-----------------------------------------
-----------------------------------------

---------------------------------------------------
---------------------------------------------------
--connectat com a PFC_ODS
ALTER SESSION SET NLS_DATE_FORMAT = 'DD/MM/YYYY HH24:MI:SS';
ALTER SESSION SET NLS_TIMESTAMP_FORMAT = 'DD/MM/YYYY HH24:MI:SS';
ALTER SESSION SET NLS_TIME_FORMAT = 'HH24:MI:SS';
COMMIT;

---------------------------------------------------
--------------  CATEGORIA  ------------------------
---------------------------------------------------
--DROP TABLE op_categoria CASCADE CONSTRAINTS PURGE;
CREATE TABLE op_categoria(
      idcategoria INTEGER CONSTRAINT PK_op_categoria PRIMARY KEY
      , nomCategoria VARCHAR2(50) 
      , dataAlta DATE 
      , dataBaixa DATE 
)
TABLESPACE TS_ODS;
COMMIT;

---------------------------------------------------
--------------  POBLACIO  ------------------------
---------------------------------------------------
--DROP TABLE op_poblacio CASCADE CONSTRAINTS PURGE;
CREATE TABLE op_poblacio(
      idpoblacio INTEGER CONSTRAINT PK_op_poblacio PRIMARY KEY
      , nomPoblacio VARCHAR2(50) 
      , dataAlta DATE 
      , dataBaixa DATE 
)
TABLESPACE TS_ODS;
COMMIT;

---------------------------------------------------
-----------------  CENTRE  ------------------------
---------------------------------------------------
--DROP TABLE op_centre CASCADE CONSTRAINTS PURGE;
CREATE TABLE op_centre(
      idcentre INTEGER CONSTRAINT PK_op_centre PRIMARY KEY
      , nomCentre VARCHAR2(50)
      , adrea VARCHAR2(50) 
      , idpoblacio INTEGER 
      , codipostal CHAR(5) 
      , telefon VARCHAR2(15) 
      , mail VARCHAR2(50)
      , dataAlta DATE 
      , dataBaixa DATE       
)
TABLESPACE TS_ODS;
COMMIT;

---------------------------------------------------
-----------------  EMPRESA  -----------------------
---------------------------------------------------
--DROP TABLE op_empresa CASCADE CONSTRAINTS PURGE;
CREATE TABLE op_empresa(
      idempresa INTEGER CONSTRAINT PK_op_empresa PRIMARY KEY
      , nomEmpresa VARCHAR2(50) 
      , nif VARCHAR2(50)       
      , adrea VARCHAR2(50) 
      , idpoblacio INTEGER 
      , codipostal CHAR(5) 
      , telefon1 VARCHAR2(15) 
      , telefon2 VARCHAR2(15) 
      , fax VARCHAR2(15) 
      , mail VARCHAR2(50)
      , personaContacte VARCHAR2(50)
      , telefonContacte VARCHAR2(50) 
      , mailContacte VARCHAR2(50)
      , telefon24hores VARCHAR2(50)
      , dataAlta DATE 
      , dataBaixa DATE      
)
TABLESPACE TS_ODS;
COMMIT;

---------------------------------------------------
-----------------  OPERARI  -----------------------
---------------------------------------------------
--DROP TABLE op_operari CASCADE CONSTRAINTS PURGE;
CREATE TABLE op_operari(
      idoperari INTEGER CONSTRAINT PK_op_operari PRIMARY KEY
      , idempresa INTEGER 
      , codiOperari VARCHAR2(50) 
      , dataAlta DATE 
      , dataBaixa DATE       
)
TABLESPACE TS_ODS;
COMMIT;

---------------------------------------------------
-------------------  MARCA  -----------------------
---------------------------------------------------
--DROP TABLE op_marca CASCADE CONSTRAINTS PURGE;
CREATE TABLE op_marca(
      idmarca INTEGER CONSTRAINT PK_op_marca PRIMARY KEY
      , nomMarca VARCHAR2(50) 
      , dataAlta DATE 
      , dataBaixa DATE  
)
TABLESPACE TS_ODS;
COMMIT;

---------------------------------------------------
---------------  MODEL  ---------------------------
---------------------------------------------------
--DROP TABLE op_model CASCADE CONSTRAINTS PURGE;
CREATE TABLE op_model(
      idmodel INTEGER CONSTRAINT PK_op_model PRIMARY KEY
      , idmarca INTEGER 
      , nomModel VARCHAR(50) 
      , caracteristiques VARCHAR(100)  
      , dataAlta DATE 
      , dataBaixa DATE 
      , idcategoria INTEGER     
)
TABLESPACE TS_ODS;
COMMIT;

---------------------------------------------------
-------------------  EQUIP  -----------------------
---------------------------------------------------
--DROP TABLE op_equip CASCADE CONSTRAINTS PURGE;
CREATE TABLE op_equip(
      idequip INTEGER CONSTRAINT PK_op_equip PRIMARY KEY
      , numSerie VARCHAR2(50) 
      , idmodel INTEGER 
      , idcategoria INTEGER 
      , idcentre INTEGER 
      , descripcio VARCHAR2(50) 
      , dataCompra DATE 
      , dataFiGarantia DATE 
      , dataAlta DATE 
      , dataBaixa DATE
)
TABLESPACE TS_ODS;
COMMIT;

---------------------------------------------------
-------------------  USUARI  --------------------
---------------------------------------------------
--DROP TABLE op_usuari CASCADE CONSTRAINTS PURGE;
CREATE TABLE op_usuari(
      idusuari INTEGER CONSTRAINT PK_op_usuari PRIMARY KEY
      , login VARCHAR2(50)  
      , pwd VARCHAR2(50) 
      , dni VARCHAR2(15) 
      , nom VARCHAR2(100) 
      , mail VARCHAR2(50) 
      , perfil VARCHAR2(50) 
      , dataAlta DATE 
      , dataBaixa DATE       
)
TABLESPACE TS_ODS;
COMMIT;

---------------------------------------------------
--------------  PRIORITAT  ------------------------
---------------------------------------------------
--DROP TABLE op_prioritat CASCADE CONSTRAINTS PURGE;
CREATE TABLE op_prioritat(
      idprioritat INTEGER CONSTRAINT PK_op_prioritat PRIMARY KEY
      , gravetat VARCHAR2(50) 
      , qDiesResolucio INTEGER 
      , dataAlta DATE 
      , dataBaixa DATE 
)
TABLESPACE TS_ODS;
COMMIT;

---------------------------------------------------
----------------  MANTENIMENT  --------------------
---------------------------------------------------
--DROP TABLE op_manteniment CASCADE CONSTRAINTS PURGE;
CREATE TABLE op_manteniment(
      idequip INTEGER 
      , idmanteniment INTEGER 
      , tipusMant CHAR(9) 
      , dataAlta DATE 
      , dataBaixa DATE 
      , CONSTRAINT PK_op_manteniment PRIMARY KEY (idequip, idmanteniment) 
)
TABLESPACE TS_ODS;
COMMIT;

---------------------------------------------------
-----------  MANTENIMENT  CORRECTIU  --------------
---------------------------------------------------
--DROP TABLE op_mantcorrectiu CASCADE CONSTRAINTS PURGE;
CREATE TABLE op_mantcorrectiu(
      idequip INTEGER 
      , idmanteniment INTEGER 
      , dataIncid DATE 
      , motiuIncid VARCHAR2(220) 
      , idusuari INTEGER 
      , idprioritat INTEGER 
      , CONSTRAINT PK_op_mantcorrectiu PRIMARY KEY (idequip, idmanteniment) 
)
TABLESPACE TS_ODS;
COMMIT;

---------------------------------------------------
------  RESOLUCIO MANTENIMENT CORRECTIU -----------
---------------------------------------------------
--DROP TABLE op_resoluciomant CASCADE CONSTRAINTS PURGE;
CREATE TABLE op_resoluciomant(
      idequip INTEGER 
      , idmanteniment INTEGER 
      , idempresa INTEGER
      , idoperari INTEGER 					
      , dataInici DATE 
      , dataFi DATE 
      , observacions VARCHAR2(100) 
      , dataAlta DATE 
      , dataBaixa DATE 
      , CONSTRAINT PK_op_resoluciomant PRIMARY KEY (idequip, idmanteniment) 
)
TABLESPACE TS_ODS;
COMMIT;

---------------------------------------------------
-----------  MANTENIMENT  PREVENTIU  --------------
---------------------------------------------------
--DROP TABLE op_mantpreventiu CASCADE CONSTRAINTS PURGE;
CREATE TABLE op_mantpreventiu(
      idequip INTEGER 
      , idmanteniment INTEGER
      , dataInici DATE 
      , dataFi DATE 
      , periodicitatMesos INTEGER 
      , CONSTRAINT PK_op_mantpreventiu PRIMARY KEY (idequip, idmanteniment) 
)
TABLESPACE TS_ODS;
COMMIT;

---------------------------------------------------
----------------  REVISIO  ------------------------
---------------------------------------------------
--DROP TABLE op_revisio CASCADE CONSTRAINTS PURGE;
CREATE TABLE op_revisio(
      idequip INTEGER 
      , idmanteniment INTEGER 
      , idrevisio INTEGER
      , dataPrevista DATE 
      , dataRealitzacio DATE 
      , idempresa INTEGER   	  
      , idoperari INTEGER 
      , observacions VARCHAR(100)
      , dataAlta DATE 
      , dataBaixa DATE 
      , CONSTRAINT PK_op_revisio PRIMARY KEY (idequip, idmanteniment, idrevisio) 
)
TABLESPACE TS_ODS;
COMMIT;

 
spool off
exit
 