-----------------------------------------
-----------------------------------------
spool C:\UOC\PFC\mbernard\logs\zc21-creacio_dimensions_ods.log
-----------------------------------------
-----------------------------------------

---------------------------------------------------
---------------------------------------------------
--connectat com a pfc_ODS
ALTER SESSION SET NLS_DATE_FORMAT = 'DD/MM/YYYY HH24:MI:SS';
ALTER SESSION SET NLS_TIMESTAMP_FORMAT = 'DD/MM/YYYY HH24:MI:SS';
ALTER SESSION SET NLS_TIME_FORMAT = 'HH24:MI:SS';
COMMIT;
---------------------------------------------------
---------------------------------------------------


---------------------------------------------------
--------------  CATEGORIES  -----------------------
---------------------------------------------------
--DROP TABLE D_CATEGORIES;
CREATE TABLE D_CATEGORIES(
      idcategoria INTEGER CONSTRAINT PK_d_categories PRIMARY KEY
      , nomCategoria VARCHAR2(50) 
)
TABLESPACE TS_ODS;
COMMIT;

---------------------------------------------------
-----------------  CENTRES  -----------------------
---------------------------------------------------
--DROP TABLE D_CENTRES;
CREATE TABLE D_CENTRES(
      idcentre INTEGER CONSTRAINT PK_d_centres PRIMARY KEY
      , nomCentre VARCHAR2(50)   
)
TABLESPACE TS_ODS;
COMMIT;

---------------------------------------------------
-----------------  EMPRESES  ----------------------
---------------------------------------------------
--DROP TABLE D_EMPRESES;
CREATE TABLE D_EMPRESES(
      idempresa INTEGER CONSTRAINT PK_d_empreses PRIMARY KEY
      , nomEmpresa VARCHAR2(50) 
      , nif VARCHAR2(50)       
)
TABLESPACE TS_ODS;
COMMIT;

---------------------------------------------------
-----------------  MARQUES  -----------------------
---------------------------------------------------
--DROP TABLE D_MARQUES;
CREATE TABLE D_MARQUES(
      idmarca INTEGER CONSTRAINT PK_d_marques PRIMARY KEY
      , nomMarca VARCHAR2(50) 
)
TABLESPACE TS_ODS;
COMMIT;

---------------------------------------------------
---------------  MODELS  --------------------------
---------------------------------------------------
--DROP TABLE D_MODELS;
CREATE TABLE D_MODELS(
      idmodel INTEGER CONSTRAINT PK_d_models PRIMARY KEY
      , idmarca INTEGER 
      , nomModel VARCHAR(50)  
      , idcategoria INTEGER     
)
TABLESPACE TS_ODS;
COMMIT;

---------------------------------------------------
-------------------  EQUIPS  ----------------------
---------------------------------------------------
--DROP TABLE D_EQUIPS;
CREATE TABLE D_EQUIPS(
      idequip INTEGER CONSTRAINT PK_d_equips PRIMARY KEY
      , numSerie VARCHAR2(50) 
      , idmodel INTEGER 
      , idcategoria INTEGER 
      , idcentre INTEGER 
      , descripcio VARCHAR2(50) 
      , dataCompra DATE 
      , dataFiGarantia DATE 
      , dataBaixa DATE	  
)
TABLESPACE TS_ODS;
COMMIT;

---------------------------------------------------
---------------  TIPUS PRIORITAT  -----------------
---------------------------------------------------
--DROP TABLE D_TIPUS_PRIORITAT;
CREATE TABLE D_TIPUS_PRIORITAT(
      idtipusPrioritat INTEGER CONSTRAINT PK_d_tipus_prioritat PRIMARY KEY
      , gravetat VARCHAR2(50) 
      , qDiesResolucio INTEGER  
)
TABLESPACE TS_ODS;
COMMIT;

---------------------------------------------------
-------------  TIPUS MANTENIMENT  -----------------
---------------------------------------------------
--DROP TABLE D_TIPUS_MANTENIMENT;
CREATE TABLE D_TIPUS_MANTENIMENT(
      idtipusManteniment INTEGER CONSTRAINT PK_d_tipus_manteniment PRIMARY KEY
      , descTipusManteniment VARCHAR2(50)  
)
TABLESPACE TS_ODS;
COMMIT;

---------------------------------------------------
-------------  TIPUS REPARACIO  -------------------
---------------------------------------------------
--DROP TABLE D_TIPUS_REPARACIO;
CREATE TABLE D_TIPUS_REPARACIO(
      idtipusReparacio INTEGER CONSTRAINT PK_d_tipus_reparacio PRIMARY KEY
      , descTipusReparacio VARCHAR2(50)  
)
TABLESPACE TS_ODS;
COMMIT;

---------------------------------------------------
-------------  TIPUS REVISIO  ---------------------
---------------------------------------------------
--DROP TABLE D_TIPUS_REVISIO;
CREATE TABLE D_TIPUS_REVISIO(
      idtipusRevisio INTEGER CONSTRAINT PK_d_tipus_revisio PRIMARY KEY
      , descTipusRevisio VARCHAR2(50)  
)
TABLESPACE TS_ODS;
COMMIT;

---------------------------------------------------
-------------  TRAMS ANTIGUITAT  ------------------
---------------------------------------------------
--DROP TABLE D_TRAMS_ANTIGUITAT;
CREATE TABLE D_TRAMS_ANTIGUITAT(
      idtramAntiguitat INTEGER CONSTRAINT PK_d_trams_antiguitat PRIMARY KEY
      , descTramAntiguitat VARCHAR2(50)  
	  , iniciAny INTEGER
	  , fiAny INTEGER
	  , periode VARCHAR2(50)
)
TABLESPACE TS_ODS;
COMMIT;

---------------------------------------------------
---------------------  ANYS  ----------------------
---------------------------------------------------
--DROP TABLE D_ANYS;
CREATE TABLE D_ANYS(
      idany INTEGER CONSTRAINT PK_d_anys PRIMARY KEY
      , descAny CHAR(4)  
)
TABLESPACE TS_ODS;
COMMIT;

---------------------------------------------------
---------------------  MESOS  ---------------------
---------------------------------------------------
--DROP TABLE D_MESOS;
CREATE TABLE D_MESOS(
      idmes INTEGER CONSTRAINT PK_d_mesos PRIMARY KEY
      , descMes CHAR(6)  
	  , idany INTEGER CONSTRAINT fk1_d_mesos REFERENCES d_anys(idany)
)
TABLESPACE TS_ODS;
COMMIT;


---------------------------------------------------
------------------  PERMISOS  ---------------------
---------------------------------------------------
-- donem permisos per pfc_DWH
GRANT SELECT ON D_CATEGORIES TO pfc_DWH WITH GRANT OPTION;
GRANT SELECT ON D_CENTRES TO pfc_DWH WITH GRANT OPTION;
GRANT SELECT ON D_EMPRESES TO pfc_DWH WITH GRANT OPTION;
GRANT SELECT ON D_MODELS TO pfc_DWH WITH GRANT OPTION;
GRANT SELECT ON D_MARQUES TO pfc_DWH WITH GRANT OPTION;
GRANT SELECT ON D_EQUIPS TO pfc_DWH WITH GRANT OPTION;

GRANT SELECT ON D_TIPUS_PRIORITAT TO pfc_DWH WITH GRANT OPTION;
GRANT SELECT ON D_TIPUS_MANTENIMENT TO pfc_DWH WITH GRANT OPTION;
GRANT SELECT ON D_TIPUS_REPARACIO TO pfc_DWH WITH GRANT OPTION;
GRANT SELECT ON D_TIPUS_REVISIO TO pfc_DWH WITH GRANT OPTION;
GRANT SELECT ON D_TRAMS_ANTIGUITAT TO pfc_DWH WITH GRANT OPTION;
GRANT SELECT ON D_ANYS TO pfc_DWH WITH GRANT OPTION;
GRANT SELECT ON D_MESOS TO pfc_DWH WITH GRANT OPTION;

COMMIT;
---------------------------------------------------
---------------------------------------------------
 
spool off
exit
 