-----------------------------------------
-----------------------------------------
spool C:\UOC\PFC\mbernard\logs\zc32-creacio_fets_dwh.log
-----------------------------------------
-----------------------------------------

---------------------------------------------------
---------------------------------------------------
--connectat com a pfc_DWH
ALTER SESSION SET NLS_DATE_FORMAT = 'DD/MM/YYYY HH24:MI:SS';
ALTER SESSION SET NLS_TIMESTAMP_FORMAT = 'DD/MM/YYYY HH24:MI:SS';
ALTER SESSION SET NLS_TIME_FORMAT = 'HH24:MI:SS';
COMMIT;
---------------------------------------------------
---------------------------------------------------


---------------------------------------------------
--------------  EQUIPS INSTALLATS  ----------------
---------------------------------------------------
--DROP TABLE F_EQUIPS_INSTALLATS;
CREATE TABLE F_EQUIPS_INSTALLATS(
      idmes CONSTRAINT fk1_f_equips_installats REFERENCES d_mesos(idmes)
	  , idcentre CONSTRAINT fk2_f_equips_installats REFERENCES d_centres(idcentre)
      , idcategoria CONSTRAINT fk3_f_equips_installats REFERENCES d_categories(idcategoria)
	  , idmarca CONSTRAINT fk4_f_equips_installats REFERENCES d_marques(idmarca)
	  , idmodel CONSTRAINT fk5_f_equips_installats REFERENCES d_models(idmodel)
	  , qEquips INTEGER
	  , CONSTRAINT pk_f_equips_installats PRIMARY KEY (idmes,idcentre,idcategoria,idmarca,idmodel)
)
TABLESPACE TS_DWH;
COMMIT;

---------------------------------------------------
--------------  MANTENIMENTS  ---------------------
---------------------------------------------------
--DROP TABLE F_MANTENIMENTS;
CREATE TABLE F_MANTENIMENTS(
      idmes CONSTRAINT fk1_f_manteniments REFERENCES d_mesos(idmes)
	  , idcentre CONSTRAINT fk2_f_manteniments REFERENCES d_centres(idcentre)
      , idcategoria CONSTRAINT fk3_f_manteniments REFERENCES d_categories(idcategoria)
	  , idmarca CONSTRAINT fk4_f_manteniments REFERENCES d_marques(idmarca)
	  , idmodel CONSTRAINT fk5_f_manteniments REFERENCES d_models(idmodel)
	  , idequip CONSTRAINT fk6_f_manteniments REFERENCES d_equips(idequip)	  
	  , idtramAntiguitat CONSTRAINT fk7_f_manteniments REFERENCES d_trams_antiguitat(idtramAntiguitat)	
	  , idtipusManteniment CONSTRAINT fk8_f_manteniments REFERENCES d_tipus_manteniment(idtipusManteniment)	  	  
	  , qManteniments INTEGER
	  , CONSTRAINT pk_f_manteniments PRIMARY KEY (idmes,idcentre,idcategoria,idmarca,idmodel,idequip,idtramAntiguitat,idtipusManteniment)
)
TABLESPACE TS_DWH;
COMMIT;

---------------------------------------------------
--------------  REVISIONS  ------------------------
---------------------------------------------------
--DROP TABLE F_REVISIONS;
CREATE TABLE F_REVISIONS(
      idmes CONSTRAINT fk1_f_revisions REFERENCES d_mesos(idmes)
	  , idcentre CONSTRAINT fk2_f_revisions REFERENCES d_centres(idcentre)
      , idcategoria CONSTRAINT fk3_f_revisions REFERENCES d_categories(idcategoria)
	  , idempresa CONSTRAINT fk4_f_revisions REFERENCES d_empreses(idempresa)	  
	  , idtipusRevisio CONSTRAINT fk5_f_revisions REFERENCES d_tipus_revisio(idtipusRevisio)	  	  
	  , qRevisions INTEGER
	  , CONSTRAINT pk_f_revisions PRIMARY KEY (idmes,idcentre,idcategoria,idempresa,idtipusRevisio)
)
TABLESPACE TS_DWH;
COMMIT;

---------------------------------------------------
--------------  TEMPS RESOLUCIO  ------------------
---------------------------------------------------
--DROP TABLE F_TEMPS_RESOLUCIO;
CREATE TABLE F_TEMPS_RESOLUCIO(
      idmes CONSTRAINT fk1_f_temps_resolucio REFERENCES d_mesos(idmes)
	  , idempresa CONSTRAINT fk2_f_temps_resolucio REFERENCES d_empreses(idempresa)	  
	  , idtipusPrioritat CONSTRAINT fk3_f_temps_resolucio REFERENCES d_tipus_prioritat(idtipusPrioritat)	  	  
	  , promigDies NUMBER(9,1)
	  , CONSTRAINT pk_f_temps_resolucio PRIMARY KEY (idmes,idempresa,idtipusPrioritat)
)
TABLESPACE TS_DWH;
COMMIT;

---------------------------------------------------
--------------  REPARACIONS  ----------------------
---------------------------------------------------
--DROP TABLE F_REPARACIONS;
CREATE TABLE F_REPARACIONS(
      idmes CONSTRAINT fk1_f_reparacions REFERENCES d_mesos(idmes)
	  , idcentre CONSTRAINT fk2_f_reparacions REFERENCES d_centres(idcentre)
	  , idempresa CONSTRAINT fk3_f_reparacions REFERENCES d_empreses(idempresa)	  
	  , idtipusPrioritat CONSTRAINT fk4_f_reparacions REFERENCES d_tipus_prioritat(idtipusPrioritat)	
	  , idtipusReparacio CONSTRAINT fk5_f_reparacions REFERENCES d_tipus_reparacio(idtipusReparacio)	  	  
	  , qReparacions INTEGER
	  , CONSTRAINT pk_f_reparacions PRIMARY KEY (idmes,idcentre,idempresa,idtipusPrioritat,idtipusReparacio)
)
TABLESPACE TS_DWH;
COMMIT;

---------------------------------------------------
---------------------------------------------------

spool off
exit