-----------------------------------------
-----------------------------------------
spool C:\UOC\PFC\mbernard\logs\zp01-package_carregar_imatgeBDop_ods.log
-----------------------------------------
-----------------------------------------

CREATE OR REPLACE PACKAGE pfc_ODS.CARREGA_IMATGEBDOP AS
    PROCEDURE PR_CARREGA_OP_CATEGORIA;
    --PROCEDURE PR_CARREGA_OP_POBLACIO;
    PROCEDURE PR_CARREGA_OP_CENTRE;
    PROCEDURE PR_CARREGA_OP_EMPRESA;
    --PROCEDURE PR_CARREGA_OP_OPERARI;
	PROCEDURE PR_CARREGA_OP_MARCA;
	PROCEDURE PR_CARREGA_OP_MODEL;
    PROCEDURE PR_CARREGA_OP_EQUIP;
	--PROCEDURE PR_CARREGA_OP_USUARI;
	PROCEDURE PR_CARREGA_OP_PRIORITAT;	
    PROCEDURE PR_CARREGA_OP_MANTENIMENT;
	PROCEDURE PR_CARREGA_OP_MANTCORRECTIU;
	PROCEDURE PR_CARREGA_OP_RESOLUCIOMANT;	
    PROCEDURE PR_CARREGA_OP_MANTPREVENTIU;
	PROCEDURE PR_CARREGA_OP_REVISIO;	
	
END;
/


CREATE OR REPLACE PACKAGE BODY pfc_ODS.CARREGA_IMATGEBDOP AS

	PROCEDURE PR_CARREGA_OP_CATEGORIA AS
	BEGIN
	  DELETE FROM OP_CATEGORIA;
	  COMMIT;
	  
	  INSERT INTO OP_CATEGORIA(idcategoria,nomCategoria,dataAlta,dataBaixa) 
		SELECT * 
		FROM pfc_BDR.CATEGORIA; 
	  COMMIT; 
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;
	
	PROCEDURE PR_CARREGA_OP_CENTRE AS
	BEGIN
	  DELETE FROM OP_CENTRE;
	  COMMIT;
	  
	  INSERT INTO OP_CENTRE(idcentre,nomCentre,adrea,idpoblacio,codipostal,telefon,mail,dataAlta,dataBaixa) 
		SELECT * 
		FROM pfc_BDR.CENTRE; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;
	
	PROCEDURE PR_CARREGA_OP_EMPRESA AS
	BEGIN
	  DELETE FROM OP_EMPRESA;
	  COMMIT;
	  
	  INSERT INTO OP_EMPRESA(idempresa,nomEmpresa,nif,adrea,idpoblacio,codipostal,telefon1,telefon2,fax,mail,personaContacte,telefonContacte,mailContacte,telefon24hores,dataAlta,dataBaixa) 
		SELECT * 
		FROM pfc_BDR.EMPRESA; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;
	
	PROCEDURE PR_CARREGA_OP_MARCA AS
	BEGIN
	  DELETE FROM OP_MARCA;
	  COMMIT;
	  
	  INSERT INTO OP_MARCA(idmarca,nomMarca,dataAlta,dataBaixa) 
		SELECT * 
		FROM pfc_BDR.MARCA; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;

	PROCEDURE PR_CARREGA_OP_MODEL AS
	BEGIN
	  DELETE FROM OP_MODEL;
	  COMMIT;
	  
	  INSERT INTO OP_MODEL(idmodel,idmarca,nomModel,caracteristiques,dataAlta,dataBaixa,idcategoria) 
		SELECT * 
		FROM pfc_BDR.MODEL; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;

	PROCEDURE PR_CARREGA_OP_EQUIP AS
	BEGIN
	  DELETE FROM OP_EQUIP;
	  COMMIT;
	  
	  INSERT INTO OP_EQUIP(idequip,numSerie,idmodel,idcategoria,idcentre,descripcio,dataCompra,dataFiGarantia,dataAlta,dataBaixa) 
		SELECT * 
		FROM pfc_BDR.EQUIP; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;	
	
	PROCEDURE PR_CARREGA_OP_PRIORITAT AS
	BEGIN
	  DELETE FROM OP_PRIORITAT;
	  COMMIT;
	  
	  INSERT INTO OP_PRIORITAT(idprioritat,gravetat,qDiesResolucio,dataAlta,dataBaixa) 
		SELECT * 
		FROM pfc_BDR.PRIORITAT; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;
	
	PROCEDURE PR_CARREGA_OP_MANTENIMENT AS
	BEGIN
	  DELETE FROM OP_MANTENIMENT;
	  COMMIT;
	  
	  INSERT INTO OP_MANTENIMENT(idequip,idmanteniment,tipusMant,dataAlta,dataBaixa) 
		SELECT * 
		FROM pfc_BDR.MANTENIMENT; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;
	
	PROCEDURE PR_CARREGA_OP_MANTCORRECTIU AS
	BEGIN
	  DELETE FROM OP_MANTCORRECTIU;
	  COMMIT;
	  
	  INSERT INTO OP_MANTCORRECTIU(idequip,idmanteniment,dataIncid,motiuIncid,idusuari,idprioritat) 
		SELECT * 
		FROM pfc_BDR.MANTCORRECTIU; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;	
	
	PROCEDURE PR_CARREGA_OP_RESOLUCIOMANT AS
	BEGIN
	  DELETE FROM OP_RESOLUCIOMANT;
	  COMMIT;
	  
	  INSERT INTO OP_RESOLUCIOMANT(idequip,idmanteniment,idempresa,idoperari,dataInici,dataFi,observacions,dataAlta,dataBaixa) 
		SELECT * 
		FROM pfc_BDR.RESOLUCIOMANT; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;		
	
	PROCEDURE PR_CARREGA_OP_MANTPREVENTIU AS
	BEGIN
	  DELETE FROM OP_MANTPREVENTIU;
	  COMMIT;
	  
	  INSERT INTO OP_MANTPREVENTIU(idequip,idmanteniment,dataInici,dataFi,periodicitatMesos) 
		SELECT * 
		FROM pfc_BDR.MANTPREVENTIU; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;
	
	PROCEDURE PR_CARREGA_OP_REVISIO AS
	BEGIN
	  DELETE FROM OP_REVISIO;
	  COMMIT;
	  
	  INSERT INTO OP_REVISIO(idequip,idmanteniment,idrevisio,dataPrevista,dataRealitzacio,idempresa,idoperari,observacions,dataAlta,dataBaixa) 
		SELECT * 
		FROM pfc_BDR.REVISIO; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;	

END;
/

COMMIT;

spool off
exit