-----------------------------------------
-----------------------------------------
spool C:\UOC\PFC\mbernard\logs\zp11-package_carregar_dimensions_ods.log
-----------------------------------------
-----------------------------------------

CREATE OR REPLACE PACKAGE pfc_ODS.CARREGA_DIMENSIONS AS
    PROCEDURE PR_CARREGA_D_CATEGORIES;
    PROCEDURE PR_CARREGA_D_CENTRES;
    PROCEDURE PR_CARREGA_D_EMPRESES;
    PROCEDURE PR_CARREGA_D_MARQUES;
    PROCEDURE PR_CARREGA_D_MODELS;
	PROCEDURE PR_CARREGA_D_EQUIPS;
	PROCEDURE PR_CARREGA_D_TIPUS_PRIORITAT;
    PROCEDURE PR_CARREGA_D_TIPUS_MANTENIMENT;
	PROCEDURE PR_CARREGA_D_TIPUS_REPARACIO;
	PROCEDURE PR_CARREGA_D_TIPUS_REVISIO;	
    PROCEDURE PR_CARREGA_D_TRAMS_ANTIGUITAT;
	PROCEDURE PR_CARREGA_D_ANYS(p_anyInici IN INTEGER, p_anyFi IN INTEGER);
	PROCEDURE PR_CARREGA_D_MESOS;		
END;
/

CREATE OR REPLACE PACKAGE BODY pfc_ODS.CARREGA_DIMENSIONS AS
	
    PROCEDURE PR_CARREGA_D_CATEGORIES AS
    BEGIN
	  --esborrem i tornem a carregar
      DELETE FROM D_CATEGORIES;
	  COMMIT;
      INSERT INTO D_CATEGORIES(idcategoria,nomCategoria) 
		SELECT idcategoria,nomCategoria
		FROM pfc_ODS.OP_CATEGORIA; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 
    END;
	
	
    PROCEDURE PR_CARREGA_D_CENTRES AS
    BEGIN
	  --esborrem i tornem a carregar
      DELETE FROM D_CENTRES;
	  COMMIT;
      INSERT INTO D_CENTRES(idcentre,nomCentre) 
		SELECT idcentre,nomCentre
		FROM pfc_ODS.OP_CENTRE; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;
	
	
    PROCEDURE PR_CARREGA_D_EMPRESES AS
    BEGIN
	  --esborrem i tornem a carregar
      DELETE FROM D_EMPRESES;
	  COMMIT;
      INSERT INTO D_EMPRESES(idempresa,nomEmpresa,nif) 
		SELECT idempresa,nomEmpresa,nif
		FROM pfc_ODS.OP_EMPRESA; 
	  COMMIT;
	  --inserim valor per quan no existeixi l empresa
	  INSERT INTO D_EMPRESES(idempresa,nomEmpresa,nif) 
		VALUES (9999,'Desconegut o valor buit','ZZZZZZZZZZZZZZZZ'); 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;
	
	
    PROCEDURE PR_CARREGA_D_MARQUES AS
    BEGIN
	  --esborrem i tornem a carregar
      DELETE FROM D_MARQUES;
	  COMMIT;
      INSERT INTO D_MARQUES(idmarca,nomMarca) 
		SELECT idmarca,nomMarca
		FROM pfc_ODS.OP_MARCA; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;
	
	
    PROCEDURE PR_CARREGA_D_MODELS AS
    BEGIN
	  --esborrem i tornem a carregar
      DELETE FROM D_MODELS;
	  COMMIT;
      INSERT INTO D_MODELS(idmodel,idmarca,nomModel,idcategoria) 
		SELECT idmodel,idmarca,nomModel,idcategoria
		FROM pfc_ODS.OP_MODEL; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;
	
	
	PROCEDURE PR_CARREGA_D_EQUIPS AS
    BEGIN
	  --esborrem i tornem a carregar
      DELETE FROM D_EQUIPS;
	  COMMIT;
      INSERT INTO D_EQUIPS(idequip,numSerie,idmodel,idcategoria,idcentre,descripcio,dataCompra,dataFiGarantia,dataBaixa) 
		SELECT idequip,numSerie,idmodel,idcategoria,idcentre,descripcio,dataCompra,dataFiGarantia,dataBaixa
		FROM pfc_ODS.OP_EQUIP; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;	
	
	
	PROCEDURE PR_CARREGA_D_TIPUS_PRIORITAT  AS
    BEGIN
	  --esborrem i tornem a carregar
      DELETE FROM D_TIPUS_PRIORITAT;
	  COMMIT;
      INSERT INTO D_TIPUS_PRIORITAT(idtipusPrioritat,gravetat,qDiesResolucio) 
		SELECT idprioritat,gravetat,qDiesResolucio
		FROM pfc_ODS.OP_PRIORITAT; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;	

	
    PROCEDURE PR_CARREGA_D_TIPUS_MANTENIMENT AS
    BEGIN
      DELETE FROM D_TIPUS_MANTENIMENT;
	  COMMIT;
      INSERT INTO D_TIPUS_MANTENIMENT VALUES(1,'Correctiu');
      INSERT INTO D_TIPUS_MANTENIMENT VALUES(2,'Preventiu');
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;	
	
	
    PROCEDURE PR_CARREGA_D_TIPUS_REPARACIO AS
    BEGIN
      DELETE FROM D_TIPUS_REPARACIO;
	  COMMIT;
      INSERT INTO D_TIPUS_REPARACIO VALUES(1,'Fora termini');
      INSERT INTO D_TIPUS_REPARACIO VALUES(2,'Dins termini');
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;	
	
	
    PROCEDURE PR_CARREGA_D_TIPUS_REVISIO AS
    BEGIN
      DELETE FROM D_TIPUS_REVISIO;
	  COMMIT;
      INSERT INTO D_TIPUS_REVISIO VALUES(1,'Pendent');
      INSERT INTO D_TIPUS_REVISIO VALUES(2,'Amb demora');
	  INSERT INTO D_TIPUS_REVISIO VALUES(3,'Sense demora');
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;

	
    PROCEDURE PR_CARREGA_D_TRAMS_ANTIGUITAT AS
    BEGIN
      DELETE FROM D_TRAMS_ANTIGUITAT;
	  COMMIT;
      INSERT INTO D_TRAMS_ANTIGUITAT VALUES(1,'Nou',0,2,'0 a 2 anys');
      INSERT INTO D_TRAMS_ANTIGUITAT VALUES(2,'Semi-nou',3,5,'3 a 5 anys');
	  INSERT INTO D_TRAMS_ANTIGUITAT VALUES(3,'Semi-vell',6,8,'6 a 8 anys');
	  INSERT INTO D_TRAMS_ANTIGUITAT VALUES(4,'Vell',9,99,'ms de 8 anys');
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;
	
	
	PROCEDURE PR_CARREGA_D_ANYS(p_anyInici IN INTEGER,
								p_anyFi IN INTEGER)
	AS
	  i INTEGER;
	  vany INTEGER;
	BEGIN
	  DELETE FROM D_ANYS;
	  COMMIT;  
	  i:= 1;
	  vany:= p_anyInici;
	  WHILE (vany <= p_anyFi) LOOP
		INSERT INTO D_ANYS VALUES(i,TO_CHAR(vany));
		i:=i+1;
		vany:=vany+1;
	  END LOOP;
	  COMMIT; 
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
	END;
	
	
	PROCEDURE  PR_CARREGA_D_MESOS AS
	  vidany integer;
	  minAny integer;
	  maxAny integer;
	  i INTEGER;
	  vmes INTEGER;
	  vany INTEGER;
	BEGIN
	  DELETE FROM D_MESOS;
	  COMMIT;
	  
	  SELECT min(descAny), max(descAny) 
	  INTO minAny, maxAny 		
	  FROM D_ANYS 
	  ;
	  
	  i:= 1;
	  vany:= minAny;
	  WHILE (vany <= maxAny) LOOP
	  
		  SELECT idany
		  INTO vidany
		  FROM D_ANYS
		  WHERE descAny = to_char(vany)
		  ;
		  
		  FOR m IN 1..12 LOOP
			vmes:= (vany * 100) + m;
			INSERT INTO D_MESOS VALUES(i,TO_CHAR(vmes),vidany);	  
			i:=i+1;
		  END LOOP;
		  
		  vany:=vany+1;
	  
	  END LOOP;
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
	END;
		
END;
/

COMMIT;


spool off
exit

