-----------------------------------------
-----------------------------------------
spool C:\UOC\PFC\mbernard\logs\zp13-package_carregar_auxiliars_ods.log
-----------------------------------------
-----------------------------------------

CREATE OR REPLACE PACKAGE pfc_ODS.CARREGA_AUXILIARS AS
    PROCEDURE PR_CARREGA_AUX_UBICACIONS;
	PROCEDURE PR_CARREGA_AUX_MANTS_EQUIP;
END;
/

CREATE OR REPLACE PACKAGE BODY pfc_ODS.CARREGA_AUXILIARS AS

  PROCEDURE PR_CARREGA_AUX_UBICACIONS AS
  BEGIN
	--guardem histric mensual de les diferents ubicacions d'un equip al llarg de la seva vida til
	--s'executa abans de final de cada mes, o com a molt tard el segon dia del mes actual
	INSERT INTO AUX_UBICACIONS(aaaamm,idequip,idcentre)
		SELECT TO_CHAR(SYSDATE-3,'YYYYMM'), idequip, idcentre
		FROM pfc_ODS.OP_EQUIP
		WHERE dataBaixa IS NULL;
	COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	
  END;
  
  
  PROCEDURE PR_CARREGA_AUX_MANTS_EQUIP AS
  BEGIN
	--guardem recompte mensual de manteniments per equip (preventius i correctius)
	INSERT INTO AUX_MANTS_EQUIP(aaaamm,idequip,tipusmant,qmants)
		SELECT TO_CHAR(c.dataIncid,'YYYYMM'), m.idequip, 'CORRECTIU', count(*) q
		FROM op_manteniment m
				 , op_mantcorrectiu c
		WHERE m.tipusmant = 'CORRECTIU'
				  AND m.dataBaixa is null
				  AND c.idequip = m.idequip
				  AND c.idmanteniment = m.idmanteniment
		GROUP BY TO_CHAR(c.dataIncid,'YYYYMM'), m.idequip  
		UNION ALL
		SELECT TO_CHAR(r.dataRealitzacio,'YYYYMM'), r.idequip, 'PREVENTIU', count(*) q
		FROM op_revisio r
		WHERE r.dataBaixa IS NULL
				  AND r.dataRealitzacio IS NOT NULL
		GROUP BY TO_CHAR(r.dataRealitzacio,'YYYYMM'), r.idequip  
		;
	COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	
  END;
  

END;
/

COMMIT;



spool off
exit
