-----------------------------------------
-----------------------------------------
spool C:\UOC\PFC\mbernard\logs\zp15-package_carregar_fets_ods.log
-----------------------------------------
-----------------------------------------

CREATE OR REPLACE PACKAGE pfc_ODS.CARREGA_FETS AS
    PROCEDURE PR_CARRINI_F_EQUIPS_INSTALLATS;
    PROCEDURE PR_CARRINI_F_MANTENIMENTS;
    PROCEDURE PR_CARRINI_F_REVISIONS;
    PROCEDURE PR_CARRINI_F_TEMPS_RESOLUCIO;
    PROCEDURE PR_CARRINI_F_REPARACIONS;
	
	PROCEDURE PR_CARRMEN_F_EQUIPS_INSTALLATS;
    PROCEDURE PR_CARRMEN_F_MANTENIMENTS;
    PROCEDURE PR_CARRMEN_F_REVISIONS;
    PROCEDURE PR_CARRMEN_F_TEMPS_RESOLUCIO;
    PROCEDURE PR_CARRMEN_F_REPARACIONS;
END;
/

CREATE OR REPLACE PACKAGE BODY pfc_ODS.CARREGA_FETS AS

  PROCEDURE PR_CARRINI_F_EQUIPS_INSTALLATS AS	
	--creem cursor per guardar els mesos
	CURSOR cMesos IS
		SELECT idmes, descMes
		FROM D_MESOS
		WHERE descMes < TO_CHAR(SYSDATE,'YYYYMM');
		
  BEGIN
	--crrega inicial (noms el primer cop)
	--esborrem i carreguem per tal de carregar tamb les dades histriques
	DELETE FROM F_EQUIPS_INSTALLATS;
	COMMIT;
	
	--per cada mes, inserim les dades adients
	FOR regMesos IN cMesos LOOP	 
		INSERT INTO F_EQUIPS_INSTALLATS(idmes,idcentre,idcategoria,idmarca,idmodel,qEquips)
			SELECT regMesos.idmes
				   , e.idcentre, e.idcategoria, m.idmarca, e.idmodel
				   , count(*) as q
			FROM 	op_equip e
					, op_model m
			WHERE 	e.dataBaixa is null
					AND e.idmodel = m.idmodel
					AND TO_CHAR(e.dataCompra,'YYYYMM') <= regMesos.descMes
			GROUP BY e.idcentre, e.idcategoria, m.idmarca, e.idmodel
			;
	END LOOP;
	COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	
  END;
  
  
  PROCEDURE PR_CARRMEN_F_EQUIPS_INSTALLATS AS
    vmes INTEGER;		
  BEGIN
	--crrega del mes actual
	--no esborrem, noms carreguem
	SELECT idmes
	INTO vmes
	FROM d_mesos
	WHERE descMes = TO_CHAR(SYSDATE-3,'YYYYMM');
	
	INSERT INTO F_EQUIPS_INSTALLATS(idmes,idcentre,idcategoria,idmarca,idmodel,qEquips)
		SELECT vmes, e.idcentre, e.idcategoria, m.idmarca, e.idmodel, count(*) as q
		FROM 	op_equip e
				, op_model m
		WHERE 	e.dataBaixa is null
				AND e.idmodel = m.idmodel
		GROUP BY e.idcentre, e.idcategoria, m.idmarca, e.idmodel
		;
	COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	
  END;  
  
  
  PROCEDURE PR_CARRINI_F_MANTENIMENTS AS
  BEGIN
	--crrega inicial (noms el primer cop)
	--esborrem i carreguem per tal de carregar tamb les dades histriques
	DELETE FROM F_MANTENIMENTS;
	COMMIT;
	
	INSERT INTO F_MANTENIMENTS
	 (idmes, idcentre,idcategoria,idmarca,idmodel,idequip,idtramAntiguitat,idtipusManteniment,qManteniments)
		SELECT  d.idmes, e.idcentre, e.idcategoria, m.idmarca, e.idmodel
				, e.idequip, a.idtramAntiguitat 
				, t.idtipusmanteniment, p.qmants
		FROM    op_equip e
				, op_model m
				, aux_mants_equip p
				, D_TRAMS_ANTIGUITAT a
				, D_MESOS d
				, D_TIPUS_MANTENIMENT t
		WHERE   e.dataBaixa is null
				AND e.idmodel = m.idmodel
				AND e.idequip = p.idequip
				AND (trunc(months_between(last_day(to_date(d.descMes,'YYYYMM')), e.datacompra) / 12) 
								  between a.iniciany and a.fiany)
				AND p.aaaamm = d.descMes
				AND d.descMes < TO_CHAR(SYSDATE,'YYYYMM')
				AND UPPER(t.desctipusmanteniment) = p.tipusmant
		;
	COMMIT;		
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	
  END;
  
  
  PROCEDURE PR_CARRMEN_F_MANTENIMENTS AS
    vmes INTEGER;
  BEGIN
	----crrega mensual
	--no esborrem, noms carreguem 
	SELECT idmes
	INTO vmes
	FROM d_mesos
	WHERE descMes = TO_CHAR(SYSDATE-3,'YYYYMM'); 
	
	INSERT INTO F_MANTENIMENTS(idmes,idcentre,idcategoria,idmarca,idmodel,idequip,idtramAntiguitat,idtipusManteniment,qManteniments)
		SELECT  vmes
				, e.idcentre, e.idcategoria, m.idmarca, e.idmodel
				, e.idequip, a.idtramAntiguitat
				, p.tipusmant, p.qmants
		FROM 	op_equip e
				, op_model m
				, aux_mants_equip p
				, D_TRAMS_ANTIGUITAT a
		WHERE 	e.dataBaixa is null
				AND e.idmodel = m.idmodel
				AND e.idequip = p.idequip
				AND trunc(months_between(sysdate-3,e.datacompra)/12) 
						  between a.iniciany and a.fiany
				AND TO_CHAR(SYSDATE-3,'YYYYMM') = p.aaaamm
		--ORDER BY e.idcentre, e.idcategoria, m.idmarca, e.idmodel, e.idequip
		;
	COMMIT;	
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	
  END;


  PROCEDURE PR_CARRINI_F_REVISIONS AS
  BEGIN
	--crrega inicial (noms el primer cop)
	--esborrem i carreguem per tal de carregar tamb les dades histriques
	DELETE FROM F_REVISIONS;
	COMMIT;
	
	INSERT INTO F_REVISIONS (idmes,idcentre,idcategoria,idempresa,idtipusRevisio,qRevisions)
		SELECT  m.idmes, e.idcentre, e.idcategoria
				, decode(r.idempresa,null,9999,r.idempresa) emp
			    , decode(r.dataRealitzacio,NULL,1,decode(sign(r.dataRealitzacio - r.dataPrevista),1,2,3)) idtRev
			    , count(*) q
		FROM OP_REVISIO r
			 , OP_EQUIP e
			 , D_MESOS m
		WHERE 
			  e.idequip = r.idequip
			  and e.dataBaixa is null
			  and r.dataBaixa is null
			  and m.descmes = decode(r.dataRealitzacio,NULL,to_char(r.dataPrevista,'YYYYMM'),to_char(r.dataRealitzacio,'YYYYMM'))
			  AND m.descMes < TO_CHAR(SYSDATE,'YYYYMM')
		GROUP BY  m.idmes, e.idcentre, e.idcategoria
				  , decode(r.idempresa,null,9999,r.idempresa)
				  , decode(r.dataRealitzacio,NULL,1,decode(sign(r.dataRealitzacio - r.dataPrevista),1,2,3))         
		;
	COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	
  END;
  

  PROCEDURE PR_CARRMEN_F_REVISIONS AS
    vmes INTEGER;
  BEGIN
	----crrega del mes actual
	--no esborrem, noms carreguem 
	SELECT idmes
	INTO vmes
	FROM d_mesos
	WHERE descMes = TO_CHAR(SYSDATE-3,'YYYYMM'); 
	
	INSERT INTO F_REVISIONS (idmes,idcentre,idcategoria,idempresa,idtipusRevisio,qRevisions)
		SELECT  vmes, e.idcentre, e.idcategoria
				, decode(r.idempresa,null,9999,r.idempresa) emp
			    , decode(r.dataRealitzacio,NULL,1,decode(sign(r.dataRealitzacio - r.dataPrevista),1,2,3)) idtRev
			    , count(*) q
		FROM OP_REVISIO r
			 , OP_EQUIP e
		WHERE 
			  e.idequip = r.idequip
			  and e.dataBaixa is null
			  and r.dataBaixa is null
			  and TO_CHAR(SYSDATE-3,'YYYYMM') = decode(r.dataRealitzacio,NULL,to_char(r.dataPrevista,'YYYYMM'),to_char(r.dataRealitzacio,'YYYYMM'))
		GROUP BY  e.idcentre, e.idcategoria
				  , decode(r.idempresa,null,9999,r.idempresa)
				  , decode(r.dataRealitzacio,NULL,1,decode(sign(r.dataRealitzacio - r.dataPrevista),1,2,3))         
		;
	COMMIT;	
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	
  END;

  
  PROCEDURE PR_CARRINI_F_TEMPS_RESOLUCIO AS
  BEGIN
	--crrega inicial (noms el primer cop)
	--esborrem i carreguem per tal de carregar tamb les dades histriques
	DELETE FROM F_TEMPS_RESOLUCIO;
	COMMIT;
	
	INSERT INTO F_TEMPS_RESOLUCIO (idmes,idempresa,idtipusPrioritat,promigDies)
		SELECT 
				d.idmes
				, a.idemp
				, a.idpr
				, AVG(qDies) promigDies
		FROM         
				(SELECT 
					   TO_CHAR(r.datainici,'YYYYMM') aaaamm
					   , r.idempresa idemp
					   , idprioritat idpr
					   , trunc(((r.dataFi - r.dataInici) + 1 )) qDies
				FROM OP_RESOLUCIOMANT r
					 , OP_MANTCORRECTIU m
				WHERE 
					  r.idequip = m.idequip
					  AND r.idmanteniment = m.idmanteniment
				) A      
				, D_MESOS d
		WHERE d.descMes = a.aaaamm 
			  AND d.descMes < TO_CHAR(SYSDATE,'YYYYMM')
		GROUP BY 
				 d.idmes
				 , a.idemp
				 , a.idpr
		;
	COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	
  END;
  
  
  PROCEDURE PR_CARRMEN_F_TEMPS_RESOLUCIO AS
    vmes INTEGER;
  BEGIN
	----crrega del mes actual
	--no esborrem, noms carreguem 
	SELECT idmes
	INTO vmes
	FROM d_mesos
	WHERE descMes = TO_CHAR(SYSDATE-3,'YYYYMM'); 
 
	INSERT INTO F_TEMPS_RESOLUCIO (idmes,idempresa,idtipusPrioritat,promigDies)
		SELECT 
				vmes 
				, a.idemp
				, a.idpr
				, AVG(qDies) promigDies
		FROM         
				(SELECT 
					   TO_CHAR(r.datainici,'YYYYMM') aaaamm
					   , r.idempresa idemp
					   , idprioritat idpr
					   , trunc(((r.dataFi - r.dataInici) + 1 )) qDies
				FROM OP_RESOLUCIOMANT r
					 , OP_MANTCORRECTIU m
				WHERE 
					  r.idequip = m.idequip
					  AND r.idmanteniment = m.idmanteniment
				) A      
		WHERE TO_CHAR(SYSDATE-3,'YYYYMM') = a.aaaamm 
		GROUP BY 
				 a.idemp
				 , a.idpr
		;
	COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN  
       RAISE; 	
  END;
  
  
  PROCEDURE PR_CARRINI_F_REPARACIONS AS
  BEGIN
	--crrega inicial (noms el primer cop)
	--esborrem i carreguem per tal de carregar tamb les dades histriques
	DELETE FROM F_REPARACIONS;
	COMMIT;
	
	INSERT INTO F_REPARACIONS (idmes,idcentre,idempresa,idtipusPrioritat,idtipusReparacio,qReparacions)	
		SELECT 
			   d.idmes
			   , a.idcen
			   , a.idemp
			   , a.idpr
			   , a.idtrep
			   , count(*) qReps
		FROM        
			(SELECT 
					 TO_CHAR(r.datainici,'YYYYMM') aaaamm
					 , e.idcentre idcen
					 , r.idempresa idemp
					 , m.idprioritat idpr
					 , decode(sign(trunc(((r.dataFi - r.dataInici) + 1 )) - p.qdiesResolucio),1,1,2) idtrep
			  FROM OP_RESOLUCIOMANT r
				   , OP_EQUIP e
				   , OP_MANTCORRECTIU m
				   , D_TIPUS_PRIORITAT p
			  WHERE 
					r.idequip = m.idequip
					AND r.idequip = e.idequip
					AND r.idmanteniment = m.idmanteniment
					AND m.idprioritat = p.idtipusPrioritat
			  ) A
			  , D_MESOS d
		WHERE 
			  d.descmes = a.aaaamm
			  AND d.descMes < TO_CHAR(SYSDATE,'YYYYMM')
		GROUP BY 
				  d.idmes
				  , a.idcen
				  , a.idemp
				  , a.idpr
				  , a.idtrep
		;      
	COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	
  END;
	

  PROCEDURE PR_CARRMEN_F_REPARACIONS AS
  BEGIN
	--crrega mensual
	--no esborrem, noms carreguem  
	INSERT INTO F_REPARACIONS (idmes,idcentre,idempresa,idtipusPrioritat,idtipusReparacio,qReparacions)	
		SELECT 
			   d.idmes
			   , a.idcen
			   , a.idemp
			   , a.idpr
			   , a.idtrep
			   , count(*) qReps
		FROM        
			(SELECT 
					 TO_CHAR(r.datainici,'YYYYMM') aaaamm
					 , e.idcentre idcen
					 , r.idempresa idemp
					 , m.idprioritat idpr
					 , decode(sign(trunc(((r.dataFi - r.dataInici) + 1 )) - p.qdiesResolucio),1,1,2) idtrep
			  FROM OP_RESOLUCIOMANT r
				   , OP_EQUIP e
				   , OP_MANTCORRECTIU m
				   , D_TIPUS_PRIORITAT p
			  WHERE 
					r.idequip = m.idequip
					AND r.idequip = e.idequip
					AND r.idmanteniment = m.idmanteniment
					AND m.idprioritat = p.idtipusPrioritat
			  ) A
			  , D_MESOS d
		WHERE 
			  d.descmes = a.aaaamm
			  AND d.descMes = TO_CHAR(SYSDATE-3,'YYYYMM')
		GROUP BY 
				  d.idmes
				  , a.idcen
				  , a.idemp
				  , a.idpr
				  , a.idtrep
		;      
	COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	
  END;

END;
/

COMMIT;


spool off
exit
