// Copyright  2003 Cognos Incorporated. All Rights Reserved.
// Cognos and the Cognos logo are trademarks of Cognos Incorporated.

// htmlcontent.js

// Helper functions for getting the Content and the navigation buttons in 
// sync.

// var page; is defined by the HTML file that includes this script.
// holds the page identifier.

// Have we initialized ourselves.
var loaded = false;


function alert_obj(obj)
{
  var msg = typeof(obj) + "\n";
  msg = msg + obj + "\n";
  var name;
  for (name in obj) {
    msg = msg + name + ":" + obj[name] + "\n";
  }
  alert(msg);
}

/// Returns the Table of contents Window
function window_toc()
{
  if (parent) {
    if (parent.frames) {
      var toc = parent.frames["toc"];
      return toc;
    }
  }
  return null;
}
  



// Update the navigation frame to show what is being displayed
function update_navigation()
{
  var hash;
  var id_valid;


  win_toc = window_toc();
  if (win_toc) {
    if (win_toc.loaded) {
      hash = document.location.hash;
      if (hash == null || hash.length == 0) {
        hash = page;
      } else {
        hash = hash.substr(1); // Everything exccept the first letter
      }
      id_valid = win_toc.highlight(hash);
      if (! id_valid) {
        // Walk through the documents anchors until a valid id is found.
        var nbAnchors = document.anchors.length;
        var anchorIndex = 0;
        while (anchorIndex < nbAnchors) {
          hash = document.anchors[anchorIndex].name;
          id_valid = win_toc.highlight(hash);
          if (id_valid) {
            break;
          }
          anchorIndex++;
        }
      }	
    }
  }
}


function onLoad()
{
  loaded = true;
  update_navigation();
}



function content_output_iframe(fileStr,hash,width,height)
{
  var text = "<NOFRAMES>";
  text = text + "Frames must be enabled since the IFRAME tag is being used."; // TODO put this into a resource file
  text = text + fileStr + "#" + hash;
  text = text + "</NOFRAMES>";
  document.writeln(text);

  text = "<IFRAME ";
  text += "marginheight=\"0px\" marginwidth=\"0px\" ";
  text += "border=\"0px\" ";
  text += "width=\"";
  text += width;
  text += "\" height=\"";
  text += height;
  text += "\" src=\"";
  text += fileStr;
  if (hash && hash.length > 0) {
    text += "#" + hash;
  }
  text += "\" >";
  text += "</IFRAME>";
  document.writeln(text);
}


// Find the back link for the window.
function get_back_link(win)
{
  if (! win) {
    return "";
  }
  if (win.location && win.location.search) {
    var terms =  win.location.search.split("&");
    var l = terms.length;
    var i = 0;
    while (i < l) {
      var term = terms[i];
      if (term.indexOf("back=") == 0) {
	    //return "back="+escape(win.location);
        return term;
      }
      i++;
    }
    if (win == win.parent) {
      return "";
    } else {    
      return get_back_link(win.parent);
    }
  } else {
    return "";
  }
}


// Find the window that contains the back link.
function get_back_link_window(win)
{
  if (! win) {
    return null;
  }
  if (win.location && win.location.search) {
    var terms =  win.location.search.split("&");
    var l = terms.length;
    var i = 0;
    while (i < l) {
      var term = terms[i];
      if (term.indexOf("back=") == 0) {
        return win;
      }
      i++;
    }
    if (win == win.parent) {
      return null;
    } else {    
      return get_back_link_window(win.parent);
    }
  } else {
    return null;
  }
}

function has_caf_info(window)
{

  var back_window = window;
  back_window = get_back_link_window(window);
  if ( !back_window ) 
  {
    return false;
  }
  if (back_window.location && back_window.location.search) 
  {
    var terms =  back_window.location.search.split("=");
    var term = terms[0];
    if (term.indexOf("?AFDATA") == 0) 
    {
        return true;
    }
  } 
  return false;
}




// Find the frame that will be the target for the drill-through
function drill_frame(w) {
	if (w == null) { return w; }
	if (w.parent == w) { return w; } 
	if (w.parent == null) { return w; }
	return drill_frame(w.parent); 
}

function add_drill_backlink(url)
{
  var back = get_back_link(window);

    // Extract the search part and hash part of the string.
	var q_pos = url.indexOf("?");
	var h_pos = url.indexOf("#");
	var search = "?"; // Search term including "?"
	var hash = "";   // target including "#"
	var base = "";   // protocol, host and port, path
	if (q_pos < 0) {
	  // No search term
	  if (h_pos > 0) {
	    // No search term but have a hash
	    hash = url.slice(h_pos, url.length);
		base = url.slice(0, h_pos);
	  } else {
	    // No search term and no hash
	    base = url;
	  }
	} else {
	  // Search term
	  if (h_pos < 0) {
	    // Search term but no hash
	    search = url.slice(q_pos, url.length);
		base = url.slice(0, q_pos);
	  } else {	    
	    // Search term and hash
	    search = url.slice(q_pos, h_pos);
	    hash = url.slice(h_pos, url.length);
		base = url.slice(0, q_pos);
	  }
	}

  if (back != "") {
	if (search != "?") {
	  search +=  "&";
	}
	search += back;
  }
 
  var temp = "";
  var has_caf = has_caf_info(window);
  if (has_caf == true) {
    // Replace ? with "?AFDATA"
    temp = search.slice(1);
	search = "?AFDATA" + temp; 
  } 
  var newUrl = base + search + hash;    
  return newUrl; 
}

// Go to the drill through location
// url is a string.
function drill_thru(url)
{
  // Find the top most window.
  var win = window;
  while (win.parent && win.parent!=win) {
    win = win.parent;
  }

  var newUrl = add_drill_backlink(url);    
  win.location = newUrl; 
}

// Bring up the drill through form so the user can choose which
// report they want.
function drill_through_form(form_name)
{
  var forms = document.forms;
  var i = 0;
  var nb = forms.length;
  var newurl = "";

  while ( i < nb ) { 
    var form = forms[i]; 
    if (form.name == form_name) { 
	// found the form, now loop through the drillthru links and add this page as the back link
	var j = 0;
      var nbElements = form.elements.length;
      var drillElement = "";
	while ( j  < nbElements ) { 
         if  (form.elements[j].name.indexOf("goto_drilllink") == 0) 
	   {
		newurl = add_drill_backlink(form.elements[j].value );
            form.elements[j].value = newurl;
         }
	   j++;
	}
      form.submit();
      return;
    }
    i++;
  }
}
